;
;	IN_*.C - ASM C^tF[X
;	for i8086,Turbo-C
;
;	$Header$
;


		INCLUDE	STDDEFS.INC

		.186
		.MODEL	SMALL

		.CODE

		EXTRN	_inet_toipv4addr:Near,_inet_ipv4addrtoipaddr:Near
		EXTRN	_inet_toipaddr:Near,_inet_tostr:Near
		EXTRN	_inet_iswildcard:Near

		PUBLIC	INET_ToIPv4Addr,INET_IPv4AddrToIPAddr
		PUBLIC	INET_ToIPAddr,INET_ToStr
		PUBLIC	INET_IsWildcard
		PUBLIC	_inet_ipv4masktobits


;
;@́FES:DI=addr
;@óFCF=0
;		DX.AX=*ipv4addr
;	 CF=1
;		AL=G[R[h
;		DX,AH=s
;@jFBX,CX,ES
;	char inet_toipv4addr(void FAR *addr, IDWORD FAR *ipv4addr);
INET_ToIPv4Addr	PROC

	SUB	SP,4
	MOV	AX,SP

	PUSH	SS
	PUSH	AX	;ipv4addr
	
	PUSH	ES
	PUSH	DI	;addr

	CALL	_inet_toipv4addr

	ADD	SP,4*2

	POP	BX		;*ipv4addr 
	POP	DX		;*ipv4addr 

	OR	AL,AL
	STC
	_IF Z
		MOV	AX,BX
		CLC
	_ENDIF
	RET

INET_ToIPv4Addr	ENDP


;
;@́FES:DI=ipaddr
;	 DX.BX=ipv4addr
;@óFȂ
;@jFAX,BX,CX,DX,ES
;	IPADDR FAR *inet_ipv4addrtoipaddr(IDWORD ipv4addr, IPADDR FAR *ipaddr);
INET_IPv4AddrToIPAddr	PROC

	PUSH	ES
	PUSH	DI	;ipaddr
	PUSH	DX
	PUSH	BX
	CALL	_inet_ipv4addrtoipaddr
	ADD	SP,4*2
	RET

INET_IPv4AddrToIPAddr	ENDP


;
;@́FDX:SI=addr
;	 ES:DI=ipaddr
;@óFCF=0
;		AL=0
;	 CF=1
;		AL=G[R[h
;@jFAH,BX,CX,DX,ES
;	char inet_toipaddr(void FAR *addr, IPADDR FAR *ipaddr);
INET_ToIPAddr	PROC

	MOV	BX,OFFSET _inet_toipaddr
INET_FARP_FARP_CALL::
	PUSH	ES
	PUSH	DI	;ipaddr
	PUSH	DX
	PUSH	SI	;addr
	CALL	BX
	ADD	SP,4*2

	OR	AL,AL
	STC
	_IF Z
		CLC
	_ENDIF
	RET

INET_ToIPAddr	ENDP

;
;@́FDX:SI=addr
;	 ES:DI=str
;@óFCF=0
;		AL=0
;	 CF=1
;		AL=G[R[h
;@jFAH,BX,CX,DX,ES
;	char inet_tostr(void FAR *addr, IPADDRSTR far *str);
INET_ToStr	PROC
	MOV	BX,OFFSET _inet_tostr
	JMP	INET_FARP_FARP_CALL
INET_ToStr	ENDP

;
;@́FES:DI=addr
;@óFAL
;@jFAH,BX,CX,DX,ES
;	char inet_iswildcard(void FAR *addr);
INET_IsWildcard	PROC
	PUSH	ES
	PUSH	DI	;addr
	CALL	_inet_iswildcard
	ADD	SP,2*2
	RET
INET_IsWildcard	ENDP




;IPv4̃lbg}XNÃrbg𓾂
;	uchar inet_ipv4masktobits(IDWORD addr);
;@́FDWORD [SP+2]
;@óFAL
;@jFAX,BX,CX,DX
_inet_ipv4masktobits	PROC

	MOV	BX,SP
	MOV	AX,[BX+4]
	MOV	DX,[BX+2]
	XCHG	AH,AL
	XCHG	DH,DL

	MOV	CX,32
	_REPEAT
		SHL	AX,1
		RCL	DX,1
		_BREAK NC
	_LOOP

	NEG	CX
	ADD	CL,32
	MOV	AL,CL
	RET

_inet_ipv4masktobits	ENDP


;2000/ 1/23
;2001/ 1/28 _inet_ipv4masktobits

		end
