;
;	`t@Cǂݍ
;	for MS-DOS,80186
;
;	$Header$
;

		INCLUDE	STDDEFS.INC


		.186
		.MODEL	SMALL

LINEBUFLEN	EQU 40
READBUFLEN	EQU 40

SectionType	STRUC
SectionName	DW ?
BRegs		DB ?
BRegOfs		DW ?
WRegs		DB ?
WRegOfs		DW ?
SRegs		DB ?
SRegOfs		DW ?
SectionType	ENDS


		.CODE

		PUBLIC	Config
		PUBLIC	_config
		;EXTN	LOG_PutBinary


;t@CI[v
;@́FDS
;@óFCY= 0..I 1..G[
;	 AX=G[R[h
;@jFAX,DX
FileOpen	PROC

		MOV	DX,WORD PTR ConfigFileName[0]
		MOV	AX,WORD PTR ConfigFileName[2]
		OR	AX,AX
		_IF Z
			MOV	DX,OFFSET DefaultFileName
			MOV	AX,DS
		_ENDIF

		PUSH	DS
		MOV	DS,AX
		MOV	AX,3D00h
		INT	21h
		POP	DS

		_IFN C
			MOV	FileHandle,AX
			CLR	AX
			MOV	ReadBufUsed,AL
			MOV	ReadBufTop,AX
		_ENDIF

		RET

FileOpen	ENDP


;t@CN[Y
;@́FDS
;@jFAX,BX
FileClose	PROC
		MOV	AH,3Eh
		MOV	BX,FileHandle
		INT	21h
		RET
FileClose	ENDP


;Pǂݍ
;@́FDS
;@óFAL= 1Ah..EOF
;@jFAH
ReadChar	PROC

		PUSH	BX
		PUSH	CX
		PUSH	DX

		CMP	ReadBufUsed,0
		_IF E
			MOV	AH,3Fh
			MOV	DX,OFFSET ReadBuf
			MOV	CX,READBUFLEN
			MOV	BX,FileHandle
			INT	21h
			JC	ReadChar_Err

			OR	AX,AX
			JZ	ReadChar_Err
			MOV	ReadBufUsed,AL
			MOV	ReadBufTop,0
		_ENDIF

		MOV	BX,ReadBufTop
		MOV	AL,ReadBuf[BX]
		INC	BX
		MOV	ReadBufTop,BX
		DEC	ReadBufUsed

ReadChar_Exit:
		POP	DX
		POP	CX
		POP	BX
		RET

ReadChar_Err:
		MOV	AL,EOF
		JMP	ReadChar_Exit

ReadChar	ENDP


;Psǂݍ
;@́FDS
;@óFCY=0 I
;@@@@CY=1 t@CGhɒB
;@jFAX,BX
ReadLine	PROC

		CLR	BX

		_REPEAT
			CALL	ReadChar
			CMP	AL,EOF
			JE	#EndLine

			CMP	AL,LF
			_BREAK E
			CMP	AL,CR
			_CONT E

			CMP	BX,LINEBUFLEN-1
			_IF B
				MOV	LineBuf[BX],AL
				INC	BX
			_ENDIF
		_WHILE

		MOV	LineBuf[BX],0
		CLC
		RET

#EndLine:
		MOV	LineBuf[BX],0
		OR	BX,BX
		CLC
		_IF Z
			STC
		_ENDIF
		RET

ReadLine	ENDP


;@́FSI
;	 DS
;@óFSI
;@jFAL
SkipSpace	PROC

		_REPEAT
			LODSB
			CMP	AL,' '
			_CONT E
			CMP	AL,TAB
		_WHILE E

		DEC	SI
		RET

SkipSpace	ENDP


;@́FSI
;	 DS
;@óFSI
;	 AX
;	 CY=0 I
;	 CY=1 񂪈ُ
;@jFBX,CX,DX

AtoI		PROC

		CLD
		CLR	CX
		MOV	BX,10
		LODSB
		CMP	AL,'$'
		_IF E
			MOV	BX,16
			LODSB
		_ENDIF

	      _REPEAT
		OR	AL,AL
		JZ	#Exit

		CMP	AL,'a'
		_IF AE
			SUB	AL,'a'-'A'
		_ENDIF
		CMP	AL,'0'
		JB	#Err
		CMP	AL,'9'
		JBE	#Digit
		CMP	BL,16
		_IF E
			CMP	AL,'A'
			JB	#Err
			CMP	AL,'F'
			JBE	#Digit16
		_ENDIF
		JMP	#Err

#Digit16:
		SUB	AL,'A'-10-'0'
#Digit:
		SUB	AL,'0'

		XCHG	CX,AX
		MUL	BX
		XCHG	CX,AX
		MOV	AH,0
		ADD	CX,AX

		LODSB
	      _WHILE

#Err:
		DEC	SI
		STC
		RET
#Exit:
		DEC	SI
		MOV	AX,CX
		CLC
		RET

AtoI		ENDP


;@́FSI
;	 DS
;@óFSI=g[N̎n܂
;	 BX=g[N̏I̎
;	 CY=0 I 1..g[N
;@jFAL
Token		PROC

		CALL	SkipSpace
		PUSH	SI

		CLD
		LODSB
		OR	AL,AL
		JZ	#NoToken

		_REPEAT
			OR	AL,AL
			_BREAK E
			CMP	AL,' '
			_BREAK E
			CMP	AL,TAB
			_BREAK E
			LODSB
		_WHILE
		MOV	BX,SI
		MOV	BYTE PTR [SI-1],0

		POP	SI
		CLC
		RET

#NoToken:
		POP	SI
		STC
		RET

Token		ENDP


;@́FSI=̐擪
;	 DI=̃Rs[
;	 DS
;@óFSI=̎
;	 DI=Rs[̎
;@jFAL
CopyString	PROC

		PUSH	ES

		MOVSEG	ES,DS
		CLD
		_REPEAT
			LODSB
			OR	AL,AL
			_BREAK E
			CMP	AL,"'"
			_BREAK E
			STOSB
		_WHILE
		MOV	AL,0
		STOSB

		POP	ES

		RET

CopyString	ENDP


;@́FSI
;	 DS
;@jFAL
RemoveComment	PROC

		PUSH	SI
		CLD
		_REPEAT
			LODSB
			OR	AL,AL
			_BREAK E
			CMP	AL,';'
		_WHILE NE

		MOV	BYTE PTR [SI-1],0
		POP	SI
		RET

RemoveComment	ENDP


;@óFAL= 0..I 1..ZNV 2..f[^ 3..ُ
;@jFAH,BX,CX,DX,SI,ES

LineAnalysis	PROC


	      _REPEAT
		INC	LineNum
		CALL	ReadLine
		JC	#NoLine

		MOV	SI,OFFSET LineBuf
		CALL	RemoveComment

		CALL	SkipSpace

		CLD
		LODSB
		OR	AL,AL
	      _WHILE Z

		CMP	AL,'['
		JZ	#Section

		;f[^
		DEC	SI
		CALL	Token
		JC	#Illegal
		PUSH	BX
		CALL	AtoI
		POP	SI
		JC	#Illegal
		MOV	RegNo,AX

		CMP	AX,300
		_IF B
			CALL	Token
			JC	#Illegal
			CALL	AtoI
			JC	#Illegal
			MOV	RegVal,AX
		_ELSE
			;
			CALL	SkipSpace
			LODSB
			CMP	AL,"'"
			JNE	#Illegal
			MOV	DI,StringBufT
			MOV	DX,DI
			CALL	CopyString
			MOV	StringBufT,DI
			MOV	RegVal,DX
		_ENDIF

		MOV	AL,2
		RET

#Section:	;ZNV̊Jn
		CALL	SkipSpace
		MOV	BX,SI
		_REPEAT
			LODSB
			CMP	AL,']'
			_BREAK E
			CMP	AL,' '
			_BREAK E
			CMP	AL,TAB
			_BREAK E
			OR	AL,AL
		_WHILE NZ
		DEC	SI
		MOV	CX,SI
		SUB	CX,BX
		JZ	#Illegal

		;BX=ZNVJnItZbg
		;CX=ZNV

		MOV	DX,Sections
		MOVSEG	ES,DS
		MOV	DI,OFFSET SectionTable
		_REPEAT
			PUSH	CX
			PUSH	DI

			MOV	DI,[DI].SectionName
			MOV	SI,BX
			REPE	CMPSB
			
			POP	DI
			POP	CX

			_BREAK E

			ADD	DI,TYPE SectionType
			DEC	DX
			JZ	#Illegal
		_WHILE

		;DI=ZNV
		MOV	AL,1
		RET

#Illegal:	;ُ
		MOV	AL,3
		RET

#NoLine:
		;
		MOV	AL,0
		RET

LineAnalysis	ENDP


;`t@Cǂݍ
;@óFAX			0..I
;				0FFFFh..t@CI[vłȂ
;				̑..t@CLq~X(AX=sԍ)
_config		LABEL	PROC
Config		PROC

		PUSH	SI
		PUSH	DI

		MOV	Section,OFFSET SectionTable
		MOV	StringBufT,OFFSET StringBuf

		CALL	FileOpen
		_IFN C

			MOV	LineNum,0
			_REPEAT
				CALL	LineAnalysis
				OR	AL,AL
				_BREAK E
				CMP	AL,3
				JE	#Err
				CMP	AL,1
				_IF E
					MOV	Section,DI
				_ELSE

				      IF 0
					MOVSEG	ES,DS
					MOV	DI,OFFSET RegNo
					MOV	CX,4
					CALL	LOG_PutBinary
				      ENDIF

					MOV	DI,Section
					MOV	DX,RegVal
					MOV	AX,RegNo
					MOV	BL,100
					DIV	BL
					XCHG	AH,AL	;AH=0~3,AL=WX^ԍ
					DEC	AH
					JZ	#R100
					DEC	AH
					JZ	#R200
					DEC	AH
					JZ	#R300
					JMP	#Err

#R100:
					CMP	AL,[DI].BRegs
					_IF B
						MOV	BX,[DI].BRegOfs
						MOV	AH,0
						ADD	BX,AX
						MOV	[BX],DL
					_ENDIF
					JMP	#RegEnd
#R200:
					CMP	AL,[DI].WRegs
					_IF B
						MOV	BX,[DI].WRegOfs
						MOV	AH,0
						ADD	BX,AX
						ADD	BX,AX
						MOV	[BX],DX
					_ENDIF
					JMP	#RegEnd
#R300:
					CMP	AL,[DI].SRegs
					_IF B
						MOV	BX,[DI].SRegOfs
						MOV	AH,0
						ADD	BX,AX
						ADD	BX,AX
						MOV	[BX],DX
					_ENDIF
					;JMP	#RegEnd
#RegEnd:

				_ENDIF


			_WHILE

			CALL	FileClose
			CLR	AX
		_ELSE
			;t@CI[vłȂ
			MOV	AX,0FFFFh
		_ENDIF

		POP	DI
		POP	SI
		RET

#Err:
		MOV	AX,LineNum
		POP	DI
		POP	SI
		RET

Config		ENDP


		.DATA?
ReadBufTop	DW ?
ReadBufUsed	DB ?
ReadBuf		DB READBUFLEN DUP (?)
LineBuf		DB LINEBUFLEN DUP (?)

		EVEN
RegNo		DW ?
RegVal		DW ?
FileHandle	DW ?
LineNum		DW ?
Section		DW ?

StringBuf	DW 512 DUP (?)
StringBufT	DW ?


		.DATA

		PUBLIC	ConfigFileName
		EXTRN	DIAL_SReg:WORD,LOG_SReg:WORD
		EXTRN	RS_WReg:WORD,RS_BReg:WORD,RS_SReg:WORD
		EXTRN	DIAL_BReg:BYTE, LOG_BReg:BYTE, PPP_BReg:BYTE
		EXTRN	_ip_breg:BYTE
		EXTRN	_DNS_BReg:BYTE, _DNS_SReg:WORD
		EXTRN	TSR_WReg:WORD,TSR_BReg:BYTE
		EXTRN	TCU_WReg:WORD
		EXTRN	IEP_SReg:WORD

DefaultFileName	DB "PPP.DEF",0
ConfigFileName	DD 0			;ɃAhXw肷
					; DefaultFileNamȇ
					;g

Sections	DW 9
SectionTable	SectionType<SN_RS,   2,RS_BReg,   19,RS_WReg,  11,RS_SReg>
		SectionType<SN_DIAL, 4,DIAL_BReg, 0,0, 10,DIAL_SReg>
		SectionType<SN_LOG,  1,LOG_BReg,  0,0, 1,LOG_SReg>
		SectionType<SN_RSLV, 1,_DNS_BReg, 0,0, 2,_DNS_SReg>
		SectionType<SN_PPP , 1,PPP_BReg , 0,0, 0,0>
		SectionType<SN_IP  , 1,_ip_breg , 0,0, 0,0>
		SectionType<SN_TSR , 5,TSR_BReg,  1,TSR_WReg, 0,0>
		SectionType<SN_TCU , 0,0,         9,TCU_WReg, 0,0>
		SectionType<SN_IEP , 0,0,         0,0, 		4,IEP_Sreg>

SN_RS		DB "RS"
SN_DIAL		DB "DIAL"
SN_LOG		DB "LOG"
SN_RSLV		DB "RESOLVER"
SN_PPP		DB "PPP"
SN_IP		DB "IP"
SN_TSR		DB "TSR"
SN_TCU		DB "TCU"
SN_IEP		DB "IEP"
