;
;	An Ethernet Address Resolution Protocol
;

		OPTION OLDSTRUCTS

		INCLUDE	STDDEFS.INC
		INCLUDE	ETHER.INC
		INCLUDE IF.INC
		INCLUDE IFETHER.INC
		INCLUDE	ETHERPD.INC
;		INCLUDE	ARP.INC
		INCLUDE	INET.INC

		EXTRN	ETHERPD_Send:Near

		EXTRN	ETHERPD_ARP_PutBuf:Near
		EXTRN	ETHERPD_ARP_LeftSpace:Near
		EXTRN	ETHERPD_ARP_Get:Near


		.186
		.MODEL	SMALL



;-------------------------------
;	萔
;-------------------------------


IPV4_ADDRESS_SIZE	EQU 4

ARES_HRD_ETHERNET	EQU 1

ARES_OP_REQUEST		EQU 1
ARES_OP_REPLY		EQU 2

ARP_TABLE_DEFAULT_SIZE	EQU	8	;ARPe[ũGg


;-------------------------------
;	\
;-------------------------------


ARPType		STRUC

HRD		DW ?	;ARES_HRD_ETHERNET	;n[hEFA
PRO		DW ?	;ETHER_TYPE_DOD_INTERNET;vgR
HLN		DB ?	;ETHER_ADDRESS_SIZE	;n[hAhX
PLN		DB ?	;IPV4_ADDRESS_SIZE	;vgRAhX
OPC		DW ?				;Iy[VR[h
SHA		DB ETHER_ADDRESS_SIZE DUP (?)	;M҃n[hAhX
SPA		DB IPV4_ADDRESS_SIZE DUP (?)	;M҃vgRAhX
THA		DB ETHER_ADDRESS_SIZE DUP (?)	;ړInn[hAhX
TPA		DB IPV4_ADDRESS_SIZE DUP (?)	;ړInvgRAhX

ARPType		ENDS

;ARPe[u
ARPTableType	STRUC

AT_Ether	DB ETHER_ADDRESS_SIZE DUP (?)
AT_IP		DB IPV4_ADDRESS_SIZE DUP (?)

ARPTableType	ENDS
				;̍\̓vf̕я
				;AddEntry,ARP_GetEntry̎ɉe


;ARP_GetEntryŎgpobt@
ARPEntryType	STRUC
AE_IP		DB TYPE IPADDR DUP (?)
AE_Ether	DB ETHER_ADDRESS_SIZE DUP (?)
ARPEntryType	ENDS



;-------------------------------
;	}N
;-------------------------------



;16rbg萔lbg[Nɂăɕۑ
MOVCWORD	MACRO	WMEM,WCONST

		MOV	WORD PTR WMEM,((WCONST AND 0FFh) SHL 8) OR (WCONST SHR 8)

		ENDM

;16rbg萔lbg[NɂăeƔr
CMPCWORD	MACRO	WMEM,WCONST

		CMP	WORD PTR WMEM,((WCONST AND 0FFh) SHL 8) OR (WCONST SHR 8)

		ENDM

;16rbg萔lbg[Nɂ̂V{Ɋ蓖
EQUCWORD	MACRO	NAME,WCONST

		NAME	EQU	((WCONST AND 0FFh) SHL 8) OR (WCONST SHR 8)

		ENDM


Print		MACRO	STR

		PUSH	SI
		MOV	SI,OFFSET STR
		CALL	_Print
		POP	SI

		ENDM


;-------------------------------
;	R[hiJj
;-------------------------------


		.CODE

		PUBLIC	ARP_TimerSignal,ARP_Resolve,ARP_Init,ARP_GetEntry
		EXTRN	_tmem_alloc:NEAR,_tmem_free:NEAR


;
;@́FDS
;@óFCF=0.. 1..G[(TMEMs/ETHERPD_ARP_PutBufs)
;@jFAX,BX,CX,DX,ES
;@⑫FtmemgpĂB
;	 MpɃpPbgP̃obt@p
ARP_Init	PROC

		PUSH	(ETHERPD_BUFFER_SIZE + 15) / 16
		CALL	_tmem_alloc
		ADD	SP,2
		MOV	ES,DX
		OR	DX,AX
		STC
		_IFN Z
			MOV	DI,AX
			CALL	ETHERPD_ARP_PutBuf	;o:CF
		_ENDIF
		RET

ARP_Init	ENDP



;^C}[쓮[`
;@́FDS
;@óF
;@jFAX,BX,CX,DX,SI,DI,BP,ES
ARP_TimerSignal	PROC

		CALL	Receive
		RET

ARP_TimerSignal	ENDP


;IPAhX->EthernetAhXϊ
;@́FAL.AH.DL.DH=IPAhX
;	 DS:SI=IF_ETH_PDType ̃AhX
;	 DS
;@óF
;		CF=0
;		DS:SI=EthernetAhX
;	 G[(Ȃ)
;		CF=1
;@jFAX,BX,CX,DX,DI,ES
ARP_Resolve	PROC

		PUSH	BP

		MOV	BX,SI			;SAVE
		CALL	Search
		_IF C
			;;ARPNGXg𑗐M
			;;͑҂Ȃ
			MOV	SI,BX		;RESTORE

			MOV	WORD PTR RequestTemplateARP.TPA[0],AX
			MOV	WORD PTR RequestTemplateARP.TPA[2],DX

			MOV	AX,WORD PTR [SI].IF_Addr[0]
			MOV	WORD PTR RequestTemplateARP.SPA[0],AX
			MOV	AX,WORD PTR [SI].IF_Addr[2]
			MOV	WORD PTR RequestTemplateARP.SPA[2],AX

			MOV	AX,WORD PTR [SI].IF_ETH_Addr[0]
			MOV	WORD PTR RequestTemplateARP.SHA[0],AX
			MOV	AX,WORD PTR [SI].IF_ETH_Addr[2]
			MOV	WORD PTR RequestTemplateARP.SHA[2],AX
			MOV	AX,WORD PTR [SI].IF_ETH_Addr[4]
			MOV	WORD PTR RequestTemplateARP.SHA[4],AX

	IF 0
		;TMEMg
			PUSH	(TYPE EtherHeaderType + TYPE ARPType + 15)/16
			CALL	_tmem_alloc
			ADD	SP,2
			MOV	ES,DX
			OR	DX,AX
			_IFN Z
				;擾ł

				XCHG	DI,AX
				MOV	BX,SI		;SAVE
				MOV	SI,OFFSET RequestTemplate
				MOV	CX,(TYPE EtherHeaderType + TYPE ARPType)/2
				MOV	DX,CX		;SAVE
				CLD
				REP	MOVSW

				MOV	CX,DX		;RESTORE
				MOV	SI,BX		;RESTORE
				MOV	DI,AX

				PUSH	ES
				PUSH	DI

				CALL	ETHERPD_Send	;M

				CALL	_tmem_free
				ADD	SP,2*2
			_ENDIF
	ELSE
		;DATAZOg̃ev[ĝ܂ܑM
				MOV	DI,OFFSET RequestTemplate
				MOVSEG	ES,DS
				CALL	ETHERPD_Send	;M
	ENDIF

			STC
		_ENDIF

		POP	BP
		RET

ARP_Resolve	ENDP


;
;@́FES:DI=buf(ARPEntryInfoType)
;	 CL=n
;	 CH=buf̃oCg
;	 DS
;@óFCF=0 
;		AL=0
;	 CF=1 G[
;		AL=0ȊO
;@jFAX,BX,CX,DX,SI,DI,ES

ARP_GetEntry	PROC

		MOV	AL,-1
		CMP	CL,ARPTableEntries
		CMC	;CF ]
		_IFN C
			;CL<ARPTableEntries

			PUSH	CX
			PUSH	DI
			PUSH	ES

			;ARPEntryWorkɃf[^쐬

			CLR	AX
			MOV	AL,CL
			IMUL	AX,TYPE ARPTableType
			ADD	AX,ARPTable
			MOV	SI,AX		;DS:SI=ARPTable̖ړI̗vf

			MOV	DI,OFFSET ARPEntryWork.AE_Ether
			MOVSEG	ES,DS

			CLD
			;ADD	SI,AT_Ether
			MOVSW			;EtherAhXRs[
			MOVSW
			MOVSW

			LODSW
			MOV	BX,AX
			LODSW
			MOV	DX,AX		;DX.BX=IPAhX

			ADD	DI,AE_IP-(AE_Ether+6)
			CALL	INET_IPv4AddrToIPAddr


			POP	ES
			POP	DI
			POP	CX

			;CHoCgES:DIɃRs[

			MOV	SI,OFFSET ARPEntryWork
			MOV	CL,CH
			MOV	CH,0
			OR	CX,CX
			_IFN Z
				CMP	CX,TYPE ARPEntryType
				_IF A
					MOV	CX,TYPE ARPEntryType
				_ENDIF
				CLD
				REP	MOVSB
			_ENDIF

			MOV	AL,0
			CLC
		_ENDIF

		RET

ARP_GetEntry	ENDP


;-------------------------------
;	R[hij
;-------------------------------

;MpPbgoď
;@́FDS
;@óF
;@jFAX,BX,CX,DX,SI,BP,DI,ES
Receive	PROC


		CALL	ETHERPD_ARP_Get
		_IF C
			RET
		_ENDIF


		;ES:DI=EthernetpPbg
		;CX=̃TCY
		;SI=IF_ETH_PDType

		PUSH	DI

		ADD	DI,TYPE EtherHeaderType
		SUB	CX,TYPE EtherHeaderType
		JBE	@f		;TCYُ
;		JBE	#Exit		;TCYُ

		CMP	CX,TYPE ARPType
		JB	@f		;TCYُ
;		JB	#Exit		;TCYُ

		;ES:DI=ARPpPbg
		;CX=̃TCY

		CMPCWORD ES:[DI].HRD,ARES_HRD_ETHERNET
		JNE	@f		;n[hEFAʂႤ
;		JNE	#Exit		;n[hEFAʂႤ

		CMPCWORD ES:[DI].PRO,ETHER_TYPE_DOD_INTERNET
		JNE	@f		;vgRʂႤ
;		JNE	#Exit		;vgRʂႤ

		;SHA,SPA  ARP e[uɒǉ
		CALL	AddEntry	;AX,BX,CX,DXj

		CMPCWORD ES:[DI].OPC,ARES_OP_REQUEST
		_IF E
			;ARPNGXg̏

			;pPbgMC^tF[XIPAhX
			;pPbg TPA Ƃr
			MOV	AX,WORD PTR [SI].IF_ETH_PD_S.IF_ETH_S.IF_Addr[0]
			MOV	DX,WORD PTR [SI].IF_ETH_PD_S.IF_ETH_S.IF_Addr[2]
					;AL.AH.DL.DH=̲̪IPAhX

			CMP	WORD PTR ES:[DI].TPA[0],AX
			JNE	@f
;			JNE	#Exit
			CMP	WORD PTR ES:[DI].TPA[2],DX
			JNE	@f
;			JNE	#Exit

			;Ȃ̂ŁAԓ

			MOVCWORD ES:[DI].OPC,ARES_OP_REPLY
			
			;SHA,SPA  THA,TPA ɃRs[
			PUSH	SI
			PUSH	DS
			MOV	BX,AX	;BL.BH.DL.DH=̲̪IPAhX
			MOV	BP,DI	;ES:BP=ARPpPbg

			CLD
			MOV	AX,ES
			MOV	DS,AX
			MOV	SI,DI
			ADD	SI,SHA
			ADD	DI,THA
			MOV	CX,(THA-SHA)/2
			REP	MOVSW

			;ĐAhXEthernetwb_ɃRs[
			MOV	SI,BP
			ADD	SI,THA
			MOV	DI,BP
			ADD	DI, 0 - TYPE EtherHeaderType + EH_DestAddr
			MOV	CX,ETHER_ADDRESS_SIZE /2
			REP	MOVSW

			MOV	DI,BP
			POP	DS
			POP	SI

			;BL.BH.DL.DH  IPAhX
			MOV	WORD PTR ES:[DI].SPA[0],BX
			MOV	WORD PTR ES:[DI].SPA[2],DX

			; Ethernet AhX SHA ɃRs[
			MOV	BX,SI	;PUSH SI
			ADD	SI,IF_ETH_PD_S.IF_ETH_Addr
			ADD	DI,SHA
			MOV	CX,ETHER_ADDRESS_SIZE/2
			REP	MOVSW
			MOV	SI,BX	;POP SI

			MOV	DI,BP
			SUB	DI,TYPE EtherHeaderType
			MOV	CX,TYPE EtherHeaderType + TYPE ARPType
			CALL	ETHERPD_Send

		_ELSE
		_ENDIF

@@:
;#Exit:
		POP	DI

		;Vobt@^
		SUB	DI,TYPE PacketInfoType
		CALL	ETHERPD_ARP_PutBuf

		RET

Receive	ENDP


;ARPe[uɃGgǉ
;@́FES:DI=ARPpPbg
;	 DS
;@óF
;@jFAX,BX,CX,DX
;@⑫FARPpPbg̃\[XEthernet/IPAhXe[uɒǉ
AddEntry	PROC

		;Print	M4

		PUSH	SI

		MOV	AX,WORD PTR ES:[DI].SPA[0]
		MOV	DX,WORD PTR ES:[DI].SPA[2]
		CALL	Search
		MOV	BX,SI
		;STC
		_IF C
			;܂o^ĂȂ

			MOV	AL,ARPTableEntries
			CMP	AL,ARPTableSize
			_IF B
				;e[u͂܂܂ĂȂ
				MOV	BL,AL
				INC	AL
				MOV	ARPTableEntries,AL
			_ELSE
				MOV	AL,ARPNextEntry
				MOV	BL,AL
				INC	AL
				CMP	AL,ARPTableSize
				_IF AE
					MOV	AL,0
				_ENDIF
				MOV	ARPNextEntry,AL
			_ENDIF
	
			MOV	BH,0
			IMUL	BX,TYPE ARPTableType
			ADD	BX,ARPTable
		_ENDIF

		;DS:BX=e[ȕꏊ
		MOV	SI,DI
		ADD	SI,SHA
		XCHG	DI,BX
		MOV	DX,DS
		MOV	AX,ES
		MOV	DS,AX
		MOV	ES,DX
		MOV	CX,(IPV4_ADDRESS_SIZE + ETHER_ADDRESS_SIZE) / 2
		CLD
		REP	MOVSW
		MOV	DI,BX
		MOV	ES,AX
		MOV	DS,DX
@@:
;#Exit:
		POP	SI
		RET

AddEntry	ENDP


;ARPe[u
;@́FAL.AH.DL.DH=IPAhX
;	 DS
;@óF
;		CF=0
;		DS:SI=ARPe[uGgAhX
;	 G[(Ȃ)
;		CF=1
;@jFCX,SI

Search		PROC

		;Print	M5

		MOV	CL,ARPTableEntries
		INC	CL
		MOV	SI,ARPTable
		SUB	SI,TYPE ARPTableType
		_REPEAT
			ADD	SI,TYPE ARPTableType
			DEC	CL
			_BREAK Z

			CMP	WORD PTR [SI].AT_IP[0],AX
			_CONT NE
			CMP	WORD PTR [SI].AT_IP[2],DX
			_CONT NE

			CLC
			RET
		_WHILE

		STC
		RET

Search		ENDP


IF 0
;\
;@́FDS:SI=̃AhX
;@jFAX,BX,CX,DX
_Print	PROC

		PUSHM	AX,BX,CX,DX
		PUSH	DI
		PUSH	ES
		PUSHF

		MOVSEG	ES,DS
		MOV	DI,SI
		MOV	AL,0
		MOV	CX,1000h
		CLD
		REPNZ	SCASB
		NEG	CX
		ADD	CX,1000h-1
		MOV	DX,SI
		MOV	BX,2			;WG[o
		MOV	AH,40h
		INT	21h
	
		POPF
		POP	ES
		POP	DI
		POPM	DX,CX,BX,AX
	RET

_Print	ENDP
ENDIF


;-------------------------------
;	f[^
;-------------------------------


		.DATA

		;PUBLIC ARPTable

ARPTable	DW OFFSET _ARPTable
ARPTableSize	DB ARP_TABLE_DEFAULT_SIZE
ARPTableEntries	DB 0
ARPNextEntry	DB 0				;ADDEntryŎɏރGg
						;(ARPTableEntries=ARPTableSize
						; ̂Ƃ)

EQUCWORD I_ETHER_TYPE_ADDRESS_RESOLUTION, ETHER_TYPE_ADDRESS_RESOLUTION
EQUCWORD I_ARES_HRD_ETHERNET, ARES_HRD_ETHERNET
EQUCWORD I_ETHER_TYPE_DOD_INTERNET, ETHER_TYPE_DOD_INTERNET
EQUCWORD I_ARES_OP_REQUEST, ARES_OP_REQUEST

		EVEN

						;ARPNGXg̃ev[g
RequestTemplate	LABEL BYTE
RequestTemplateEther LABEL BYTE			;EtherHeaderType <>
		DB 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
		DB 6 DUP (?)
		DW I_ETHER_TYPE_ADDRESS_RESOLUTION
RequestTemplateARP ARPType <I_ARES_HRD_ETHERNET,I_ETHER_TYPE_DOD_INTERNET,ETHER_ADDRESS_SIZE,IPV4_ADDRESS_SIZE,I_ARES_OP_REQUEST>



		.DATA?

ARPEntryWork	ARPEntryType <>
_ARPTable	ARPTableType ARP_TABLE_DEFAULT_SIZE DUP (<>)



;2000/ 6/27 
;2000/ 6/29 
;2000/ 7/ 5 ARP_Resolve
;2000/ 9/ 1 Receive CBARP_ResolveC
;2001/ 1/14 ARP_GetEntry 肩
;2001/ 1/16 ARP_GetEntry
;2001/ 1/28 ARP_TABLE_DEFAULT_SIZE 28֕ύX

		end
