/*
    PIT Count to time.


    LSI C-86 : lcc -O -m -DPC98 -o caltime.exe pittime.c
    Turbo C  : tcc -M -mt -O -DPC98 -ecaltime.com pittime.c

 */

#include <stdio.h>
#include <dos.h>

int main()
{
	long int pit_cntd;
	unsigned short int h, m, s, t;

#ifdef PC98
	pit_cntd = *(long int far *)0x04f1L;
	h = pit_cntd / 32 / 3600;
	t = pit_cntd / 32 % 3600;
#else
	pit_cntd = *(long int far *)0x046cL;
	h = pit_cntd * 55 / 1000 / 3600;
	t = pit_cntd * 55 / 1000 % 3600;
#endif

	m = t / 60;
	s = t % 60;
    printf("PIT Time : %02hd:%02hd:%02hd  (%ld count)\r\n", h, m, s, pit_cntd);

	return (0);
}
