;
;	^C}[(MC 146818) Configuration Register
;	for PC/AT
;
;	$Header: RTCREG.ASv  1.0  2008/04/19 11:11:32  Exp $
;

		INCLUDE	CONFIG.INC
		INCLUDE	RTC.INC

		.186
		.MODEL	SMALL

		.DATA



;--------[CONFIG]
		PUBLIC	RTC_WReg,MasICU0,MasICU1,SlvICU0,SlvICU1
		PUBLIC	TimerRSlct,TimerDPort,TimerRate
		PUBLIC	RtcIR,RtcINT,IOWaitTime,RtcUnitLevel
		PUBLIC	TCU_Section

TCU_Section	SectionType <SectName,0,RegInfo>
SectName	DB "TCU",0
RegInfo		RegisterInfoType <1,RTC_BReg, 9,RTC_WReg, 0,0, 0,0, 0>


RTC_BReg	LABEL	BYTE
RtcUnitLevel	DB 1		;݊Ԋu 0..10,1..1(msec);100

RTC_WReg	LABEL	BYTE

MasICU0	DW 0020h	;ICU }X^[ |[gO	;200
MasICU1	DW 0021h	;ICU }X^[ |[gP	;201
SlvICU0	DW 00A0h	;ICU X[u |[gO	;202
SlvICU1	DW 00A1h	;ICU X[u |[gP	;203

TimerRSlct	DW 0070h	;RTC Register select	;204
TimerDPort	DW 0071h	;RTC Data port		;205

TimerRate	DW 0110b	;^C}[ periodic interrupt rate ;206
				; 0110b  :  0.9765625 ms

RtcIR		DB 8		;RTC 荞݃x	;207
RtcINT		DB 70h		;RTC 荞		;207
IOWaitTime	DW 0		;I/O҂		;208

;--------[END OF CONFIG]

		end

