/*
 *  Copyright (C) 1997 XMaZ Project.
 *
 *  isoternet Protocol Library / uDP Module / udp datagram
 *
 */

#ifndef _UDP_H_
#define _UDP_H_

#include <types.h>

/* udp message header */

typedef struct {
	/* udp pseudo header */
	BYTE	pseudo_zero;	/* ip_ttl */
	BYTE	ip_proto;
	WORD	pseudo_len;		/* ip_cksum */
	DWRD	ip_src;
	DWRD	ip_dst;
	/* my own header */
	WORD	udp_sport;
	WORD	udp_dport;
	WORD	udp_msglen;
	WORD	udp_cksum;
} UDP;

#define UDPHLEN			8
#define PSEUDOHLEN		12
#define PROTO_UDP		17

#endif /* _UDP_H_ */
