/*
 * Copyright (c) 1997  XMaZ Project.
 *
 *  isoternet Protocol Library / iPv4 Module / raw packet buffer
 *
 *  $Id$
 */

#include <ttypes.h>

#define BUFSIZE 10

char top = 0, bot = 0, data = 0;
void FAR *buf[BUFSIZE];

void raw_enqueue(void FAR *p)
{
	 if (data < BUFSIZE){
		 data++;
		 buf[bot++] = p;
		 bot %= BUFSIZE; 
	 }
	 return;
}

void FAR *raw_dequeue() 
{
	void FAR *p = 0;

	if (data > 0) {
		data--;
		p = buf[top++];
		top %= BUFSIZE; 
	}
	return p;
}
