;
;	LOG.ASM - C C^tF[X
;	for i8086,Turbo-C
;
;	$Header$
;


		.186
		.MODEL	SMALL

		INCLUDE	STDDEFS.INC




		.CODE

		EXTRN	LOG_Init:Near,LOG_Put:Near,LOG_PutBinary:Near,LOG_PutMulti:Near
		EXTRN	LOG_Flush:Near,LOG_PutChar:Near,LOG_Switch:Near
		EXTRN	_tmem_alloc:Near,_tmem_free:Near
		EXTRN	VSPrintF:Near

		PUBLIC	_log_init,_log_put,_log_putbinary,_log_putchar
		PUBLIC	_log_flush,_log_switch
		PUBLIC	_log_printf



;void log_init(void);
;@́F
;@óF
;@jF
_log_init	PROC
		JMP	LOG_Init
_log_init	ENDP

;void log_put(char *str);
;@́F
;@óF
;@jF
_log_put	PROC
		MOV	BX,SP
		PUSH	SI
		MOV	SI,[BX+2]
		CALL	LOG_Put
		POP	SI
		RET
_log_put	ENDP

;void log_putchar(char c);
;@́F
;@óF
;@jF
_log_putchar	PROC
		MOV	BX,SP
		MOV	AL,[BX+2]
		JMP	LOG_PutChar
_log_putchar	ENDP


;void log_putbinary(void far *data, uint len);
;@́F
;@óF
;@jF
_log_putbinary	PROC
		MOV	BX,SP
		PUSH	DI
		LES	DI,[BX+2]
		MOV	CX,[BX+6]
		CALL	LOG_PutBinary
		POP	DI
		RET
_log_putbinary	ENDP


;void log_flush(void);
;@́F
;@óF
;@jF
_log_flush	PROC
		JMP	LOG_Flush
_log_flush	ENDP


;void log_switch(int sw);
;@́F
;@óF
;@jF
_log_switch	PROC

		MOV	BX,SP
		MOV	AL,[BX+2]
		JMP	LOG_Switch

_log_switch	ENDP



IF 0
;====== Oŏo͂ꍇ ====================================================

IF 0
--------
;void log_printf(char *form,...);
;  ӁFo͂95zĂ͂Ȃ
PRINTFBUFLEN	EQU 96

_log_printf	PROC

		;CMP	CS:LogMode,0
		;JE	#Exit

		PUSH	PRINTFBUFLEN SHR 4
		CALL	_tmem_alloc
		ADD	SP,2

		OR	DX,DX
		JZ	#Exit

		MOV	BX,SP

		PUSH	SI
		PUSH	DI
		;PUSHF
		;CLI

		PUSH	AX
		PUSH	DX

		MOV	ES,DX
		MOV	DI,AX
		MOV	SI,OFFSET PrintfBuf
		MOV	CX,PRINTFBUFLEN/2
		CLD
		REP	MOVSW

		LEA	AX,[BX+4]
		MOV	SI,[BX+2]
		MOV	DI,OFFSET PrintfBuf
		MOV	BX,AX
		MOVSEG	ES,DS
		CALL	VSPrintF

		MOV	SI,OFFSET PrintfBuf
		CALL	LOG_Put

		MOV	AX,DS
		MOV	ES,AX
		MOV	DI,OFFSET PrintfBuf

		POP	DS
		POP	SI

		PUSH	DS
		PUSH	SI

		MOV	CX,PRINTFBUFLEN/2
		CLD
		REP	MOVSW

		MOV	AX,ES
		MOV	DS,AX
		CALL	_tmem_free
		ADD	SP,4

		;POPF
		POP	DI
		POP	SI
#Exit:
		RET

_log_printf	ENDP
--------
ELSE

;void log_printf(char *form,...);
;  ӁFo͂95zĂ͂Ȃ
PRINTFBUFLEN	EQU 96

_log_printf	PROC
		NOP			;for LOG_Enable/Disable

		;CMP	CS:LogMode,0
		;JE	#Exit

		PUSH	(PRINTFBUFLEN+15) SHR 4
		CALL	_tmem_alloc
		ADD	SP,2

		OR	DX,DX
		JZ	#Exit

		MOV	BX,SP

		PUSH	SI
		PUSH	DI

		;PUSHF
		;CLI

		PUSH	DX
		PUSH	AX

		MOV	DI,AX
		MOV	ES,DX
		MOV	SI,[BX+2]
		LEA	BX,[BX+4]
		CALL	VSPrintF

		PUSH	DS
		MOV	BX,SP
		LDS	SI,[BX+2]
		CALL	LOG_Put
		POP	DS

		CALL	_tmem_free
		ADD	SP,4

		;POPF
		POP	DI
		POP	SI
#Exit:
		RET

_log_printf	ENDP

ENDIF


ELSE
;====== TLOG gꍇ =======================================================

		INCLUDE	TLOG.INC

;void log_printf(char *form,...);

_log_printf	PROC
		NOP			;for LOG_Enable/Disable

		PUSH	BP

		MOV	BP,SP
		MOV	AX,BP
		ADD	AX,6

		$TLOG	6,<[BP+4],DS,AX,SS>

		POP	BP
		RET

_log_printf	ENDP

ENDIF



;1997/10/ 1
;1997/11/ 9 log_printf Ń擾Ɏsꍇ̏
;1997/12/ 2 
;1997/12/ 5 VSPrintF 𒼐ڎgp

;1998/10/ 4 TLOG pɕύX

		end
