

		INCLUDE	STDDEFS.INC
		INCLUDE	DISCNCT.INC


		.186
		.MODEL	SMALL

CMPBUFLEN	EQU 80

		.CODE

		PUBLIC	DIAL_Open,DIAL_Close,DIAL_Receive
		EXTN	LOG_Put,LOG_PutChar
		EXTN	RS_CheckCD,RS_OffDTR,RS_OnDTR,RS_SendStr,RS_Get
		EXTN	RS_Open,RS_Close,RS_SetReceiver
		EXTN	TIMER_Set,TIMER_Remove
		;EXTN	DisconnectedSignal
		;EXTN	LCP_DownSignal,LCP_UpSignal
		EXTN	LM_PhysicalDown,LM_PhysicalFinished,LM_PhysicalUp
		EXTN	_strlen


ClearCmpBuf	MACRO
		MOV	CmpBufUse,0
		;PUSH	SI
		;MOV	SI,OFFSET M_ClearCmpBuf
		;CALL	LOG_Put
		;POP	SI
		ENDM


;@́FDS
;@jFAX,BX,CX,DX,ES
DIAL_Open	PROC

		CALL	DialConfig

		CALL	RS_Open
		CALL	RS_OnDTR

		MOVSEG	ES,DS
		ClearCmpBuf
		MOV	State,DC_WORKING
		MOV	CheckStrings,0


		;CDM
		MOV	CDChecking,OFF
		CALL	RS_CheckCD
		MOV	AL,NoDialing
		_IF Z
			;CDON(=0)łB
			OR	AL,1	;_CȂ
		_ENDIF

		TEST	AL,1
		_IF Z
			;_C
			MOV	AL,0
			CALL	RS_SetReceiver
			MOV	CDChecking,ON
			CALL	DialInit1
		_ELSE
			;_CȂ
			TEST	AL,2
			_IF Z
				;菇F؂
				MOV	AL,0
				CALL	RS_SetReceiver
				CALL	StartLogin
			_ELSE
				;菇F؂Ȃ
				CALL	Connect
			_ENDIF

		_ENDIF
		RET

IF 0
----------------
		MOV	AL,NoDialing
		DEC	AL
		JZ	#NoDialing	;NoDialing=1
		DEC	AL
		JZ	#NoLogin	;NoDialing=2

		;CDM
		;CALL	RS_CheckCD
		_IF Z
			;CDON(=0)łB
#NoDialing:
			;Login

			MOV	AL,0
			CALL	RS_SetReceiver

			MOV	CDChecking,OFF
			CALL	Login
IF 0
			_REPEAT
				;CALL	DIAL_Receive
				MOV	AL,State
				CMP	AL,DC_WORKING
			_WHILE E
			CMP	AL,DC_CONNECTED
			JNE	#LoginFail
ENDIF
#NoLogin:
			MOV	CDChecking,OFF
			;MOV	TimerHandler,-1
		      IFNDEF NOLOG
			PUSH	SI
			MOV	SI,OFFSET M_IgnoreCD
			CALL	LOG_Put
			POP	SI
		      ENDIF

			CMP	NoDialing,2
			_IF E
				CALL	Connect
			_ENDIF

IF 0
			MOV	AL,1
			CALL	RS_SetReceiver
			CALL	LCP_UpSignal
ENDIF

		_ELSE

			;CDOFF łB->ڑ
			MOV	AL,0
			CALL	RS_SetReceiver
			MOV	CDChecking,ON

IF 0
			MOV	DI,P_AT_Dial
			CALL	RS_SendStr
			MOV	DI,P_AT_TelNum
			CALL	RS_SendStr
			MOV	DI,OFFSET AT_CR
			CALL	RS_SendStr


			MOV	BX,OFFSET C_DialResult
			CALL	SetCheckStrings
ELSE
			CALL	DialInit1
			;CALL	DialStart
ENDIF


IF 0
			_REPEAT
				;CALL	DIAL_Receive
				MOV	AL,State
				CMP	AL,DC_WORKING
			_WHILE E
			CMP	AL,DC_CONNECTED
			JNE	#LoginFail
ENDIF

IF 0
			;OC
			MOV	CX,200
			MOV	BX,OFFSET CheckCD
			CALL	TIMER_Set
			MOV	TimerHandler,AL
			MOV	AL,1
			CALL	RS_SetReceiver
			CALL	LCP_UpSignal
ENDIF

		_ENDIF


		RET
----------------
ENDIF

IF 0
#LoginFail:
		;OCs
		CALL	Disconnect
		RET
ENDIF

DIAL_Open	ENDP


;@́FDS
;@jFAX,BX,CX,DX
DIAL_Close	PROC
		;CALL	RS_OffDTR
		CALL	RS_Close
		MOV	AL,DC_DISCONNECTED
		CALL	Disconnect
		RET
DIAL_Close	ENDP



;OCr̐ݒ
;@́FDS
;@óF
;@jFAX,BX,CX,DX,ES
DialConfig	PROC

		PUSH	SI

		;OCvvg
		CLR	AX
		XCHG	AX,P_CSz_Login
		MOV	SI,OFFSET C_Login_Login
		CALL	DialConfig_SetString

		;pX[hvvg
		CLR	AX
		XCHG	AX,P_CSz_Password
		MOV	SI,OFFSET C_Login_Password
		CALL	DialConfig_SetString

		;OCs\
		CLR	AX
		XCHG	AX,P_CSz_Invalid
		MOV	SI,OFFSET C_Login_Invalid
		CALL	DialConfig_SetString

		;OC\
		CLR	AX
		XCHG	AX,P_CSz_Begin
		MOV	SI,OFFSET C_Login_Begin
		CALL	DialConfig_SetString

		POP	SI

IF 0
		;OCvvg
		MOV	AX,P_CSz_Login
		OR	AX,AX
		_IFN Z
			PUSH	AX
			CALL	_strlen
			ADD	SP,2
			
			OR	AX,AX
			_IFN Z
				MOV	BX,P_CSz_Login
				DEC	AX
				MOV	[BX],AL
				MOV	C_Login_Login,BX
			_ENDIF
			
			MOV	P_CSz_Login,0
		_ENDIF


		;pX[hvvg
		MOV	AX,P_CSz_Password
		OR	AX,AX
		_IFN Z
			PUSH	AX
			CALL	_strlen
			ADD	SP,2
			
			OR	AX,AX
			_IFN Z
				MOV	BX,P_CSz_Password
				DEC	AX
				MOV	[BX],AL
				MOV	C_Login_Password,BX
			_ENDIF
			
			MOV	P_CSz_Password,0
		_ENDIF
ENDIF
		RET

DialConfig	ENDP

;  ́FAX=[Uw肵̃AhX ܂ 0
;	 SI=ur̃AhXv܂AhX
;  jFAX,BX,CX,ES
DialConfig_SetString	PROC

		;MOV	AX,P_CSz_Login
		OR	AX,AX
		_IFN Z
			PUSH	AX

			PUSH	AX
			CALL	_strlen
			ADD	SP,2

			POP	BX
			CMP	AX,1
			_IF G
				;MOV	BX,P_CSz_Login
				DEC	AX
				MOV	[BX],AL
				;MOV	C_Login_Login,BX
				MOV	[SI],BX
			_ENDIF
			
			;MOV	P_CSz_Login,0
		_ENDIF

		RET
DialConfig_SetString	ENDP



;@́FAL=ؒfv
;@@@@DS
;@jFAX,BX,CX,DX
;@ӁFē̉\(DIAL_Close,^C}ɂCDĎARSM)
;	 ē̉eɂĂ͂܂ĂȂ
Disconnect	PROC

		PUSH	AX
		CALL	RemoveTimer
		POP	AX

		MOV	CheckStrings,0
IF 1
		CALL	LM_PhysicalDown
		CALL	LM_PhysicalFinished
ELSE
		XCHG	State,AL
		PUSH	AX
		CMP	AL,DC_CONNECTED
		_IFN E
			;OC
		_ELSE
			;ڑ
			CALL	LCP_DownSignal
		_ENDIF
		POP	AX

		;CMP	AL,DC_DISCONNECTED
		;_IF B
			;;ؒfԂؒfԂ֕ω
			MOV	AL,State
			PUSH	ES
			CALL	DisconnectedSignal
					;́FDS,AL
					;jFAX,BX,CX,DX,ES
			POP	ES
		;_ENDIF
ENDIF
		RET

Disconnect	ENDP



;@́FDS
;@jFAX,BX,CX,DX
CheckCD		PROC
		CALL	RS_CheckCD
		_IFN Z
			;CDOFF(1) łB->ؒf
			MOV	AL,DC_NOCARRIER
			CALL	Disconnect
		_ENDIF
		RET

CheckCD		ENDP


;CDĎ^C}/OC^C}폜
RemoveTimer	PROC

		PUSHF
		CLI
		MOV	AL,-1
		XCHG	AL,TimerHandler
		CALL	TIMER_Remove
		POPF
		RET
RemoveTimer	ENDP










SetCheckStrings	PROC

		MOV	CheckStrings,BX
		MOV	CX,[BX][2]
		MOV	BX,OFFSET CheckTimeOut
		CALL	TIMER_Set
		MOV	TimerHandler,AL
		RET

SetCheckStrings	ENDP


SetDialWait	PROC

		MOV	AfterDialWait,BX
		MOV	BX,OFFSET C_DialWait
		CALL	SetCheckStrings
		RET

SetDialWait	ENDP


CheckTimeOut	PROC

		CALL	RemoveTimer
		MOV	BX,CheckStrings
		CALL	WORD PTR [BX][4]
		RET

CheckTimeOut	ENDP



;RSM̒ʒm(ʂĂ΂)
;@́FDS
;@jFAX,BX,CX,DX,SI,DI,BP,ES
;@ӁF荞݋ԂŌĂ΂Bē͋NȂB

DIAL_Receive	PROC

		;MOV	Receiving,ON
#Top:
		CALL	RS_Get
		JC	#NoData

		CALL	LOG_PutChar

		;Mǉ
		;@́FAL=M

		CMP	AL,CR
		JZ	#ll2
		CMP	AL,LF
		JNE	#ll3
#ll2:
		ClearCmpBuf
		JMP	#Top

#ll3:
		MOV	BL,CmpBufUse
		CMP	BL,CMPBUFLEN
		_IF AE
			ClearCmpBuf
			MOV	BL,0
		_ENDIF

		MOV	BH,0
		MOV	CmpBuf[BX],AL
		INC	BL
		MOV	CmpBufUse,BL

		;WƔr

		MOVSEG	ES,DS
		MOV	BX,CheckStrings
		OR	BX,BX
		JZ	#Top

		MOV	CX,[BX]
		JCXZ	#Top
		ADD	BX,6

		MOV	AL,CmpBufUse
		OR	AL,AL
		_IFN Z
		    CLD
		    _REPEAT	;CX

			MOV	DI,[BX]
			MOV	AH,[DI]
			INC	DI
			MOV	DL,AL
			SUB	DL,AH
			_IF AE
				;r\Ȓ
				MOV	SI,OFFSET CmpBuf
				MOV	DH,0
				ADD	SI,DX
				XCHG	AH,CL
				REPZ	CMPSB
				MOV	CL,AH

				_IF Z
					;v
					MOV	DX,[BX][2]	;Wv
					CALL	RemoveTimer
					PUSH	DS
					CALL	DX
					POP	DS
					CMP	State,DC_WORKING
					JNE	#NoData		;ڑ
								;܂͐ؒf
					JMP	#Top
				_ENDIF	
			_ENDIF

			ADD	BX,4
		    _LOOP
		_ENDIF

		JMP	#Top

#NoData:
		;MOV	Receiving,OFF
		RET


DIAL_Receive	ENDP




DialFail	PROC

LoginFail_Out:
DialFail_Out:
		MOV	AL,DC_TIMEOUT
		JMP	#Exit
LoginFail_Invalid:
		MOV	AL,DC_INVALIDLOGIN
		JMP	#Exit
DialFail_Busy:
		MOV	AL,DC_BUSY
		JMP	#Exit
DialFail_Carrier:
		MOV	AL,DC_NOCARRIER
		JMP	#Exit
DialFail_Error:
		MOV	AL,DC_ATERROR
		JMP	#Exit
DialFail_Answer:
		MOV	AL,DC_NOANSWER
		JMP	#Exit
DialFail_Tone:
		MOV	AL,DC_NODIALTONE
		;JMP	#Exit
#Exit:
		;MOV	State,AL
		CALL	Disconnect
		RET
DialFail	ENDP


Connect		PROC

		;OC
		MOV	State,DC_CONNECTED

		CMP	CDChecking,ON
		_IF E
			;CDĎ^C}N
			MOV	CX,200
			MOV	BX,OFFSET CheckCD
			CALL	TIMER_Set
			MOV	TimerHandler,AL

		_ENDIF

		;RSؑ
		MOV	AL,1
		CALL	RS_SetReceiver
		;ʑwɒʒm
		;CALL	LCP_UpSignal
		CALL	LM_PhysicalUp

		RET
Connect		ENDP





DialInit1	PROC

		MOVSEG	ES,DS
		MOV	DI,OFFSET AT_AT
		CALL	RS_SendStr

		MOV	BX,OFFSET C_DialInit1
		CALL	SetCheckStrings
		RET

DialInit1	ENDP

DialInit1Retry	PROC

		MOVSEG	ES,DS
		MOV	DI,OFFSET AT_AT
		CALL	RS_SendStr

		MOV	BX,OFFSET C_DialInit1Retry
		CALL	SetCheckStrings
		RET

DialInit1Retry	ENDP


DialInit2	PROC

		MOV	BX,OFFSET DialInit2_
		CALL	SetDialWait
		RET

DialInit2	ENDP

DialInit2_	PROC

		MOVSEG	ES,DS
		MOV	DI,P_AT_INIT2
		CALL	RS_SendStr
		MOV	DI,OFFSET AT_CR
		CALL	RS_SendStr

		MOV	BX,OFFSET C_DialInit2
		CALL	SetCheckStrings
		RET

DialInit2_	ENDP

DialStart	PROC

		MOV	BX,OFFSET DialStart_
		CALL	SetDialWait
		RET

DialStart	ENDP

DialStart_	PROC

		MOVSEG	ES,DS
		MOV	DI,P_AT_Dial
		CALL	RS_SendStr
		MOV	DI,P_AT_TelNum
		CALL	RS_SendStr
		MOV	DI,OFFSET AT_CR
		CALL	RS_SendStr

		MOV	BX,OFFSET C_DialResult
		CALL	SetCheckStrings
		RET
DialStart_	ENDP





StartLogin	PROC

		TEST	NoDialing,2
		_IFN Z
			;菇F؂Ȃ
			MOV	BX,OFFSET Connect
			CALL	SetDialWait
			RET
		_ENDIF

		TEST	PlainAuthOption,1
		_IFN Z
			;OCvvg҂ɃOC𑗐M
			MOV	BX,OFFSET PutLoginName
			CALL	SetDialWait
			RET
		_ENDIF

		JMP	Login

StartLogin	ENDP


Login		PROC

		MOV	BX,OFFSET C_Login
		CALL	SetCheckStrings
		RET

Login		ENDP





PutLoginName	PROC
		MOVSEG	ES,DS
		MOV	DI,P_LoginName
		CALL	RS_SendStr
		MOV	DI,OFFSET AT_CR
		CALL	RS_SendStr
		JMP	Login
PutLoginName	ENDP

PutLoginPassword	PROC
		MOVSEG	ES,DS
		MOV	DI,P_LoginPassword
		CALL	RS_SendStr
		MOV	DI,OFFSET AT_CR
		CALL	RS_SendStr
		JMP	Login
PutLoginPassword	ENDP




		.DATA

M_IgnoreCD	DB "RS  : CDM",0
;M_ClearCmpBuf	DB CR,LF,"RS  : CmpBuf",0


AT_Null		DB 0
;AT_CR		DB CR,0
AT_CR		DB CR,LF,0
AT_AT		DB "AT",CR,LF,0
AT_ATZ		DB "ATZ",0

C_DialWait	LABEL	WORD
		DW 0			;r
		DW 40			;^CAEg(10msecP)
AfterDialWait	DW ?			;^CAEǧĂяo

C_DialInit1	LABEL	WORD
		DW 2			;r
		DW 300			;^CAEg(10msecP)
		DW DialInit1Retry	;^CAEǧĂяo
		DW CS_OK		;r
		DW DialInit2		;ṽWv
		DW CS_ERROR		;r
		DW DialInit1Retry	;ṽWv

C_DialInit1Retry LABEL	WORD
		DW 2			;r
		DW 300			;^CAEg(10msecP)
		DW DialFail_Out		;^CAEǧĂяo
		DW CS_OK		;r
		DW DialInit2		;ṽWv
		DW CS_ERROR		;r
		DW DialFail_Error	;ṽWv

C_DialInit2	LABEL	WORD
		DW 2			;r
		DW 300			;^CAEg(10msecP)
		DW DialFail_Out		;^CAEǧĂяo
		DW CS_OK		;r
		DW DialStart		;ṽWv
		DW CS_ERROR		;r
		DW DialFail_Error	;ṽWv

C_DialResult	LABEL	WORD
		DW 7			;r
		DW 5000			;^CAEg(10msecP)
		DW DialFail_Out		;^CAEǧĂяo
		DW CS_BUSY		;r
		DW DialFail_Busy	;ṽWv
		DW CS_CONNECT		;r
		DW StartLogin		;ṽWv
		DW CS_ERROR		;r
		DW DialFail_Error	;ṽWv
		DW CS_NOCARRIER		;r
		DW DialFail_Carrier	;ṽWv
		DW CS_DELAYED		;r
		DW DialFail_Carrier	;ṽWv
		DW CS_NODIALTONE
		DW DialFail_Tone
		DW CS_NOANSWER
		DW DialFail_Answer

C_Login		LABEL	WORD
		DW 6
		DW 3000
		DW LoginFail_Out
C_Login_Login	DW CS_LOGIN
		DW PutLoginName
C_Login_Password DW CS_PASSWORD
		DW PutLoginPassword
C_Login_Invalid	DW CS_INVALID
		DW LoginFail_Invalid
		DW CS_BEGIN
		DW Connect
		DW CS_BEGIN2
		DW Connect
C_Login_Begin	DW CS_BEGIN3
		DW Connect

CS_OK		DB 2,"OK"
CS_BUSY		DB 4,"BUSY"
CS_CONNECT	DB 7,"CONNECT"
CS_ERROR	DB 5,"ERROR"
CS_NOCARRIER	DB 10,"NO CARRIER"
CS_NODIALTONE	DB 11,"NO DIALTONE"
CS_NOANSWER	DB 9,"NO ANSWER"
CS_DELAYED	DB 7,"DELAYED"

;CS_LOGIN	DB 6,"login:"
;CS_PASSWORD	DB 9,"Password:"
CS_LOGIN	DB 4,"ogin"
CS_PASSWORD	DB 7,"assword"
CS_BEGIN	DB 6,7Eh,0FFh,07Dh,23h,0C0h,21h
CS_BEGIN2	DB 5,7Eh,0FFh,03h,0C0h,21h
;CS_BEGIN3	DB 8,"Entering"
CS_BEGIN3	DB 9,"beginning"
CS_INVALID	DB 7,"Invalid"


;------- Config
		PUBLIC	DIAL_BReg,DIAL_SReg
		PUBLIC	P_LoginName,P_LoginPassword

DIAL_BReg	LABEL	BYTE
NoDialing	DB 0		;100	bit0 0.._C 1..Ȃ
				;	bit1 0..菇F؂ 1..Ȃ
		DB ?,?		;101(Fؕ),102(OCXNvg)
PlainAuthOption	DB 0		;103	OC̑M
				;	0..OCvvg҂
				;	1..҂

DIAL_SReg	LABEL	WORD
P_AT_Dial	DW AT_Null	;300
P_AT_TelNum	DW AT_Null	;301
P_LoginName	DW AT_Null	;302
P_LoginPassword	DW AT_Null	;303
P_AT_INIT2	DW AT_ATZ	;304
		DW 0		;305
P_CSz_Login	DW 0		;306
P_CSz_Password	DW 0		;307
P_CSz_Begin	DW 0		;308
P_CSz_Invalid	DW 0		;309

;-------



State		DB DC_DISCONNECTED
;Receiving	DB OFF			;RS_Receive s
TimerHandler	DB -1			;CDĎ^C},OC^C}
CDChecking	DB ON			;CDĎ邩


		.DATA?

CheckStrings	DW ?
CmpBufUse	DB ?
CmpBuf		DB CMPBUFLEN DUP (?)




;1997/ 9/ 6 
;1997/10/ 1 _CȂXCb`
;1997/10/13 _CȂƂłOC͂邱Ƃ\
;1997/10/27 񓯊ɂ
;1997/12/23 OCOCApX[hvvg񂪐ݒ\
;1998/ 1/16 CmpBuftɂȂ
;1998/ 2/16 L̏C
;1998/ 2/21 OC/s`\([DIAL]308,309)
;1998/ 3/11 _COAT,ATZ 𑗐M
;1998/ 3/12 f̃UgR[hMIȂɃR}h𑗐M
;	    ƃfMȂƂɑΏ
;1998/ 6/11 NoDialing([DIAL]100)̈ӖύX
;1998/ 6/27 "CONNECT"MシɃf[^𑗐Mƃfڑ؂ꍇ
;	    邽߁ACONNECTMPPPڑJnOɃEGCg
;	    "DELAYED"F
;1998/11/21 [DIAL]103 OCvvg҂ɃOC𑗐M \
;1998/12/ 6 菇F؂ȂƂłOCvvg҂Ă̂C
