		INCLUDE	STDDEFS.INC
		INCLUDE	CONFIG.INC

		.MODEL	TINY

IF 0
OSectionType	STRUC
OSectionName	DW ?
OBRegs		DB ?
OBRegOfs	DW ?
OWRegs		DB ?
OWRegOfs	DW ?
OSRegs		DB ?
OSRegOfs	DW ?
OSectionType	ENDS
ENDIF

		.CODE

		EXTRN	SMEM_Alloc:NEAR


		ORG	100h

START:
		MOVSEG	ES,DS
		MOV	DI,OFFSET FileName
		CALL	CONFIG_SetFileName

		CALL	Config
		;CALL	CONFIG_Single100Only

		;I
		MOV	AH,4CH
		INT	21H


		.DATA

		PUBLIC	CONFIG_Sections,CONFIG_SectionTable

FileName	DB "CONFIGTS.TXT",0


CONFIG_Sections	DW 3

CONFIG_SectionTable	DW RS_Section,NEP_Section,NPR_Section


;---- RS

RS_Section	SectionType <RS_SN, 0, RS_RegisterInfo>
RS_SN		DB "RS",0
RS_RegisterInfo	RegisterInfoType <2,RS_BReg,   19,RS_WReg,  11,RS_SReg, 0,0, 0>

		PUBLIC	RS_Breg,RS_WReg,RS_SReg

RS_Breg		DB 2 DUP (0)
RS_WReg		DW 19 DUP (0)
RS_SReg		DW 11 DUP (0)

;---- NETIF_ETHER_PD

		.DATA
		PUBLIC	NEPTop

NEPType	STRUC

NEP_Header	DB TYPE InstanceListType DUP (?)
NEP_WReg	DW 4 DUP (?)

NEPType	ENDS

NEP_Section	SectionType <NEP_SN, SECTION_MULTIINSTANCE, NEP_RegisterInfo, TYPE NEPType, NEP_GetInstance>
NEP_SN		DB "NEP",0
NEP_RegisterInfo RegisterInfoType <0,0, 4,NEP_WReg,  0,0, 0,0, 0>


NEPTop		DW 0

		.CODE


;  ́FDS:BX=CX^XAhX
;	 CX=̒
;	 DS:DI=IꂽZNV SectionType
;@óFDX=G[R[h
;	 AX=CX^XAhX
NEP_GetInstance	PROC

		MOV	SI,OFFSET NEPTop
		JMP	CONFIG_GetInstance

IF 0
		MOV	CX,[DI].InstanceSize
		CALL	SMEM_Alloc
		_IF C
			MOV	DX,ECONFIG_NOMEM
			RET
		_ENDIF

					;DI=mۂ
		MOV	SI,OFFSET NEPTop
		CALL	CONFIG_AddInstance
		MOV	DX,AX
		MOV	AX,DI
		RET
ENDIF

IF 0
		PUSH	CX
		MOV	CX,TYPE NEPType
		CALL	SMEM_Alloc
		POP	CX
		_IF C
			MOV	DX,ECONFIG_NOMEM
			RET
		_ENDIF
					;DI=擾

		;ÕRs[
		MOV	AX,DI		;SAVE
		MOV	SI,BX
		ADD	DI,NEP_Name
		CALL	CONFIG_MemCopy
		MOV	DI,AX		;RESTORE

		;Xgɒǉ
		MOV	AX,NEPTop
		MOV	[DI].NEP_Next,AX
		MOV	NEPTop,DI

		MOV	AX,DI
		CLR	DX
		RET

ENDIF

NEP_GetInstance	ENDP


;---- NETIF_PPP_RS

		.DATA
		PUBLIC	NPRTop

NPRType	STRUC

NPR_Header	DB TYPE InstanceListType DUP (?)
NPR_NETIF_Sreg	DW 4 DUP (?)
NPR_NETIF_Areg	DD 2 DUP (?)
NPR_PPP_Breg	DB 2 DUP (?)

NPRType	ENDS

NPR_Section	SectionType <NPR_SN, SECTION_MULTIINSTANCE|SECTION_SUBSECTION, 0, TYPE NPRType, NPR_GetInstance,0,  2,NPR_SubsectionTable>
NPR_SN		DB "NPR",0
NPR_SubsectionTable DW NETIF_Subsection,PPP_Subsection


NETIF_Subsection SubsectionType <NETIF_SN,NETIF_RegisterInfo>
NETIF_SN	DB "NETIF",0
NETIF_RegisterInfo RegisterInfoType <0,0, 0,0, 4,NPR_NETIF_SReg, 2,NPR_NETIF_AReg, 0>

PPP_Subsection SubsectionType <PPP_SN,PPP_RegisterInfo>
PPP_SN		DB "PPP",0
PPP_RegisterInfo RegisterInfoType <2,NPR_PPP_BReg, 0,0, 0,0, 0,0, 0>


NPRTop		DW 0

		.CODE


;  ́FDS:BX=CX^XAhX
;	 CX=̒
;	 DS:DI=IꂽZNV SectionType
;@óFDX=G[R[h
;	 AX=CX^XAhX
NPR_GetInstance	PROC

		MOV	SI,OFFSET NPRTop
		JMP	CONFIG_GetInstance

NPR_GetInstance	ENDP



IF 0

		.CODE

XInstance	MACRO	NAME

	&NAME&Instance:	MOV	SI,OFFSET &Name&Section
		JMP	OldTypeInstance

		ENDM


		XInstance	RS
		XInstance	DIAL


;
;@́FDS:SI=OSectionType ̃AhX
;	 
;@óF
;@jF
OldTypeInstance	PROC

		MOV	BX,SP
		MOV	DI,[BX+2]

		CMP	[DI].InstanceName,0
		MOV	AX,ECONFIG_CANNOTINSTANCIATE
		JNZ	#Error

		MOV	AL,[SI].OBRegs
		MOV	[DI].BRegs,AL
		MOV	AL,[SI].OWRegs
		MOV	[DI].WRegs,AL
		MOV	AL,[SI].OSRegs
		MOV	[DI].SRegs,AL
		MOV	[DI].ARegs,0

		MOV	AX,[SI].OBRegOfs
		MOV	[DI].BRegOfs,AX
		MOV	AX,[SI].OWRegOfs
		MOV	[DI].WRegOfs,AX
		MOV	AX,[SI].OSRegOfs
		MOV	[DI].SRegOfs,AX
		MOV	[DI].ARegOfs,0

		CLR	AX
		RET

#Error:
		RET

OldTypeInstance	ENDP


		.DATA

RSSection	OSectionType<SN_RS,   2,RS_BReg,   19,RS_WReg,  11,RS_SReg>
DIALSection	OSectionType<SN_DIAL, 4,DIAL_BReg, 0,0, 10,DIAL_SReg>


		PUBLIC	RS_Breg,RS_WReg,RS_SReg,DIAL_BReg,DIAL_SReg

RS_Breg		DB 2 DUP (0)
RS_WReg		DW 19 DUP (0)
RS_SReg		DW 11 DUP (0)

DIAL_Breg	DB 4 DUP (0)
DIAL_Sreg	DW 10 DUP (0)

ENDIF

		END	START
