;
;	Ethernet
;	(Ethernet I/F - TEENppPbghCoI/F)
;

		OPTION OLDSTRUCTS

		INCLUDE	STDDEFS.INC
		INCLUDE	ETHER.INC
		INCLUDE	IF.INC
		INCLUDE	IFETHER.INC
		INCLUDE	ETHERPD.INC
		INCLUDE	PD.INC
		INCLUDE	PDCFG.INC

		.186
		.MODEL	SMALL


Print		MACRO	STR

		PUSH	SI
		MOV	SI,OFFSET STR
		CALL	_Print
		POP	SI

		ENDM


;̈vfƂL[
BufPoolType	STRUC

ElementsMax	DB ?
Elements	DB ?
HeadBuf		DD ?
TailBuf		DD ?

BufPoolType	ENDS


;-------------------------------
;	R[hiJj
;-------------------------------

		.CODE
		
		PUBLIC	ETHERPD_Init
		PUBLIC	ETHERPD_InitIF,ETHERPD_ReleaseIF ;,ETHERPD_GenerateIF
		PUBLIC	ETHERPD_Send,ETHERPD_SetDriver,ETHERPD_InitInstance

		EXTRN	TEEN_SelectUMB:NEAR,TEEN_RelUMB:NEAR

		EXTRN	PD_Select:Near
		EXTRN	PD_AccessType:Near,PD_ReleaseType:Near
		EXTRN	PD_GetAddress:Near,PD_SendPacket:Near


;i풓P񂾂Ăяoj
;@́FDS
;@óF
;@jFAX
ETHERPD_Init	PROC

		MOV	AL,IPBufsMax
		MOV	IPBufPool.ElementsMax,AL
		MOV	IPPacketPool.ElementsMax,AL
		RET

ETHERPD_Init	ENDP


;C^tF[X(IF_ETH_PDType)̏,IFETHER_*̃ANZX\ɂ
;@́F
;@óF
;@jFAX,BX,CX,DX,ES
ETHERPD_InitInstance	PROC
		MOV	[SI].IF_ETH_PD_PSW,0
		RET
ETHERPD_InitInstance	ENDP

;pPbghCo̎w
;@́FDI=PDTypeւ̃|C^
;	 SI=IF_ETH_PDTypeւ̃|C^
;@óF(ZF=0..gp 1..gps)
;@jFAX,BX,CX,DX,ES
ETHERPD_SetDriver	PROC

		OR	DI,DI
		JZ	@f
;		JZ	#Error

		MOV	AL,[DI].PD_INT
		MOV	AH,[DI].PD_Number
		TEST	[DI].PD_Flag,PD_AVAILABLE
		_IF Z
@@:
;#Error:			;gps
			CLR	AX
		_ENDIF
		MOV	[SI].IF_ETH_PD_Device,AX
		RET

ETHERPD_SetDriver	ENDP



IF 0
;C^tF[X̐
;@́FDS
;	 DS:SI=IF_ETH_PDType \̂̃AhX
;@óF
;@jFAX,DI

ETHERPD_GenerateIF	PROC

		PUSH	SI
		MOV	SI,[SI].IF_ETH_PD_S.IF_ETH_S.IF_Name
		CALL	PD_GetDevice		;DS:DI=PD_DeviceType
		POP	SI
		MOV	AL,[DI].PD_D_INT
		MOV	AH,[DI].PD_D_Number
		MOV	[SI].IF_ETH_PD_Device,AX
		RET

ETHERPD_GenerateIF	ENDP
ENDIF


;C^tF[X̎gpJn
;@́FDS
;	 DS:SI=IF_ETH_PDType \̂̃AhX
;		(IF_ETH_PD_Device̒l͗^Ă邱)
;@óFCF=0.. 1..s
;@jFAX,BX,CX,DX,DI,BP,ES
ETHERPD_InitIF	PROC

		MOV	CS:DataSegment,DS


		;ȉ̃vO𐶐
		;	MOV	DI,IF_ETH_PDTypẽItZbgAhX
		;	JMP	FAR CS:ReceiverIP

		MOV	BYTE PTR [SI].IF_ETH_PD_ReceiveIP[0],0BFh  ;MOV DI,
		MOV	WORD PTR [SI].IF_ETH_PD_ReceiveIP[1],SI
		MOV	BYTE PTR [SI].IF_ETH_PD_ReceiveIP[3],0EAh  ;JMP FAR
		MOV	WORD PTR [SI].IF_ETH_PD_ReceiveIP[4],OFFSET ReceiveIP
		MOV	WORD PTR [SI].IF_ETH_PD_ReceiveIP[6],CS

		;ȉ̃vO𐶐
		;	MOV	DI,IF_ETH_PDTypẽItZbgAhX
		;	JMP	FAR CS:ReceiverARP

		MOV	BYTE PTR [SI].IF_ETH_PD_ReceiveARP[0],0BFh    ;MOV DI,
		MOV	WORD PTR [SI].IF_ETH_PD_ReceiveARP[1],SI
		MOV	BYTE PTR [SI].IF_ETH_PD_ReceiveARP[3],0EAh    ;JMP FAR
		MOV	WORD PTR [SI].IF_ETH_PD_ReceiveARP[4],OFFSET ReceiveARP
		MOV	WORD PTR [SI].IF_ETH_PD_ReceiveARP[6],CS

		;PDɑ΂AIP,ARPp̃nh擾

		MOV	AX,[SI].IF_ETH_PD_Device
		OR	AX,AX
		JZ	@f
;		JZ	#Error
		CALL	PD_Select

		MOV	DL,AH			;DL=number
		MOVSEG	ES,DS
		MOV	DI,SI
		ADD	DI,IF_ETH_PD_ReceiveIP	;ES:DI=receiver
		MOV	AX,ETHER_TYPE_DOD_INTERNET
		CALL	PD_AccessType
		JC	@f
;		JC	#Error

		MOV	[SI].IF_ETH_PD_IPHandle,AX

		MOV	DX,[SI].IF_ETH_PD_Device
		MOV	DL,DH			;DL=number
		MOVSEG	ES,DS
		MOV	DI,SI
		ADD	DI,IF_ETH_PD_ReceiveARP	;ES:DI=receiver
		MOV	AX,ETHER_TYPE_ADDRESS_RESOLUTION
		CALL	PD_AccessType
		_IF C
			MOV	BX,[SI].IF_ETH_PD_IPHandle
			CALL	PD_ReleaseType
			JMP	@f
;			JMP	#Error
		_ENDIF

		MOV	[SI].IF_ETH_PD_ARPHandle,AX

		;EthernetAhX擾
		MOV	BX,AX
		MOVSEG	ES,DS
		MOV	DI,SI
		ADD	DI,IF_ETH_PD_S.IF_ETH_Addr
		PUSH	SI
		CALL	PD_GetAddress
		POP	SI

		CLC
		RET

@@:
;#Error:
		STC
		RET

ETHERPD_InitIF	ENDP

;C^tF[X̎gpI
;@́FDS
;	 DS:SI=IF_ETH_PDType \̂̃AhX
;@óF
;@jFAX,BX,CX,DX,DI,BP,ES
ETHERPD_ReleaseIF	PROC

		MOV	AX,[SI].IF_ETH_PD_Device
		OR	AX,AX
		_IFN Z

		MOV	BX,[SI].IF_ETH_PD_IPHandle
		CALL	PD_ReleaseType
		MOV	BX,[SI].IF_ETH_PD_ARPHandle
		CALL	PD_ReleaseType

		_ENDIF
		RET

ETHERPD_ReleaseIF	ENDP



;EthernetpPbgM
;@́FDS
;	 ES:DI=EthernetpPbgiwb_܂ށAwb_ɈĐ,typeLq)
;	 CX=̃TCY
;	 DS:SI=IF_ETH_PDType
;@óF
;		CF=0
;	 G[(Ms)
;		CF=1
;@jFAX,BX,CX,DX,SI,DI,BP,ES
;@⑫F\[XAhX͂̃[`pPbgɏ
;	 ̃[`ES:DI̎wobt@͉Ȃ
ETHERPD_Send	PROC

		MOV	AX,WORD PTR [SI].IF_ETH_PD_S.IF_ETH_Addr[0]
		MOV	WORD PTR ES:[DI].EH_SourceAddr[0],AX
		MOV	AX,WORD PTR [SI].IF_ETH_PD_S.IF_ETH_Addr[2]
		MOV	WORD PTR ES:[DI].EH_SourceAddr[2],AX
		MOV	AX,WORD PTR [SI].IF_ETH_PD_S.IF_ETH_Addr[4]
		MOV	WORD PTR ES:[DI].EH_SourceAddr[4],AX

		CMP	CX,ETHER_PACKET_SIZE_MIN
		_IF B
			MOV	CX,ETHER_PACKET_SIZE_MIN
		_ENDIF
		CALL	PD_SendPacket

		RET

ETHERPD_Send	ENDP


IF 0
;\
;@́FDS:SI=̃AhX
;@jFAX,BX,CX,DX
_Print	PROC

		PUSHM	AX,BX,CX,DX
		PUSH	DI
		PUSH	ES
		PUSHF

		MOVSEG	ES,DS
		MOV	DI,SI
		MOV	AL,0
		MOV	CX,1000h
		CLD
		REPNZ	SCASB
		NEG	CX
		ADD	CX,1000h-1
		MOV	DX,SI
		MOV	BX,2			;WG[o
		MOV	AH,40h
		INT	21h
	
		POPF
		POP	ES
		POP	DI
		POPM	DX,CX,BX,AX
	RET

_Print	ENDP
ENDIF


;-------------------------------
;	pPbgM
;-------------------------------




;BufPoolBufǉ
;@́FES:DI=Buf̃AhX
;@óFCF=0.. 1..ǉłȂ
;@jFAX,CX,DX,DI,ES
BufPool_Enqueue	MACRO	Pool,IgnoreElementsMax

		MOV	CL,Pool.Elements
IFNB <IgnoreElementsMax>
		CMP	CL,255
ELSE
		CMP	CL,Pool.ElementsMax
ENDIF
		_IF B
			MOV	AX,DI
			MOV	DX,ES
			LES	DI,Pool.TailBuf
			MOV	WORD PTR Pool.TailBuf[0],AX
			MOV	WORD PTR Pool.TailBuf[2],DX

			CMP	CL,0
			_IFN Z
				MOV	ES:[DI][0],AX
				MOV	ES:[DI][2],DX
			_ELSE
				MOV	WORD PTR Pool.HeadBuf[0],AX
				MOV	WORD PTR Pool.HeadBuf[2],DX
			_ENDIF

			INC	CL
			MOV	Pool.Elements,CL
			CLC
		_ELSE
			STC
		_ENDIF


		ENDM


;BufPoolBuf擾
;@óFCF=0.. 1..ǉłȂ
;	 ES:DI=Buf̃AhX
;@jFAX,CX,DX,DI,ES
BufPool_Dequeue	MACRO	Pool

		MOV	CL,Pool.Elements
		CMP	CL,0
		_IF A
			LES	DI,Pool.HeadBuf
			MOV	AX,ES:[DI][0]
			MOV	DX,ES:[DI][2]
			MOV	WORD PTR Pool.HeadBuf[0],AX
			MOV	WORD PTR Pool.HeadBuf[2],DX
			DEC	CL
			MOV	Pool.Elements,CL
			CLC
		_ELSE
			CLR	DI
				;CF=1̂ƂłETHERPD_*_Get ES:[DI]ǂ
				;߁ADIKȒlɃZbgĂB
				;0FFFFh܂ANZX 386ł͗O
				;Ȃ
			STC
		_ENDIF

		ENDM





;----}N`Jn

ReceiverRoutines	MACRO	TYP


;IP/ARPMp̃obt@^
;@́FES:DI=obt@(ETHERPD_BUFFER_SIZE oCg)
;	 DS
;@óFCF=0.. 1..ǉłȂ
;@jFAX,BX,CX,DX,ES,DI
;@ӁF݋Ԃłǂ
ETHERPD_&TYP&_PutBuf	PROC

		CLI
		BufPool_Enqueue	&TYP&BufPool
		STI
		RET

ETHERPD_&TYP&_PutBuf	ENDP


;IP/ARPMpobt@ɗ^邱Ƃ̂łobt@̐
;@́FDS
;@óFCX
;@jF
;@ӁF݋Ԃłǂ
ETHERPD_&TYP&_LeftSpace	PROC
		CLI
		MOV	CL,&TYP&BufPool.ElementsMax
		SUB	CL,&TYP&BufPool.Elements
		_IF B
			MOV	CL,0
		_ENDIF
		MOV	CH,0
		STI
		RET
ETHERPD_&TYP&_LeftSpace	ENDP


;IP/ARPMς݃pPbg󂯎
;@́FDS
;@óFCF=0.. 1..pPbg͂Ȃ
;	 ES:DI=EthernetpPbg
;	 CX=pPbg̃TCY
;	 DS:SI=IF_ETH_PDType\̂̃AhX
;@jFAX,BX,CX,DX
;@ӁF݋Ԃłǂ
ETHERPD_&TYP&_Get	PROC

		CLI
		BufPool_Dequeue	&TYP&PacketPool
		STI
		PUSHF
		MOV	CX,ES:[DI].PI_Len
		MOV	SI,ES:[DI].PI_IF
		ADD	DI,TYPE PacketInfoType
		POPF
		RET

ETHERPD_&TYP&_Get	ENDP



;IP/ARPpPbg̎M
;(IF_ETH_PDTypeIF_ETH_ReceiveIP/ARP[`oRČĂ΂)
;@́F
;	 DataSegment:DI=IF_ETH_PDType\̂̃AhX
;@óF
;@jF
Receive&TYP&	PROC	FAR


		;PD̎dĺÃ[`ĂяoꂽɊ݋֎~
		;ĂƂ͌ȂB
		;(u݋ɂOɎÕX^bNɐ؂ւvƂL
		;q炷ƁA݋֎~ŌĂяo悤ɂEEE)

		;A݋֎~ɂĂȂƕssB
		;receiverďoPD̃t@NVĂяoȂB
		; CLI sOɃ^C}[ݓTEEN[`
		;o,PD̃t@NVĂяoĂ܂\

		PUSHF
		CLI

		;MOV	CS:SaveSS,SS
		;MOV	CS:SaveSP,SP
		
		;MOV	SS,CS:DataSegment
		;MOV	SP,OFFSET StackEnd

		PUSH	DS

		PUSHF
		POP	DX

		;IP/ARPBufPool,IP/ARPPacketPool𑀍삷邽߁A
		;̃[`sɁA
		;	PD_IP/ARP_Get,PI_IP/ARP_PutBuf sȂ悤
		;	PDC^tF[X炱ꂪĂяoȂ悤
		;݂֎~

		CLI

		OR	AX,AX
		_IF Z
			;obt@Ԃ
			PUSH	CX

			MOV	DS,CS:DataSegment

			PUSH	BX
			CALL	TEEN_SelectUMB
			MOV	Port152,BX
			POP	BX

			CMP	CX,ETHER_PACKET_SIZE_MAX
			JA	@f
;			JA	#NoBuffer

			OR	[DI].IF_ETH_PD_PSW,DX

			BufPool_Dequeue	&TYP&BufPool
			_IF C

IFDEF USEIND
				PUSH	AX
				PUSH	DX
				INC	NoBufferErrors
				MOV	AL,NoBufferErrors
				MOV	AH,0
				MOV	DH,10
				DIV	DH
				MOV	DL,AH
				ADD	DL,'0'
				MOV	DH,39
				CALL	INDICATE
				POP	DX
				POP	AX
ENDIF

@@:
;#NoBuffer:			
				;CLR	CX
				CLR	DI
				MOV	ES,DI

				PUSH	BX
				MOV	BX,Port152
				CALL	TEEN_RelUMB
				POP	BX

			_ELSE
				ADD	DI,TYPE PacketInfoType
				;MOV	CX,ETHER_PACKET_SIZE_MAX

			_ENDIF

			POP	CX

			;óF ES:DI
			;jF AX,DX,DS
			;⑫F CX͕ۑ

		_ELSE
			;DEC	AX
			;_IF Z
			OR	SI,SI
			JZ	@f
;			JZ	#Exit
			MOV	AX,DS
			OR	AX,AX
			_IFN Z
				;pPbg󂯎
				;MOV	AX,DS
				MOV	ES,AX
				XCHG	DI,SI
				SUB	DI,TYPE PacketInfoType
				MOV	ES:[DI].PI_Len,CX
				MOV	ES:[DI].PI_IF,SI

				MOV	DS,CS:DataSegment
				OR	[SI].IF_ETH_PD_PSW,DX

				MOV	SI,DI
				ADD	SI,TYPE PacketInfoType
							;SIɖ߂

				BufPool_Enqueue	&TYP&PacketPool
				_IF C
					;obt@ǉłȂ
					;obt@̗ɒǉ
					BufPool_Enqueue &TYP&BufPool,IGNORE_MAX

					;_IF C
					  ;obt@ɂǉłȂꍇB
					  ;obt@Ɋ255obt@
					  ;ꍇɊY邪A255
					  ;TCY(373KoCg)
					  ;lĂ肦ȂiƎvj
					;_ENDIF

IFDEF USEIND
					PUSH	AX
					PUSH	DX
					INC	QueueOverflowErrors
					MOV	AL,QueueOverflowErrors
					MOV	AH,0
					MOV	DH,10
					DIV	DH
					MOV	DL,AH
					ADD	DL,'0'
					MOV	DH,40
					CALL	INDICATE
					POP	DX
					POP	AX
ENDIF

				_ENDIF

				PUSH	BX
				MOV	BX,Port152
				CALL	TEEN_RelUMB
				POP	BX

				;jF AX,CX,DX,DI,DS,ES
			_ENDIF

		_ENDIF
@@:
;#Exit:

		POP	DS

		;MOV	SS,CS:SaveSS
		;MOV	SP,CS:SaveSP

		POPF
		RET

Receive&TYP&	ENDP

		ENDM
;----}N`I

		.CODE

IFDEF USEIND
		EXTRN	INDICATE:Near
ENDIF
		PUBLIC	ETHERPD_IP_PutBuf
		PUBLIC	ETHERPD_IP_LeftSpace
		PUBLIC	ETHERPD_IP_Get

		PUBLIC	ETHERPD_ARP_PutBuf
		PUBLIC	ETHERPD_ARP_LeftSpace
		PUBLIC	ETHERPD_ARP_Get

		PUBLIC	ReceiveIP,ReceiveARP

		ReceiverRoutines IP
		ReceiverRoutines ARP

		.CODE

DataSegment	DW ?

;SaveSS		DW ?
;SaveSP		DW ?


		.DATA


;r䂪Kvȃ̈
;  n[hEFA݂ɂČĂяoPDreceiver 
;@TEEN̗ANZX郁̈

PUBLIC	IPPacketPool,ARPPacketPool

IPBufPool	BufPoolType <10,0>
IPPacketPool	BufPoolType <10,0>
ARPBufPool	BufPoolType <2,0>
ARPPacketPool	BufPoolType <2,0>

;r䂱܂


IFDEF USEIND

NoBufferErrors		DB 0
QueueOverflowErrors	DB 0

ENDIF

;--------[CONFIG]

		PUBLIC	ETHERPD_Section

ETHERPD_Section	SectionType <SectName,0,RegInfo>
SectName	DB "ETHERPD",0
RegInfo		RegisterInfoType <1,ETHERPD_BReg, 0,0, 0,0, 0,0, 0>

ETHERPD_BReg	LABEL	BYTE
IPBufsMax	DB 10		;100 IPBuf/PacketPool̃obt@̍ő

;--------[END OF CONFIG]




		.DATA?

Port152		DW ?

;Stack		DB 512 DUP (?)
;StackEnd	LABEL	BYTE

;2000/ 6/24 
;2000/ 6/26 
;2000/ 6/27 
;2000/ 6/29 
;2000/ 6/30 
;2000/ 8/27 PD_GetAddressĂяoOSIۑ
;2000/ 9/24 IPBufPool,IPPacketPool ̃TCY𑝂₷
;2000/10/ 3 L2000/10/ 3 ̃̑΍BReceive*ł̃G[\
;2000/10/21 
;2000/10/22 ETHERPD_GenerateIF p~
;2001/ 1/13 IPBuf/PacketPool̃obt@[ETERPD]100ŎwB
;	    ETHERPD_Init ǉ
;	    ARPBuf/PacketPool̃obt@5->2Ɍ炷
;2002/ 9/17 UMB(PC-88VA)Ή

;:
;2000/10/ 3 Receive*  BufPool_Enqueue săpPbg̗Ƀobt@ǉłȂɕuĂƁATMEMŊmۂ̂ŁAǉłȂpPbg͋󂫃obt@̗ɒǉB󂫃obt@̗ɒǉłȂƂ͎IɂȂƎvB

		end
