/*
	TCP
	for i80x86

	$Header: tcp.cv  1.11  101/01/24 23:17:00  Exp $

*/


#include <mem.h>	/* movedata,memcpy */
#include <dos.h>	/* FP_*,enable,disable,__emit__ */

#include "dnsclt.h"
#include "tcp.h"

#include <tmem.h>
#include <timer.h>
#include <log.h>
#include <indicate.h>
#include <tmath.h>
#include <inet.h>
#include <if.h>
#include <ip.h>


#if 0
#define USEIND		/* Xe[^X\gp */
#define NOLOG		/* Ȍo͂Ȃ */
#define USETIMESTAMP	/* ^CX^vIvV舵 */
#define DEBUGIND	/* */
#endif



#define TCPPORT_ANY 0
#define TCPPORT_RESERVED 1024	/* >port ł port͗\񂳂Ă */
#define TCPPORT_USERRESERVED 5000 /* <port ł port͗\񂳂Ă */
				/* RESERVED <= port <= USERRESERVED 
				   蓖Ă|[gƂĎg */




#define NULL 0
#define OFF 0
#define ON 1

typedef enum {S_CLOSED,S_LISTEN,S_SYNSENT,S_SYNRCVD,S_ESTAB,S_CLOSEWAIT
	,S_LASTACK,S_FINWAIT1,S_FINWAIT2,S_CLOSING,S_TIMEWAIT
	,S_FREE,S_WAITACCEPT,S_DELETING} statetype;
	/* S_FREE: gp̏ 
	   S_DELETING: tcp_closes
	*/

static char *statename[]={
	"CLOSED","LISTEN","SYNSENT","SYNRCVD","ESTAB","CLOSEWAIT"
	,"LASTACK","FINWAIT1","FINWAIT2","CLOSING","TIMEWAIT"
	,"FREE","WAITACCEPT" };

typedef enum {E_POPEN,E_AOPEN,E_SEND,E_CLOSE,E_SYN,E_SYNACK,E_RST,E_ACK,E_FIN,E_TIMEOUT,E_NON,E_RECEIVE,E_ACCEPT,E_PUSH,E_REXTIMEOUT,E_RSTACK,E_FAIL,E_DELETE,E_FINACK,E_NORECEIVER,E_SENDACK} eventtype;
	/* E_NON: CxgȂ/Cxgs
	   E_RECEIVE:pPbgM 
	   E_NORECEIVER: pPbgMKȎM悪
	   E_RSTACK: RST+ACK
	   E_FAIL: ڑ悪Ȃ 
	   E_DELETE: nh
	   E_SENDACK: ACKMv(tcp_recv̗v)
	*/

static char *eventname[]={
	"POPEN","AOPEN","SEND","CLOSE","SYN","SYNACK","RST","ACK","FIN"
	,"TIMEOUT","NON","RECEIVE","ACCEPT","PUSH","ReXmitTIMEOUT","RSTACK"
	,"FAIL","DELETE","FINACK","NORECEIVER","SENDACK"};


typedef struct {
	BYTE handle;
	BYTE dummy;

	struct {
		/*BYTE working:1:	/* transitionŏł */
		unsigned sndfinseq_available:1;	
					/* MpFINseqԍ^ꂽ
					   sndfinseq̐Q */
		unsigned finreceived:1;
					/*  FIN M */
		unsigned dmy:14;	/* ߁Fgp */
	} flag;

	IWORD thisport;		/* ̃Rs[^̃|[g */
	IWORD peerport;		/* ̃|[g */
	IDWORD peerip;		/* ̃AhX */

	WORD peermss;		/* MSSBASENDMSS zƂ
				   peermss=SENDMSS */
	void (huge *notice)();
	statetype state;	/*  */
	uchar substate;		/* ؒf */

				/* MEChE */
	BYTE far *rbuf;
	BYTE far *rbuflimit;		/* Mobt@̖̎ */
	BYTE far *rbufh;		/* Lȃf[^̐擪 */
	BYTE far *rbuft;		/* Lȃf[^̖̎ */
	uint rbufsize;			/* obt@̃oCg <0xffff */
					/* rbufh=rbuft̂Ƃf[^Ȃ
					   rbuft=rbufh-1̂Ƃobt@t
					*/
	DWORD rcvnxt;
	WORD rcvwnd;
					/* rcvnxt ́AFIN̎M̉e󂯂Ȃ
					   (FIN1oCg͊܂߂Ȃ)
					*/


				/* MEChE */
	BYTE far *sbuf;
	BYTE far *sbuflimit;		/* Mobt@̖̎ */
	BYTE far *sbufh;		/* Lȃf[^̐擪 */
	BYTE far *sbuft;		/* Lȃf[^̖̎ */
	uint sbufsize;			/* obt@̃oCg <0xffff */
	DWORD snduna;
	DWORD sndnxt;			/* MACKpsndnxt */
	DWORD snddatanxt;		/* f[^MEđpsndnxt
					   FIN̑M̉e󂯂Ȃ */
	DWORD sndfinseq;		/* M/FINɗ^seqԍ 
					   flag.sndfinseq_available=ONL */
	WORD sndwnd;
	WORD cwnd;			/* congestion window */
	WORD ssthresh;			/* slow start threshold */
	int rextimer;			/* đ^C}nh */
	uint rto;			/* đ(10msec) */

	uint mrtt;			/* RTT(10msec) 蕽 */
	uint srtt;			/* RTT(10msec) W΍ */
	DWORD rtt_sendseq;		/* RTT̑ΏƂƂȂf[^SEQ */
	uint rtt_sendtime;		/* rtt_sendseqM̎(10msec) */
	char sendtime_valid;		/* ON ̂Ƃrtt_sendseq/sendtimeL*/
	uchar dupacks;			/* dACK̐-1 */

	IDWORD tsrecent;

#if 0
	int zwptimer;			/* 0 window probe ^C}nh */
#endif
} connectiontype;

#if 0
typedef struct {
	IDWORD senderip;
	IDWORD receiverip;
	BYTE zero;
	BYTE protocol;
	IWORD tcplen;			/* TCPwb_+f[^̃oCg */
} ippseudoheadertype;
#else
typedef struct {
	BYTE zero;
	BYTE protocol;
	IWORD tcplen;			/* TCPwb_+f[^̃oCg */
	IDWORD senderip;
	IDWORD receiverip;
} ippseudoheadertype;
#endif

typedef struct {
	IWORD senderport;
	IWORD receiverport;
	IDWORD seq;
	IDWORD ackedseq;
	struct {
		WORD reserved:4;
		WORD offset:4;
	} misc;
	BYTE ctrl;
	IWORD window;
	IWORD sum;
	IWORD urgpoint;
} tcpheadertype;

#define TCPHEADERSIZE (sizeof(tcpheadertype))

#define CTRL_URG 0x20
#define CTRL_ACK 0x10
#define CTRL_PSH 0x08
#define CTRL_RST 0x04
#define CTRL_SYN 0x02
#define CTRL_FIN 0x01

#define OPT_END 0
#define OPT_MSS 2
#define OPT_TIMESTAMP 8

#define SEND_NONE 0	/* ackMsv  ɎǵHH */
#define SEND_ACK  1	/* ackMKv */
#define SEND_NEW  2	/* Vf[^(snddatanxtȍ~)𑗐M */
#define SEND_REX  4	/* đ(snduna`snddatanxt-1𑗐M) */


#define RHSIZE (PREFLEN+IPHLEN)	/* TCPwb_[̑OɕKvȃ̈ */
#define SENDMSS (1500-IPHLEN-TCPHEADERSIZE-16)
				/* M\őZOgTCY
				   16=IvṼTCY
				   IPȉ̑w̑M\͂Ɉˑ */
#define MSS 512			/* M\őZOgTCY */
#define MSSMAX SENDMSS		/* MSS,peermss ̍ő(<65536/2ł邱) */
#define CWNDMAX 32767		/* cwnd ő (<65536/2ł邱) */

#define RTTDEFAULT 200		/* RTT ftHg */
#define RTOINIT (RTTDEFAULT+4*SRTTINIT)	/* đl */
#define RTOMAX  6000		/* RTO ő(10msec) (<65536/2ł邱) */
#define RTTMAX 32767		/* RTT ő(10msec) (<65536/2ł邱) */
#define SRTTMAX (RTTMAX/4)	/* RTTő (RTOvZ̓sɂ`)    */
#define SRTTINIT 1		/* RTTl */
#define DUPACKSMAX 3		/* =dupacks ̂ƂAZOgƂ݂Ȃ */

#define CONGESTION_TIMEOUT 0	/* G̓^CAEgɂČoꂽ */
#define CONGESTION_DUPACK  1	/* GACKd̂Čoꂽ */

#define CONNECTIONSMAX 8	/* \ȃRlNV̍ő */
#define TQSIZE 16		/* transitionL[̌+1 */

#define DUMMYBUFSIZE 8		/* _~[̑Mobt@̃TCY(tcp_close)*/

/*------------*/

#if defined(USEIND)
#define INDICATE(x,y) indicate(x,y)
#define INDICATEINT(x,i) indicate_int(x,5,i)
#else
#define INDICATE(x,y)
#define INDICATEINT(x,i)
#endif

/*------------*/
#if 0
int ip_send(BYTE far *buf, uint len, IDWORD toip);
	/* buf=Mf[^(IPwb_܂܂)̃AhX */
uint cksum(BYTE far *buf, uint len);
#endif

/*------------*/

static void rextimeout(int);

/*------------*/

connectiontype connection[CONNECTIONSMAX];
/*IDWORD thisip;*/		/* ̃Rs[^IPAhX */

/*
transition Ăяo֐ŋʂɎQƂϐ
*/
connectiontype *con=NULL;	/* ΏۂƂȂRlNV */
tcpheadertype far *rp;	/* MpPbg */
uint rplen;		/* MpPbgoCg */
uint rpdatalen;		/* MpPbg̃f[^̃oCg */
IDWORD fromip;		/* MpPbg̑M҂IPAhX */

static char deleting=OFF;	/* transition  con  
				   tcp_closeĂ΂ꂽ */

/*
tcp_close
*/
static char dummybuf[DUMMYBUFSIZE];	/* tcp_closeŎgp_~[obt@ */


/*------------*/


#define cnvword(x) ((((uint)(x))>>8) | (((uint)(x))<<8))

#if 0

static DWORD cnvdword(DWORD x)
{
	return (x<<24)|((x<<8)&0x00ff0000L)|((x>>8)&0x0000ff00L)|(x>>24);
}

#else

#define cnvdword(x) inet_dword(x)

#endif

IDWORD ifman_thisaddr(void);
#define ip_thisaddr() ifman_thisaddr()

/*------------*/
#if 0
static void indicateint(int x, uint num)
{
	uint b,i;

	x+=5;
	for (i=0; i<5; i++) {
		b= num % 10;
		num= num / 10;
		INDICATE(x-i,'0'+b);
	}
}
#endif

/*------------------------------
  ē
------------------------------*/

/*
V[PXԍ̔r
@óF-1..a<b, 0..a=b, 1..a>b
*/
static int cmpseq(DWORD a, DWORD b)
{
	if (a==b) return 0;
	if (b-a<0x80000000L) return -1;
	return 1;
}


/*
炵pPbgp
*/
static tcpheadertype far *newpacket(uint optionsize, uint datasize)
{
	BYTE far *p;

	datasize+=(optionsize+TCPHEADERSIZE+3)&0xfffc;
	p=tmem_alloc((RHSIZE+datasize+15)>>4);

	return (p==NULL) ? NULL : (tcpheadertype far*)(p+RHSIZE);
}

/*
TCPwb_IvV
*/
static BYTE far *searchoption(tcpheadertype far *p, BYTE optiontype)
{
	int left;
	BYTE far *option;

	left=(uint)p->misc.offset * 4 - TCPHEADERSIZE;
	option=(BYTE far*)p+TCPHEADERSIZE;
	while (left>0) {
		if (*option==optiontype) break;
		else {
			switch(*option) {
			case OPT_END:
				left=0; break;
			case 1:
				left--; option++; break;
			case OPT_MSS:
			case 3:
			case OPT_TIMESTAMP:
				left-=*(option+1);
				option+=*(option+1);
				break;
			default:
				left=0;
				break;
			}
		}
	}

	return (left>0) ? option : NULL;
}


/*
IPAhX\
*/
static char *ipstr(char str[16], IDWORD ip)
{
	uint arg[4];
	int i;

	for (i=0; i<4; i++) arg[i]=((BYTE *)&ip)[i];
	vsprintf(str,"%u.%u.%u.%u",arg);
	return str;
}

/*
flag\
*/
static char *flagstr(char str[7], BYTE flag)
{
	int i;

	strcpy(str,"FSRPAU");
	for (i=0; i<6; i++,flag>>=1) {
		if ((flag&1)==0) str[i]='_';
	}

	return str;
}

/*
IPőM
  buf=Mf[^(IPwb_܂܂)̃AhX
*/
static void ip_send(BYTE far *buf, uint len, IDWORD toip)
{
	IP far *h;

	h=(IP far *)(buf-IPHLEN);
	h->ip_dst = toip;
	h->ip_proto = 6;
	h->ip_ttl = 0xff;

#if !defined(NOLOG)
	log_printf("TCP : M %dbyte",len);
	/*log_putbinary(buf,len);*/
#endif

	ip_output((BYTE far *) h , len);
}

/*------------------------------
  ēs
------------------------------*/

/*
󂫃RlNVe[uT
*/
static char searchfreeconnection(void)
{
	int i;
	connectiontype *con;

	con=connection;
	for (i=0; i<CONNECTIONSMAX; i++,con++) {
		if (con->state==S_FREE) break;
	}

	return (i<CONNECTIONSMAX) ? i : -1 ;
}



/*------------------------------
  transitiong
  Mf[^Cxg𔻕
  ēs
------------------------------*/
/*
ΉRlNVT
*/
static connectiontype *searchconnection(tcpheadertype far *rp, IDWORD fromip)
{
	int i;
	connectiontype *con;

	con=connection;
	for (i=0; i<CONNECTIONSMAX; i++,con++) {
		if (con->state!=S_FREE &&
		    con->state!=S_CLOSED &&
		    con->state!=S_LISTEN &&
		    con->state!=S_WAITACCEPT &&
		    con->thisport==rp->receiverport &&
		    con->peerport==rp->senderport &&
		    con->peerip==fromip ) break;
	}

	return (i<CONNECTIONSMAX) ? con : NULL ;
}


/*
ΉRlNV(LISTEN)T
*/
static connectiontype *searchlistenconnection(tcpheadertype far *rp)
{
	int i;
	connectiontype *con;

	con=connection;
	for (i=0; i<CONNECTIONSMAX; i++,con++) {
		if (con->state==S_LISTEN &&
		    con->thisport==rp->receiverport) break;
	}

	return (i<CONNECTIONSMAX) ? con : NULL ;
}


/*
MpPbgCxg쐬
@́Frp,rplen,fromip
@óFeventtype	Cxg
	con		ΉRlNV(ȂƂNULL)
  ⑫Frptransition̂ŁAł͉Ȃ
*/
static eventtype decideevent(void)
{
    /* ΉRlNV */
    {
	if ( (con=searchconnection(rp,fromip))==NULL ) {
		if ( (con=searchlistenconnection(rp))==NULL ) {
			/* Ή|[gȂ->M */
			return E_NORECEIVER;
		}
	}
    }


    /* Cxǧ */
    {
	static const struct ctrltoeventstruct {
		uint ctrl;
		eventtype event;
	} ctrltoevent[]={
		{CTRL_RST|CTRL_ACK,E_RSTACK},{CTRL_FIN|CTRL_ACK,E_FINACK},
		{CTRL_SYN|CTRL_ACK,E_SYNACK},
		{CTRL_ACK,E_ACK},
		{CTRL_FIN,E_FIN},{CTRL_RST,E_RST},{CTRL_SYN,E_SYN}
	};
	const struct ctrltoeventstruct *ce;
	uint ctrl;
	int i;
	eventtype event;

	ctrl=rp->ctrl;

	event=E_NON;
	for (i=0,ce=ctrltoevent;
	     i<(sizeof ctrltoevent/sizeof(struct ctrltoeventstruct));
	     i++,ce++) {

		if ((ctrl & ce->ctrl) == ce->ctrl) {
			event=ce->event;
			break;
		}
	}
	return event;
    }
}


/*------------------------------
  transitiongANV
  ēs
------------------------------*/


/*
MO
@óFuint		MׂoCg
*/
static uint preparetosend(tcpheadertype far *p, uint optionsize, uint datasize
			  ,IDWORD toip)
{
	ippseudoheadertype far *iph;
	BYTE far *bp;
	uint realheadersize;
	/*uint sumw[2],sum;*/

	realheadersize=(TCPHEADERSIZE+optionsize+3)&0xfffc;
	p->misc.offset=realheadersize>>2;
	p->misc.reserved=0;

	/* wb_ 0padding */
	bp=(BYTE far *)p+TCPHEADERSIZE+optionsize;
	for (; (uint)bp & 3 !=0; bp++) {
		*bp=0;
	}

	/* `FbNT */
	iph=(ippseudoheadertype far *)
		( (BYTE far *)p - sizeof(ippseudoheadertype) );
	datasize+=realheadersize;
	iph->senderip=ip_thisaddr();
	iph->receiverip=toip;
	iph->protocol=6;
	iph->zero=0;
	iph->tcplen=cnvword(datasize);
	/*log_putbinary(iph,sizeof(ippseudoheadertype));*/
	p->sum=0;

#if 0
	sumw[0]=~in_cksum((BYTE far *)&iph,sizeof(ippseudoheadertype));
	sumw[1]=~in_cksum((BYTE far *)p,datasize); /* datasize͊łOk*/
	sum=in_cksum((BYTE far *)sumw,4);
	p->sum=sum/*cnvword(sum)*/;
#else
	p->sum=in_cksum((BYTE far *)iph,sizeof(ippseudoheadertype)+datasize);
#endif

#if !defined(NOLOG)
	{
		char str[7];
		/*char str2[16];*/
		/*
		BYTE flag;
		int i;
		strcpy(str,"FSRPAU");
		flag=p->ctrl;
		for (i=0; i<6; i++,flag>>=1) {
			if ((flag&1)==0) str[i]='_';
		}
		*/
		/*
		log_printf("TCP : M %u>%s:%u seq=%lu ack=%lu wnd=%u flag=%s"
				,cnvword(con->thisport)
				,ipstr(str2,toip),cnvword(con->peerport)
				,cnvdword(p->seq),cnvdword(p->ackedseq)
				,cnvword(p->window),str);
		*/
		log_printf("TCP : M seq=%lu ack=%lu wnd=%u flag=%s"
				,cnvdword(p->seq),cnvdword(p->ackedseq)
				,cnvword(p->window),flagstr(str,p->ctrl));
	}
#endif

	return datasize;
}


#if defined(USETIMESTAMP)
/*
^CX^vIvV쐬
*/
static int maketimestamp(BYTE far *option)
{
	option[0]=OPT_TIMESTAMP;
	option[1]=10;
	/*option[2]=option[3]=option[4]=option[5]=0;*/
	*((DWORD far *)(option+2))= timer_clock();
	*((IDWORD far *)(option+6))=con->tsrecent;
	return 10;
}


/*
^CX^v擾ARTTvZ
*/
static void gettimestamp(void)
{
	BYTE far *option;

	if ( (option=searchoption(rp,OPT_TIMESTAMP))!=NULL) {
		con->tsrecent=*((IDWORD far *)(option+2));
		/*
		con->rtt= timer_clock() - *((DWORD far *)(option+6));
		if (con->rtt == 0) con->rtt=timer_tick();
		*/
	}

}
#endif


/*----M----*/

/*
Mobt@gp
*/
static uint sbuf_used(void)
{
	return (con->sbuft >= con->sbufh ) 
		   ? con->sbuft - con->sbufh
		   : con->sbuflimit - con->sbufh + con->sbuft - con->sbuf;
}


/*
Mׂf[^̃TCYԂ
  ӁF̃TCY MSS z邱ƂB

	modeSEND_NEWw肳  sndwnd=0  rextimer=-1 
	Mobt@Ƀf[^ƂA1ԂB(0 window probe ̂)
				Aackf[^0̂Ƃ(1999/ 8/31)
				sndwnd=0  rextimer=-1Ȃ疢ackf[^0
								2001/ 2/ 4 

	modeSEND_REXw肳  sndwnd=0  rextimer=-1 
	Mobt@Ƀf[^ƂA1ԂB(0 window probe ̂)
								2001/ 2/ 4 

        sndwnd>0 ̂Ƃ́AԂl sndwnd z邱Ƃ͂ȂB

	mode==SEND_ACK@̂Ƃ0ԂB
*/
static uint senddata_size(int mode)
{
	uint a,b;
	WORD wnd;

	wnd = (con->sndwnd < con->cwnd) ? con->sndwnd : con->cwnd;
	if (wnd == 0 && con->rextimer == -1) wnd=1;    /* for 0 window probe */


	switch(mode&~SEND_ACK) {
	case SEND_NONE:
		return 0;
	case SEND_NEW:
		b=con->snddatanxt - con->snduna; /* ackf[^̗ */
		if (b==0xffff) b=0; /* finMsnduna=snddatanxt+1ł
					̂ƂAa=0̂͂ */
				  	/* finACKꂽŁA
				  	   ԈႢH2001/ 2/ 4 */
		a=sbuf_used();
					/* Mobt@̎gp
					   = ackf[^ + Vf[^ */
		if (a > wnd) a=wnd;
		a= (a<=b) ? 0 : a-b;
		goto common;
	case SEND_REX:
		a=con->snddatanxt - con->snduna;
		if (a==0xffff) a=0; /* finMsnduna=snddatanxt+1ł*/
		if (a > wnd) a=wnd;
	common:
		/*if (a > con->peermss) a=con->peermss;*/

		/*log_printf("TCP : MoCg %u",a);*/
		return a;
	}
	return 0;
}

/*
Mׂf[^ snduna 牽oCgڂn܂邩Ԃ
@⑫FS_SYNSENTԂłmode=SEND_ACK̂Ƃ1ԂB
	(snddatanxt = snduna + 1 )
*/
static uint senddata_offset(int mode)
{
	return (mode&SEND_REX) ? 0 : con->snddatanxt - con->snduna;
	/*
		SEND_REX ̂ƂAsnduna 
		SEND_NEW ̂ƂAsnddatanxt 
		ǂłȂƂAsnddatanxt 
		SEND_REXSEND_NEWĂƂ͂ȂƎvǁH
	*/
}

/*
snduna  offset oCgڂ擪 len oCg buf ɃRs[
  óFRs[͈͂̐擪 SEQ
  ⑫FRs[͈͂ snddatanxt zȂAsndnxt,snddatanxt XV
	len=0̂Ƃ͉ con->snduna+offset  seqԍƂĕԂ
*/
static DWORD senddata(BYTE far *buf, uint offset, uint len)
{
	uint a;
	BYTE far *data;

	if (len==0) return con->snduna+offset;

	data = con->sbufh + offset;
	if (data > con->sbuflimit ) data -= con->sbufsize;

	/* Oobt@ data  len oCg buf ɃRs[ */
	a=con->sbuflimit-data;
	if (len<a) a=len;
	movedata(FP_SEG(data),FP_OFF(data)
		 ,FP_SEG(buf),FP_OFF(buf),a);

	buf+=a;
	a=len-a;
	if (a>0) {
		data=con->sbuf;
		movedata(FP_SEG(data),FP_OFF(data)
			 ,FP_SEG(buf),FP_OFF(buf),a);
	}

	/* sndnxt,snddatanxt XV */
	len += offset;
	if ( cmpseq (con->snduna+len , con->sndnxt) > 0) {
		/*
			sndfinseq_available=ON̂Ƃł
			sndfinseq >= snduna+len > sndnxt >= snddatanxt
			̂͂łB(len)
			]āAsndfinseq>sndnxt 
			܂AFIN͑MĂȂ
			䂦 snddatanxt=sndnxt
		*/
		con->sndnxt=con->snddatanxt=con->snduna+len;
	}

	return con->snduna+offset;
}



/*
MpFINSEQԍ
*/
static assign_sndfinseq(void)
{
	if (!con->flag.sndfinseq_available) {
		con->sndfinseq = con->snduna + sbuf_used();
		con->flag.sndfinseq_available=ON;
#if !defined(NOLOG)
		log_printf("TCP : sndfinseq=%lu",con->sndfinseq);
#endif
	}
}



/*
đ^C}̍폜
*/
static void removerextimer(connectiontype *con)
{
	int th;

	disable();/*cli*/
		/* con->rextimer擾Ƀ^C}荞݂
		   nhcon->rextimer 폜Ă͍ */
	th=con->rextimer;
	if (th>=0) {
		timer_remove(th);
		con->rextimer=-1;
	}
	enable();/*sti*/
}

/*
đ^C}̃X^[g
*/
static void startrextimer(void)
{
	removerextimer(con);
	INDICATE(11,'S');
	con->rextimer=timer_set(rextimeout, con->rto);
	/*
	log_printf("TCP : startrextimer f=%d(10msec) handle=%d",con->rto,con->rextimer);
	*/
}

#if 0
/*
0 window probe ^C}̃X^[g
*/
static void startzwptimer(void)
{
	removezwptimer(con);
	con->zwptimer=timer_set(zwptimeout, con->rto);
}

/*
0 window probe ^C}̍폜
*/
static void removezwptimer(connectiontype *con)
{
	int th;

	disable();/*cli*/
		/* con->zwptimer擾Ƀ^C}荞݂
		   nhcon->zwptimer 폜Ă͍ */
	th=con->zwptimer;
	if (th>=0) {
		timer_remove(th);
		con->zwptimer=-1;
	}
	enable();/*sti*/
}
#endif


/*
RlNVvpPbgM
@⑫FS_CLOSED,S_SYNSENT ł SYN 
	S_WAITACCEPT,S_SYNRCVD ł SYN,ACK 𑗐M
*/
static void send_syn(void)
{
#if defined(USETIMESTAMP)
#define OBYTE (4+10+1)			/* 4:MSS,10:,1:I */
#else
#define OBYTE (4+1)			/* 4:MSS,1:I */
#endif
	tcpheadertype far *p;
	BYTE far *option;

/*	INDICATE(6,'S');*/

	if ( (p=newpacket(OBYTE,0))==NULL) return;

	p->senderport=con->thisport;
	p->receiverport=con->peerport;
	p->seq=cnvdword(con->snduna);
	if (con->state == S_SYNRCVD || con->state == S_WAITACCEPT) {
		p->ackedseq=cnvdword(con->rcvnxt);
		p->window=cnvword(con->rcvwnd);
		p->ctrl=CTRL_SYN|CTRL_ACK;
	}
	else {
		p->ctrl=CTRL_SYN;
	}

	option=(BYTE far *)p+TCPHEADERSIZE;
	option[0]=OPT_MSS;
	option[1]=4;
	option[2]=(WORD)MSS>>8;
	option[3]=(WORD)MSS & 0xff;
	option+=4;
#if defined(USETIMESTAMP)
	option+=maketimestamp(option);
#endif
	option[0]=OPT_END;

	ip_send((BYTE far*)p,preparetosend(p,OBYTE,0,con->peerip),con->peerip);
	startrextimer();

#undef OBYTE
}


#if 0
send_synœ@\̂ŁAp~ 2001/ 2/27 
/*
RlNVpPbgM
*/
void send_synack(void)
{
#if defined(USETIMESTAMP)
#define OBYTE (4+10+1)			/* 4:MSS,10:,1:I */
#else
#define OBYTE (4+1)			/* 4:MSS,1:I */
#endif
	tcpheadertype far *p;
	BYTE far *option;

	INDICATE(6,'$');

	if ( (p=newpacket(OBYTE,0))==NULL) return;

	p->senderport=con->thisport;
	p->receiverport=con->peerport;
	p->seq=cnvdword(con->snduna);
	p->ackedseq=cnvdword(con->rcvnxt);
	p->window=cnvword(con->rcvwnd);
	p->ctrl=CTRL_SYN|CTRL_ACK;

	option=(BYTE far *)p+TCPHEADERSIZE;
	option[0]=OPT_MSS;
	option[1]=4;
	option[2]=(WORD)MSS>>8;
	option[3]=(WORD)MSS&0xff;
	option+=4;
#if defined(USETIMESTAMP)
	option+=maketimestamp(option);
#endif
	option[0]=OPT_END;

	ip_send((BYTE far*)p,preparetosend(p,OBYTE,0,con->peerip),con->peerip);

#undef OBYTE
}
#endif


#if 0
send_ack Ńf[^܂܂ȂpPbgM̂ŁAp~ 1999/ 9/ 1 

/*
MmFpPbgM(f[^܂܂Ȃ)
@⑫FMpPbgseqsndnxtłB
*/
void send_ack_nodata(void)
{
#if defined(USETIMESTAMP)
#define OBYTE (10+1)			/* 10:,1:I */
#else
#define OBYTE 0
#endif
	tcpheadertype far *p;
	BYTE far *option;

	if ( (p=newpacket(OBYTE,0))==NULL) {
		/* ƃobt@sŃpPbgłȂ */
		return;
	}

	p->senderport=con->thisport;
	p->receiverport=con->peerport;
	p->seq=cnvdword(con->sndnxt);
	p->ackedseq=cnvdword(con->rcvnxt);
	p->window=cnvword(con->rcvwnd);
	p->ctrl=CTRL_ACK;

#if defined(USETIMESTAMP)
	option=(BYTE far *)p+TCPHEADERSIZE;
	option+=maketimestamp(option);
	option[0]=OPT_END;
#endif
	ip_send((BYTE far *)p,
		       preparetosend(p,OBYTE,0,con->peerip),con->peerip);

#undef OBYTE
}
#endif


/*
MmFpPbgMAf[^MAFINM
@⑫FS_SYNSENTԂłĂ΂B
	̂ƂAmode͏SEND_ACKB܂Apeermss,rcvnxt,rcvwnd,cwnd
	B
*/
void send_ack(int mode)
{
#if defined(USETIMESTAMP)
#define OBYTE (10+1)			/* 10:,1:I */
#else
#define OBYTE 0
#endif
	tcpheadertype far *p;
	BYTE far *option;
	uint datalen,alldatalen,offset;
	DWORD packetseq,prevsndnxt;
	char userextimer=OFF;

	INDICATE(6,'A');
	/*INDICATE(8,' ');*/
	/*INDICATE(9,(mode&SEND_REX)?'R':'_');*/
#if 0
	if ( (alldatalen=senddata_size(mode)) == 0 ) {
		if (mode & SEND_ACK) {
			send_ack_nodata();
		}
		else {
			/* M̕KvȂ */
			/*INDICATE(8,'N');*/
		}
		return;
	}
	else {
		userextimer=ON;
	}
	offset=senddata_offset(mode);
#endif

	alldatalen=senddata_size(mode);
	offset=senddata_offset(mode);

	if (mode & SEND_ACK || alldatalen>0 ) goto send_ack_send;
	else if ( (mode & SEND_NEW) && (con->flag.sndfinseq_available && (con->sndnxt==con->sndfinseq)) ) goto send_ack_send;
	else if ( (mode & SEND_REX) && (con->flag.sndfinseq_available && (con->snduna==con->sndfinseq)) ) goto send_ack_send;
	else {
#if !defined(NOLOG)
		log_printf("TCP : M mode=%s%s%s sndwnd=%u cwnd=%u",
			( (mode&SEND_ACK) ? "ACK " : "" ),
			( (mode&SEND_NEW) ? "NEW " : "" ),
			( (mode&SEND_REX) ? "REX " : "" ),
			con->sndwnd,con->cwnd);
		log_printf("TCP : snduna=%lu sndnxt=%lu sbuf_used=%u(%lu)",con->snduna,con->sndnxt,sbuf_used(),con->snduna+sbuf_used());
#endif
		return;
	}

send_ack_send:

	do {
		datalen= (alldatalen > con->peermss ) ? con->peermss 
						      : alldatalen ;
		if ( (p=newpacket(OBYTE,datalen))==NULL) {
			/* ƃobt@sŃpPbgłȂ */
			/* E݂alldatalen=0 FIN𑗐M悤ƂĂȂ
				Ȃ ackMłȂȂ̂ŖȂ
			   E݂alldatalen>0 Ȃ Mׂf[^(đ
				܂͐Vf[^)ɂ炸M
				ȂꍇŁA^C}𓮂ĎɑM
				
			*/
			userextimer=ON;
			break;
		}

		p->senderport=con->thisport;
		p->receiverport=con->peerport;
		/*p->seq=cnvdword(con->sndnxt);*/
		/*p->ackedseq=cnvdword(con->rcvnxt);*/
		p->ackedseq=cnvdword( 
			(con->flag.finreceived==ON) ? con->rcvnxt+1
						    : con->rcvnxt   );
							/* 2001/10/11 */
		p->window=cnvword(con->rcvwnd);
		p->ctrl=CTRL_ACK;

#if defined(USETIMESTAMP)
		option=(BYTE far *)p+TCPHEADERSIZE;
		option+=maketimestamp(option);
		option[0]=OPT_END;
#endif

		prevsndnxt=con->sndnxt;	/* ̃pPbg𑗂Osndnxt */
		packetseq=
		    senddata((BYTE far *)p + ((OBYTE+TCPHEADERSIZE+3)&0xfffc)
		             ,offset,datalen);
		p->seq=cnvdword(packetseq);
		if (datalen>0) userextimer=ON;

		/*
		log_printf("flag=%u datalen=%u sndnxt=%lu sndfinseq=%lu p_seq=%lu",con->flag.sndfinseq_available,datalen,con->sndnxt,con->sndfinseq,p->seq);
		*/

		if (con->flag.sndfinseq_available) {
			/* FIN ̏ */
			if ( (packetseq+datalen) == con->sndfinseq ) {
				/* ̃pPbgFINtėǂ */
				p->ctrl|=CTRL_FIN;
				userextimer=ON;
				if (con->sndnxt == con->sndfinseq) {
					/* 񏉂߂ FIN 𑗐M */
					con->sndnxt++;
#if !defined(NOLOG)
					log_printf("TCP : M ŏFIN");
#endif
				}
			}
		}

#if !defined(NOLOG)
		if (datalen>0) {
			log_printf("TCP : M(%lu-%lu) Vsndnxt:%lu"
			    ,cnvdword(p->seq),cnvdword(p->seq)+datalen-1
			    ,con->sndnxt);
		}
#endif
		/* RTTv̂߂ */
		if (con->sendtime_valid) {
			if (mode & SEND_REX) con->sendtime_valid=OFF;
		}
		else {
			/*if (mode & SEND_NEW ) {*/
			if (con->sndnxt != prevsndnxt) {
				/* sndnxt ω
				   ->̃pPbgɂ͏߂đMf[^(FIN
				     ܂)܂܂Ă
				   ->̃pPbgRTTv̑Ώۂɂ
				*/
				con->sendtime_valid=ON;
				con->rtt_sendtime=(uint)timer_clock();
				/*con->rtt_sendseq=cnvdword(p->seq);*/
				con->rtt_sendseq=con->sndnxt-1;
			}
		}

		/* M */
		ip_send((BYTE far *)p,
		       preparetosend(p,OBYTE,datalen,con->peerip),con->peerip);

		alldatalen -= datalen;
		offset += datalen;

	} while (alldatalen>0);

	if (userextimer) {
		/* ACK łȂf[^̑MĂ */
		/* 邢́A擾Ɏs */
		startrextimer();
	}

#undef OBYTE
}


/*
FINɑ΂MmFpPbgM
*/
void send_ackoffin(void)
{
#if defined(USETIMESTAMP)
#define OBYTE (10+1)			/* 10:,1:I */
#else
#define	OBYTE 0
#endif
	tcpheadertype far *p;
	BYTE far *option;

	INDICATE(6,'@');

	if ( (p=newpacket(OBYTE,0))==NULL) return;

	p->senderport=con->thisport;
	p->receiverport=con->peerport;
	p->seq=cnvdword(con->sndnxt);
	p->ackedseq=cnvdword(con->rcvnxt+1);
	p->window=cnvword(con->rcvwnd);
	p->ctrl=CTRL_ACK;

#if defined(USETIMESTAMP)
	option=(BYTE far *)p+TCPHEADERSIZE;
	option+=maketimestamp(option);
	option[0]=OPT_END;
#endif

	ip_send((BYTE far*)p,preparetosend(p,OBYTE,0,con->peerip),con->peerip);

#undef OBYTE
}


#if 0
send_ack  FIN M̂Ŕp~ 1999/ 9/ 1 

/*
JvpPbgM
@óFint		0..finM -1..MȂiMf[^݁j
@ӁF;;Mobt@ɖM̃f[^cĂȂ(snddatanxt-snduna=0)
        ;;Ƃ肷                             sbuft-snddatanxt=0H
        łsndnxtύXȂB
	܂MĂȂf[^(snddatanxt=sbuftłȂjƂ
	MȂ
*/
static int send_finack()
{
#if defined(USETIMESTAMP)
#define OBYTE (10+1)			/* 10:,1:I */
#else
#define OBYTE 0
#endif
	tcpheadertype far *p;
	BYTE far *option;

	/*INDICATE(6,'a');*/

	if (senddata_size(SEND_NEW)!=0) return -1;	@@@

	if ( (p=newpacket(OBYTE,0))==NULL) return 0;

	p->senderport=con->thisport;
	p->receiverport=con->peerport;
	p->seq=cnvdword(con->sndnxt);
	p->ackedseq=cnvdword(con->rcvnxt);
	p->window=cnvword(con->rcvwnd);
	p->ctrl=CTRL_ACK|CTRL_FIN;

#if defined(USETIMESTAMP)
	option=(BYTE far *)p+TCPHEADERSIZE;
	option+=maketimestamp(option);
	option[0]=OPT_END;
#endif

	ip_send((BYTE far*)p,preparetosend(p,OBYTE,0,con->peerip),con->peerip);

	con->sndnxt=con->snddatanxt+1;
	return 0;

#undef OBYTE
}
#endif


/*
RST(SEQ=SEG.ACK)𑗐M
@ӁFpPbg̎MRSTŉꍇ݂̂ɎgBAPI󂯂v
        RST𑗐MłȂB
*/
static void send_rst(void)
{
#define OBYTE (1)			/* 1:I */

	tcpheadertype far *p;
	BYTE far *option;

	if ( (p=newpacket(OBYTE,0))==NULL) return;
/*
	p->senderport=con->thisport;
	p->receiverport=con->peerport;
*/
	p->senderport=rp->receiverport;
	p->receiverport=rp->senderport;
	if (rp->ctrl & CTRL_ACK) {
		p->seq=rp->ackedseq;
		p->ackedseq=0;
		p->ctrl=CTRL_RST;
	}
	else {
		p->seq=0;
		p->ackedseq=cnvdword(
			cnvdword(rp->seq)
			+rpdatalen
			+( (rp->ctrl & (CTRL_SYN | CTRL_FIN)) ? 1 : 0 ) );
		p->ctrl=CTRL_RST | CTRL_ACK;
	}
	p->window=cnvword(1);		/* Ȃ */

	option=(BYTE far *)p+TCPHEADERSIZE;
	option[0]=OPT_END;
/*
	ip_send((BYTE far*)p,preparetosend(p,OBYTE,0,con->peerip),con->peerip);
*/
	ip_send((BYTE far*)p,preparetosend(p,OBYTE,0,fromip),fromip);

#undef OBYTE
}

/*----M----*/
/*
ACKԍ̐(state:SYNSENT)
@óF0..  -1..ُ
*/
static int check_ack_synsent(void)
{
	return (cnvdword(rp->ackedseq) == con->sndnxt) ? 0 : -1;
}

/*
ACKԍ̐(state:SYNRCVD)
@óF0..  -1..ُ
*/
#define check_ack_synrcvd check_ack_synsent


/*
f[^܂ FIN ̍đKvǂԂ
*/
static int check_rex(void)
{
	return (con->sndnxt == con->snduna) ? OFF : ON;
}

/*
đ^C}^CAEg 0 window probe ̑MKvǂԂ
@⑫F܂ 0 window probe 𑗐MĂȂɓKpłB
	Ȃ킿Asndwnd=0 Ȃ snduna=sndnxt
	2001/ 2/ 4 
*/
static int check_zerowindowprobe(void) 
{
	return ( con->sndwnd == 0 && (sbuf_used()>0) );
}

/*
duplicate ACK Ă邩Ԃ
*/
static int check_dupack(void)
{
	return (con->dupacks >= DUPACKSMAX && con->snduna != con->sndnxt)
	       ? ON : OFF;
}

static void indicate_rto(void)
{
#if defined(DEBUGIND)
	INDICATEINT(56,con->mrtt);
	INDICATEINT(63,con->srtt);
	INDICATEINT(49,con->rto);
#endif
}

static void indicate_flow(void)
{
#if defined(DEBUGIND)
/*	INDICATEINT(56,con->cwnd);*/
/*	INDICATEINT(63,con->ssthresh);*/
	indicate_rto();
#endif
}

/*
t[F^CAEg
  cwnd,ssthresh ̌vZ
  rtǒvZ
*/
static void flowctrl_congestion(int type)
{
	WORD a;

	/*log_printf("TCP : congestion type=%d snduna=%lu sndnxt=%lu dupacks=%d",type,con->snduna,con->sndnxt,con->dupacks);*/

	a = ( (con->sndwnd > con->cwnd) ? con->cwnd : con->sndwnd ) / 2;
	con->ssthresh = (a > con->peermss*2) ? a : con->peermss*2;
	if (type==CONGESTION_TIMEOUT) con->cwnd=con->peermss;

	con->rto *= 2;
	if (con->rto > RTOMAX) con->rto=RTOMAX;

	indicate_flow();
}

/*
t[FVACK̎M
*/
static void flowctrl_newack(WORD segsize)
{

	if (con->cwnd < con->ssthresh) {
		/* Slow start */
		con->cwnd += segsize;
	}
	else {
		/* Congestion Avoidance */
		DWORD a;

		a = mulw(segsize,segsize);
		con->cwnd += divdw(a,con->cwnd);
			/* Ă΁Acwnd>=segsize A
			   segsize^2/cwnd <= segsize 
			   ܂Asegsize <=MSSMAX < 65536/2 */
	}
	if (con->cwnd > CWNDMAX) con->cwnd = CWNDMAX;

	indicate_flow();
}


/*
RTT,RTT,RTO ̌vZ
@́Frtt=Ehgbv^Cϑl
	mrtt=݂RTT蕽
	srtt=݂RTTW΍
	rto=đ

@͏F0 <= rtt,mrtt,srtt < RTTMAX(32767)
@⑫Fdelta=rtt-mrtt
	mrtt=mrtt+ delta/8
	srtt=srtt+ (|delta| - srtt)/4
	rto=mrtt+ 4 srtt
*/
static void setrtt(uint rtt, uint *mrtt, uint *srtt, uint *rto)
{
	int delta;
	int a;

	delta= (int)rtt - (int)(*mrtt);
	*mrtt += delta>>3;	/* mrtt += delta/8 */
				/* mrtt<0,mrtt>2RTTMAXƂ͂ȂȂ 
				   mrtt<=RTTMAXȂH1998/11/ 5 
				   rtt>mrtt ̂ƂVmrttrttzȂ
				   rtt<mrtt ̂ƂVmrttrttȂ */

	/*
	log_printf("TCP : delta=%d mrtt=%u",delta,*mrtt);
	*/

/*	if (*mrtt > RTTMAX) *mrtt=RTTMAX;ȂƎv1998/11/ 5 */
	if (delta<0) delta= -delta;
#if 1
	a = (int)(*srtt) + ((delta - (int)(*srtt)) >> 2) ;
				/* -SRTTMAX <= delta-srtt <=RTTMAX */
				/* srtt>deltâƂAVsrttdeltaȂ
				   srtt<deltâƂAVsrttdeltazȂ 
				   0<= delta <=RTTMAX */

	if (a > SRTTMAX) a=SRTTMAX;
	*srtt = a;

#else
#if 0
	{
	uint dx,ax;

	/*la = (long)delta * *srtt;*/
	_CX=*srtt;
	_AX=delta;
	__emit__(0xf7,0xe1); /* mul cx */
	dx=_DX;
	ax=_AX;
	
	if (dx!=0 || ax > RTTMAX) ax=RTTMAX;
	*srtt += ax >> 2;
	if (*srtt > (RTTMAX/4)) *srtt= RTTMAX/4;
	}
#else
	{
	long la;
	uint a;

	la = mulw((uint)delta,*srtt);
	if (la & 0xffff0000L) {
		a=(RTTMAX/4);
	}
	else {
		a= *srtt + (((uint)la) >> 2);
		if (a > (RTTMAX/4)) a=(RTTMAX/4);
	}
	*srtt = a;

	}
#endif
#endif

	a = *mrtt + (*srtt<<2); /* a<= 2RTTMAXƂȂ*/
	*rto = (a > RTOMAX) ? RTOMAX : a;

	/*
	log_printf("TCP : srtt=%u rto=%u",*srtt, *rto);
	*/
}


/*
RlNVvpPbg̎M
*/
static void receive_syn(void)
{
	BYTE far *option;

	INDICATE(5,'s');

#if defined(USETIMESTAMP)
	gettimestamp();
#endif
	con->peerport=rp->senderport;
	con->peerip=fromip;
	con->rcvnxt=cnvdword(rp->seq)+1;
	option=searchoption(rp,OPT_MSS);
	con->peermss=(option==NULL)? 512: cnvword(*((IWORD far *)(option+2)));
	if (con->peermss > MSSMAX) con->peermss=MSSMAX;

	con->cwnd=con->peermss;
	con->ssthresh=65535;
}


/*
RlNVpPbg̎M(state:SYNSENT)
@óF0..  -1..ُ
*/
static int receive_synack(void)
{
	BYTE far *option;

	INDICATE(5,'$');

	if (check_ack_synsent()) return -1;

#if defined(USETIMESTAMP)
	gettimestamp();
#endif
	/*
	con->peerport=rp->senderport;
	con->peerip=fromip;
	*/
	con->rcvnxt=cnvdword(rp->seq)+1;
	con->sndwnd=cnvword(rp->window);
	con->snduna=con->sndnxt;
	option=searchoption(rp,OPT_MSS);
	con->peermss=(option==NULL)? 512: cnvword(*((IWORD far *)(option+2)));
	if (con->peermss > MSSMAX) con->peermss=MSSMAX;

	con->cwnd=con->peermss;
	con->ssthresh=65535;

	return 0;
}


/*
OFACKM
*/
#if !defined(NOLOG)
static void log_receive_ack(void)
{
	log_printf("TCP : ACKM ack:%lu snduna:%lu sndnxt:%lu"
			,cnvdword(rp->ackedseq),con->snduna,con->sndnxt);
}
#endif


/*
OFSNDxxxύX
*/
#if !defined(NOLOG)
static void log_change_snd(void)
{
	log_printf("TCP : XV snduna:%lu sndnxt:%lu sndwnd:%u"
			,con->snduna,con->sndnxt,con->sndwnd);
}
#endif


/*
MmFpPbg̎M(SYNSENT,SYNRCVD)
  ⑫Fsnduna,sndnxt,sbufh XV
*/
static void receive_ack(void)
{
	DWORD ack;
	WORD segsize;

	INDICATE(5,'a');

#if !defined(NOLOG)
	log_receive_ack();
#endif

#if defined(USETIMESTAMP)
	gettimestamp();
#endif
	ack=cnvdword(rp->ackedseq);

	/* ack ԍ̐̌ */
	if (cmpseq(ack,con->snduna)==0) {
		/* Ō ack ꂽ̂Ɠԍ */
		if (con->snduna != con->sndnxt) {	/* 1999/10/16 */
			/* ack̃f[^ -> dACK */
			con->dupacks++;
		}

		{					/* 2001/ 2/ 4 */
			/* windowTCY̕ύX */
			WORD wnd;

			wnd=cnvword(rp->window);
			if (con->sndwnd<wnd) {
				con->sndwnd=wnd;
#if !defined(NOLOG)
				log_change_snd();
#endif
				/* ackԍȂAwnd͌Ȃ
				   pPbgꍇɔA
				   wnd傫Ȃꍇ̂ݍXV
				*/
			}
		}

		return;
	}
	else if (cmpseq(ack,con->snduna)<=0 || cmpseq(ack,con->sndnxt)>0) {
		/* ܂ackԍ ܂́Ał ACKς̔ԍ */
		return;
	}

	/* M ackԍ͐ */
	con->dupacks=0;
	segsize = ack - con->snduna;
	flowctrl_newack(segsize);

	/*if (con->sndnxt!=con->snddatanxt && ack==con->sndnxt) {*/
	if (con->flag.sndfinseq_available && ack==con->sndfinseq+1) {
								/* 1999/10/16*/
		/* FIN  ACK ꂽ */
		con->sbufh=con->sbuft;
	}
	else {
		con->sbufh += segsize;
		if (con->sbufh >= con->sbuflimit) con->sbufh-=con->sbufsize;
				/* ;;MACKFINɑ΂镨łꍇA
				   ;;sbufh1]vɐiނƂɒ */
				/* ̃Rg */
	}

	con->snduna=ack;
	con->sndwnd=cnvword(rp->window);
#if !defined(NOLOG)
	log_change_snd();
#endif
	/*INDICATEINT(70,con->sndwnd);*/

#if defined(DEBUGIND)
	{
	uint a;

	a= (con->sbufh > con->sbuft ) 
	   ? con->sbufh - con->sbuft - 1
	   : con->sbuflimit - con->sbuft + con->sbufh - con->sbuf - 1;
					/* Mobt@̋ */
	INDICATEINT(32,a);
	}
#endif

	/* RTT v */
	if (con->sendtime_valid && cmpseq(con->rtt_sendseq,ack)<=0) {
		uint rtt;

		con->sendtime_valid=OFF;
		if ( (rtt = (uint)timer_clock() - con->rtt_sendtime)==0 ) {
			rtt = timer_tick();
		}
		if (rtt>RTTMAX) rtt=RTTMAX;

		/*
		log_printf("TCP : rtt_sendseq=%lu rtt=%u",con->rtt_sendseq,rtt);		*/

		setrtt(rtt,&(con->mrtt),&(con->srtt),&(con->rto));

#if defined(DEBUGIND)
		INDICATEINT(42,rtt);
		indicate_rto();
#endif
	}


	return;
}


/*
MmFpPbg̎M(state:SYNRCVD)
@óF0..ACK -1..ُACK
@⑫FSYN,SYN&ACKMɂ̓f[^tȂ߁Asndnxt==seg.ack==snduna+1
        ȊOACK͐ȂACKłB
*/
static int receive_ack_synrcvd(void)
{
	DWORD ack;

	INDICATE(5,'a');

#if !defined(NOLOG)
	log_receive_ack();
#endif

#if defined(USETIMESTAMP)
	gettimestamp();
#endif
	if (check_ack_synrcvd()) return -1;

	/* M ackԍ͐ */
	con->snduna=con->sndnxt;
	con->sndwnd=cnvword(rp->window);

#if !defined(NOLOG)
	log_change_snd();
#endif

	return 0;
}


/*
JvpPbg̎M
@óF0..肪Mf[^ׂ͂ĎMIĂ
        -1..܂MĂȂ
*/
static int receive_fin(void)
{
	INDICATE(5,'f');

#if defined(USETIMESTAMP)
	gettimestamp();
#endif
/*	if (con->rcvnxt>=cnvdword(rp->seq)) return 0;*/
	if (cmpseq(con->rcvnxt,cnvdword(rp->seq))>=0) {
		con->flag.finreceived=ON;	/* 2001/10/11 */
		return 0;
	}
	else return -1;

		/*
		FINZbgꂽZOgf[^܂łȂƂ
			rcvnxt=seg.seq
		f[^܂łāAׂẴf[^MƂ
			rcvnxt>seg.seq
		f[^܂ł邪A܂r̃f[^MŔĂƂ
			rcvnxt<seg.seq
		*/
}


/*
f[^̎M
@óF0..AvP[Vf[^Ȃ̂ŁAack𑗂ȂėǂB
        SEND_ACK..ack𑗂KvB
*/
static int receive_data(void)
{
	DWORD seq;
	uint len,hlen,a;

	INDICATE(5,'d');

	seq=cnvdword(rp->seq);
	hlen=(uint)rp->misc.offset*4;
	len=rplen-hlen;

	if (len==0) {
		/* f[^͂Ȃ */
		if (seq==con->rcvnxt) {
			/* ҂SEQԍ */
			return 0;
		}
		else {					/* 2002/ 3/ 2 */
			/* ҂ȂSEQԍɂACK𑗂
			   L[vACupPbgACK𑗂邽߁B
			   L[vACupPbgSEQ=l-1ƂȂĂ*/
			return SEND_ACK;
		}
	}

#if !defined(NOLOG)
	log_printf("TCP : M(%lu-%lu)",seq,seq+len-1);
#endif

	if (!
/*	    ((seq <= con->rcvnxt) && (con->rcvnxt < seq+len))*/
	    ( (cmpseq(seq,con->rcvnxt)<=0) && (cmpseq(con->rcvnxt,seq+len)<0) )
	   ) {
		/* ͗~Ȃf[^ */
		INDICATE(8,'x');
		return SEND_ACK;
	}
	INDICATE(8,'o');

	a=con->rcvnxt-seq;
	hlen+=a;
	len-=a;
	seq+=a;
	if (len > con->rcvwnd) len=con->rcvwnd;
#if !defined(NOLOG)
	log_printf("TCP : 擾(%lu-%lu)",seq,seq+len-1);
#endif

	/* ϐ̍XV */
	con->rcvwnd-=len;
	con->rcvnxt+=len;

	/* Mobt@ɃRs[ */
	a=con->rbuflimit-con->rbuft;
	if (len<a) a=len;
	movedata(FP_SEG(rp),FP_OFF(rp)+hlen
		 ,FP_SEG(con->rbuft),FP_OFF(con->rbuft),a);

	con->rbuft+=a;
	if (con->rbuft >= con->rbuflimit) con->rbuft=con->rbuf;

	hlen+=a;
	a=len-a;
	if (a>0) {
		movedata(FP_SEG(rp),FP_OFF(rp)+hlen
			 ,FP_SEG(con->rbuft),FP_OFF(con->rbuft),a);
		con->rbuft+=a;
	}


	return SEND_ACK;
}


/*
Zbg(RST)̎M
@óFint				0..LRST -1..RST
*/
static int receive_rst(void)
{
	DWORD seq;
	uint len,hlen,a;

	INDICATE(5,'R');

	seq=cnvdword(rp->seq);

	if ( (cmpseq(seq , con->rcvnxt)==0) || /* rcvwnd==0̏ꍇɕKv */
	     ( (cmpseq(seq , con->rcvnxt)>0) &&
	       (cmpseq(seq , con->rcvnxt + con->rcvwnd)<0) 
	     ) 
	   ) {
		/* L */

#if !defined(NOLOG)
		log_printf("TCP : RSTM");
#endif
		return 0;
	}

	return -1;
}


/*--------*/

/*
Mf[^̎oACK̑M
@⑫FMpPbgMf[^oĕۑ
        KvȂAMf[^ɑ΂ACK𑗐MAVMf[^𑗐MB
        dup ACK oĂ΃t[̏ԂύXAđB
*/
static void get_data_and_send_ack(void) {
	if (check_dupack()) {
		/* dup ack ɂ著Mɂ鍬Go */
		flowctrl_congestion(CONGESTION_DUPACK);
		con->dupacks=0;

		send_ack(receive_data()|SEND_REX);
	}
	else {
		send_ack(receive_data()|SEND_NEW);
	}
}


/*------------------------------
  ԑJ
------------------------------*/

/*
ԑJ
  connectiontype *_con		RlNV
  eventtype event		Cxg
  tcpheadertype far *_rp	MpPbg
*/
void transition(connectiontype *_con, eventtype event
			, tcpheadertype far *_rp, uint _rplen, IDWORD _fromip)
{
  static struct {
	connectiontype *con;
	eventtype event;
	tcpheadertype far *rp;
	uint rplen;
	IDWORD fromip;
  } tq[TQSIZE];
  static int tqh=0;
  static int tqt=0;
  static int running=OFF;

  statetype nextstate;
  uchar nextsubstate;

  disable();/*cli*/

  if (event==E_DELETE) {
  	/* _con ̉v */
  	if (con==_con) {
  		/* vꂽ_con͌ݏł */
  		deleting=ON;
  	}
  	else {
  		_con->state=S_FREE;	/*  */
  	}
	enable();
	return;
  }

  if (running) {
	/* L[ɓ */
	int ntqt;

	ntqt=tqt+1;
	if (ntqt==TQSIZE) ntqt=0;
	if (ntqt==tqh) {
		/* L[ς */
#if !defined(NOLOG)
		log_put("TCP : Transition queue is full");
#endif
		if (_rp!=NULL) tmem_free(_rp);
		enable();/*sti*/
		return;
	}
	tq[tqt].con=_con;
	tq[tqt].event=event;
	tq[tqt].rp=_rp;
	tq[tqt].rplen=_rplen;
	tq[tqt].fromip=_fromip;
	/*log_printf("TCP : L[%d %s",tqt,eventname[event]);*/
	tqt=ntqt;
	enable();/*sti*/
	return;
  }

  running=ON;

  INDICATE(3,'T');

  do {
  int noticekind=-1;

  con=_con;
  rp=_rp;
  rplen=_rplen;
  fromip=_fromip;

  rpdatalen=rplen-(uint)rp->misc.offset*4;

  enable();/*sti*/

  if (event==E_RECEIVE) {
  	/* pPbgMƂCxg */
  	event=decideevent();
	/*log_printf("TCP : Cxg->%s",eventname[event]);*/
  }

  if (con==NULL) {

    if (event==E_NORECEIVER) {
#if !defined(NOLOG)
	log_printf("TCP : M|[gȂ:%u",cnvword(rp->receiverport));
#endif
	if (!(rp->ctrl & CTRL_RST)) {
		send_rst();
	}
    }
  }
  else {

#if !defined(NOLOG)
  {
    char str[16];

    log_printf("TCP : Handle=%d(%u-%s:%u) =%s =%s",con->handle,cnvword(con->thisport),ipstr(str,con->peerip),cnvword(con->peerport),statename[con->state],eventname[event]);
  }
#endif

  nextsubstate=0;
  switch(nextstate=con->state) {
    case S_CLOSED: {
	switch (event) {
	case E_AOPEN: {
		send_syn();			/* đ^C} */
		nextstate=S_SYNSENT;
	 }
	 break;
	case E_POPEN: {
		nextstate=S_LISTEN;
	 }
	 break;
	case E_FAIL: {	/* ڑs */
		noticekind=TCP_CLOSED;
	 }
	 break;
	}
     }
     break;
    case S_LISTEN: {
	switch(event) {
	case E_CLOSE: {
		nextstate=S_CLOSED;
		nextsubstate=TCP_MYDOWN;
	 }
	 break;
	/*
	case E_SEND: {
	 }
	 break;
	*/
	case E_SYN: {
		receive_syn();
		noticekind=TCP_WAITACCEPT;
		nextstate=S_WAITACCEPT;
	 }
	 break;
	}
     }
     break;
    case S_WAITACCEPT: {
    	switch(event) {
	case E_ACCEPT: {
		send_syn();	/* send_synack(); */
		nextstate=S_SYNRCVD;
	 }
	 break;
	case E_POPEN: {
		nextstate=S_LISTEN;
	 }
	 break;
	 
    	}
     }
     break;
    case S_SYNSENT: {
	switch(event) {
	case E_REXTIMEOUT: {
				/* S_SYNSENTԂł͂܂ACK(SYNɑ΂)
				   MĂȂߖSYNđ */
				/* @@ ^CAEgԂύXׂ */
		send_syn();
	 }
	 break;
	case E_CLOSE: {
		nextstate=S_CLOSED;
		nextsubstate=TCP_MYDOWN;
	 }
	 break;
	case E_SYN: {
		/* removerextimer(con);	   ^C}~ׂłȂ2001/ 3/ 1 */
		receive_syn();
		send_ack(SEND_ACK);	/* send_synack(); */
		nextstate=S_SYNRCVD;
	 }
	 break;
	case E_SYNACK: {
		if (receive_synack()) {
			/* ACKُ */
			send_rst();
		}
		else {
			removerextimer(con);
			send_ack(SEND_ACK|SEND_NEW);
			noticekind=TCP_OPEN;
			nextstate=S_ESTAB;
		}
	 }
	 break;
#if 0
	SYN̂ȂACK̎M͖Bꑊ肪SYN܂SYN+ACK𑗂Ă(A
	^CAEgĂ炪SYNđ)͂B
	SYN̂ȂACKMɑJڂׂK؂ȏԂB
	2001/ 3/ 1 

	case E_ACK: {
		INDICATE(5,'a');
#if !defined(NOLOG)
		log_receive_ack();
#endif
		if (check_ack_synsent()) {
			/* ACKُ */
			send_rst();
		}
	 }
	 break;
#endif
	case E_RSTACK: {
		INDICATE(5,'r');
#if !defined(NOLOG)
		log_receive_ack();
#endif
		if (!check_ack_synsent()) {
			/* ACK */
			noticekind=TCP_CLOSED;
			nextstate=S_CLOSED;
			nextsubstate=TCP_REJECT;
		}
	 }
	 break;
	}
     }
     break;
    case S_SYNRCVD: {
    	switch(event) {
	case E_REXTIMEOUT: {	/* 2001/ 3/ 1 */
				/* S_SYNRCVDԂł͂܂ACK(SYNɑ΂)
				   MĂȂߖSYNđ */
				/* @@ ^CAEgԂύXׂ */
		send_syn();	/* SYN,ACK𑗐M */
	 }
	 break;
    	case E_ACK: {
				/* @@ Mf[^oׂ */
		if (receive_ack_synrcvd()==0) {
			removerextimer(con);  /* đ^C}~ 2001/ 3/ 2 */
			send_ack(receive_data()|SEND_NEW);
			noticekind=TCP_OPEN;
	    		nextstate=S_ESTAB;
	    	}
    	 }
    	 break;
	case E_SYN: {	/* 2001/ 3/ 1 */
				/* S_SYNRCVDł͊SYN󂯎Ă̂ŁA
				   rcvnxt,mssXVAPSYN,ACKԂ.
				   @@ MSYNSEQԍmFׂ */
		send_syn();	/* SYN&ACK̑M */
				/* @@{́AS_SYNSENTS_SYNRCVD֑Jڂ
				   ACK݂̂ALISTEN(TEENłS_WAITACCEPT)
				   S_SYNRCVD֑JڂꍇSYN&ACK
				   M̂B*/
	 }
	 break;
	case E_SYNACK: {	/* 2001/ 3/ 2 */
				/* SYNAACK̏ɕʁXɏ */
		send_syn();	/* SYN&ACK̑M(case E_SYN ̏Q) */
		if (receive_ack_synrcvd()==0) {
			removerextimer(con);  /* đ^C}~ */
			send_ack(receive_data()|SEND_NEW);
			noticekind=TCP_OPEN;
	    		nextstate=S_ESTAB;
	    	}
	 }
	 break;
    	case E_CLOSE: {
		/*send_finack();*/	/* Mobt@Ƀf[^Ƃ́H */
		assign_sndfinseq(); send_ack(SEND_NEW);
    		nextstate=S_FINWAIT1;
		nextsubstate=TCP_MYDOWN;
    	 }
    	 break;
    	}
     }
     break;
    case S_ESTAB: {
	switch(event) {
	case E_ACK: {
		receive_ack();
		get_data_and_send_ack();
	 }
	 break;
	case E_PUSH: {
		send_ack(SEND_NEW);
	 }
	 break;
	case E_SENDACK: {
		send_ack(SEND_ACK);
	 }
	 break;
	case E_REXTIMEOUT: {
		if (check_rex()) {
			flowctrl_congestion(CONGESTION_TIMEOUT);
			send_ack(SEND_REX);
		}
		else if (check_zerowindowprobe()) {	/* 2001/ 2/ 4 */
			send_ack(SEND_NEW);
		}
	 }
	 break;
	case E_FINACK:
	case E_FIN: {
		receive_ack();
		receive_data();
		if (receive_fin()) send_ack(SEND_ACK|SEND_NEW);
		else {
			send_ackoffin();
			noticekind=TCP_HISCLOSING;
			nextstate=S_CLOSEWAIT;
			nextsubstate=TCP_HISDOWN;
		}
	 }
	 break;
	case E_CLOSE: {
		/*send_finack();*/
		assign_sndfinseq(); send_ack(SEND_NEW);
		nextstate=S_FINWAIT1;
		nextsubstate=TCP_MYDOWN;
	 }
	 break;
	case E_RST:
	case E_RSTACK: {	/* 1999/10/16 */
		if (receive_rst()==0) {
			/* L RST */
			noticekind=TCP_CLOSED; /* TCP_RESET */
			nextstate=S_CLOSED;
			nextsubstate=TCP_HISDOWN; /* TCP_HISRESET */
		}
	 }
	 break;
	}
     }
     break;
    case S_CLOSEWAIT: {
	switch(event) {
	case E_CLOSE: {
		/*send_finack();*/
		assign_sndfinseq(); send_ack(SEND_NEW);
		nextstate=S_LASTACK;
	 }
	 break;
	case E_ACK: {	
		/* 肩f[^M邱Ƃ͂Ȃ */
		receive_ack();
		if (check_dupack()) {
			flowctrl_congestion(CONGESTION_DUPACK);
			send_ack(SEND_REX);
			con->dupacks=0;
		}
		else send_ack(SEND_NEW);
	 }
	 break;
	case E_PUSH: {
		send_ack(SEND_NEW);
	 }
	 break;
	case E_SENDACK: {
		send_ack(SEND_ACK);
	 }
	 break;
	case E_REXTIMEOUT: {
		if (check_rex()) {
			flowctrl_congestion(CONGESTION_TIMEOUT);
			send_ack(SEND_REX);
		}
		else if (check_zerowindowprobe()) {	/* 2001/ 2/ 4 */
			send_ack(SEND_NEW);
		}
	 }
	 break;
	case E_RST:
	case E_RSTACK: {	/* 1999/10/16 */
		if (receive_rst()==0) {
			/* L RST */
			noticekind=TCP_CLOSED; /* TCP_RESET */
			nextstate=S_CLOSED;
		}
	 }
	 break;
	}
     }
     break;
    case S_LASTACK: {
	switch(event) {
	case E_ACK: {
		/* 肩f[^M邱Ƃ͂Ȃ */
		receive_ack();
		if ( con->snduna == con->sndfinseq+1 ) {
			/* FIN ɑ΂ ACKM */
			noticekind=TCP_CLOSED;
			nextstate=S_CLOSED;
		}
		/* ACK 󂯂ĂȂMf[^cĂ */
		else if (check_dupack()) {
			flowctrl_congestion(CONGESTION_DUPACK);
			send_ack(SEND_REX);
			con->dupacks=0;
			/*send_finack();*/
		}
		else {
			/*send_ack(receive_data()| SEND_NEW);	  1999/ 9/ 1 */
			send_ack(SEND_NEW);			/*1999/ 9/ 1 */
			/*send_finack();*/
		}
	 }
	 break;
	case E_REXTIMEOUT: {
		if (check_rex()) {
			flowctrl_congestion(CONGESTION_TIMEOUT);
			send_ack(SEND_REX);
			/*send_finack();*/
		}
		else if (check_zerowindowprobe()) {	/* 2001/ 2/ 4 */
			send_ack(SEND_NEW);
		}
	 }
	 break;
	case E_RST:
	case E_RSTACK: {
		if (receive_rst()==0) {
			/* L RST */
			noticekind=TCP_CLOSED; /* TCP_RESET */
			nextstate=S_CLOSED;
		}
	 }
	 break;

	}
     }
     break;
    case S_FINWAIT1: {
	switch (event) {
	case E_FINACK:
	case E_FIN: {
		/* FIN ܂ FIN/ACK */
		receive_ack();	/* ACK ̂Ȃ FIN sׂłȂ */
		if ( con->snduna == con->sndfinseq+1 ) {
			/* FIN ɑ΂ ACK M : đ͕KvȂ */
			/* FIN  */
			receive_data();
			if (receive_fin()) {
				/* ܂ƂǂĂȂf[^ */
				send_ack(SEND_ACK|SEND_NONE);
				nextstate=S_FINWAIT2;
			}
			else {
				/* ׂẴf[^MI */
				send_ackoffin();
				noticekind=TCP_CLOSED;
				nextstate=S_CLOSED;
			}
		}
		else {
			/* ACK 󂯂ĂȂMf[^cĂ */
			get_data_and_send_ack();
			/*send_finack();*/

			if (receive_fin()) {
				/* ܂ƂǂĂȂf[^ */
			}
			else {
				/* ׂẴf[^MI */
				send_ackoffin();
				nextstate=S_CLOSING;
			}
		}
	 }
	 break;
	case E_ACK: {
		receive_ack();
		if ( con->snduna == con->sndfinseq+1 ) {
			/* FIN ɑ΂ ACKM */
			send_ack(receive_data());	/* f[^M
							   ack𑗐M */
			nextstate=S_FINWAIT2;
		}
		else {
			/* ACK 󂯂ĂȂMf[^cĂ */
			get_data_and_send_ack();
			/*send_finack();*/
		}
	 }
	 break;
	case E_REXTIMEOUT: {
		if (check_rex()) {
			flowctrl_congestion(CONGESTION_TIMEOUT);
			send_ack(SEND_REX);
			/*send_finack();*/
		}
		else if (check_zerowindowprobe()) {	/* 2001/ 2/ 4 */
			send_ack(SEND_NEW);
		}
	 }
	 break;
	case E_RST:
	case E_RSTACK: {	/* 1999/10/16 */
		if (receive_rst()==0) {
			/* L RST */
			noticekind=TCP_CLOSED; /* TCP_RESET */
			nextstate=S_CLOSED;
		}
	 }
	 break;

	}
     }
     break;
    case S_FINWAIT2: {
	switch(event) {
	case E_FINACK:
	case E_FIN: {
		/*receive_ack();*/
		receive_data();
		if (receive_fin()) send_ack(SEND_ACK);
		else {
			send_ackoffin();
			noticekind=TCP_CLOSED;
			nextstate=S_CLOSED; /*S_TIMEWAIT;*/
		}
	 }
	 break;
	case E_RST:
	case E_RSTACK: {	/* 1999/10/16 */
		if (receive_rst()==0) {
			/* L RST */
			noticekind=TCP_CLOSED; /* TCP_RESET */
			nextstate=S_CLOSED;
		}
	 }
	 break;
	}
     }
     break;
    case S_CLOSING: {
	switch(event) {
	case E_ACK: {
		/* 肩f[^M邱Ƃ͂Ȃ */
		receive_ack();
		if ( con->snduna == con->sndfinseq+1 ) {
			/* FIN ɑ΂ ACK M */
			noticekind=TCP_CLOSED;
			nextstate=S_CLOSED;
		}
		/* ACK 󂯂ĂȂMf[^cĂ 1999/ 9/ 1 */
		else if (check_dupack()) {
			flowctrl_congestion(CONGESTION_DUPACK);
			send_ack(SEND_REX);
			con->dupacks=0;
			/*send_finack();*/
		}
		else {
			send_ack(SEND_NEW);
			/*send_finack();*/
		}
	 }
	 break;
	case E_REXTIMEOUT: {	/* 1999/ 9/ 1*/
		if (check_rex()) {
			flowctrl_congestion(CONGESTION_TIMEOUT);
			send_ack(SEND_REX);
			/*send_finack();*/
		}
	 }
	 break;
        }
     }
     break;
    case S_TIMEWAIT: {
	noticekind=TCP_CLOSED;
	nextstate=S_CLOSED;
     }
     break;
  } /* end of switch */

  disable();

  if (deleting) {
    deleting=OFF;
    con->state=S_FREE;
  }
  else {
    /* transitionstcp_closeĂяoȂꍇ */
#if !defined(NOLOG)
    log_printf("TCP : J %s>%s",statename[con->state],statename[nextstate]);
#endif

    con->state=nextstate;
    if (con->substate==0) con->substate=nextsubstate;


    /* notice ̌Ăяo(KvȂ)
       con->state ̍XVɌĂяôŁA noticetcp_xxxĂ΂Ă
       Ήł
    */
#if 0
    if (noticekind>=0 && con->notice!=NULL) 
					/* tcc  far proc ĂڂƂ */
#else
    if (noticekind>=0 && (long)con->notice!=NULL) 
#endif
    {
	_con=con;
	con=NULL;
	_con->notice(_con->handle,noticekind,(void far *)NULL);
		/* notice tcp_closeĂяoƂ
		   noticestcp_closeĂяo邩ȂB
		   notices̊荞݋
		   LɂĂ͗ǂKv
		*/
    }
  }

  con=NULL;	/* transitionł̏ */
  enable();

  } /* if (con==NULL) else */

  if (rp!=NULL) tmem_free(rp);

  /* L[o */
  disable();/*cli*/
  if (tqh==tqt) break;
  else {
	_con=tq[tqh].con;
	event=tq[tqh].event;
	_rp=tq[tqh].rp;
	_rplen=tq[tqh].rplen;
	_fromip=tq[tqh].fromip;
	/*log_printf("TCP : fL[%d %s",tqh,eventname[event]);*/
	if (++tqh==TQSIZE) tqh=0;
  }

  } while (1);

  INDICATE(3,' ');

  running=OFF;
  enable();/*sti*/
}



/*------------------------------
  M
------------------------------*/
/*
  ⑫FēȂ
*/
void tcp_receive(tcpheadertype far *rp, uint rlen, IDWORD fromip)
{
    connectiontype *con;

    INDICATE(2,'t');

    /* `FbNT */
    {
	ippseudoheadertype far *iph;
	/*uint sum[2];*/

#if !defined(NOLOG)
	{
	char str[7];

	log_printf("TCP : M %ubyte",rlen);
	/*log_putbinary((BYTE far *)rp,rlen);*/
	log_printf("TCP : M seq=%lu ack=%lu wnd=%u flag=%s datasize=%u"
			,cnvdword(rp->seq),cnvdword(rp->ackedseq)
			,cnvword(rp->window),flagstr(str,rp->ctrl)
			,rlen - rp->misc.offset*4 );
	}
#endif

#if 0
	iph.senderip=fromip;
	iph.receiverip=ip_thisaddr();
	iph.zero=0;
	iph.protocol=6;
	iph.tcplen=cnvword(rlen);

	/*rp->sum=0;*/
	sum[0]=~in_cksum((BYTE far *)&iph,sizeof(ippseudoheadertype));
	sum[1]=~in_cksum((BYTE far *)rp,rlen);
	log_printf("TCP : M sum=%x",in_cksum((BYTE far *)sum,4));
#else
	iph=(ippseudoheadertype far *)
		( (BYTE far *)rp - sizeof(ippseudoheadertype) );
	iph->zero=0;
	iph->tcplen=cnvword(rlen);

	/*log_putbinary(iph,sizeof(ippseudoheadertype));*/
	/*
	log_printf("TCP : M sum=%x",
	  in_cksum((BYTE far *)iph,sizeof(ippseudoheadertype)+rlen) );
	log_printf("TCP : for %d byte",sizeof(ippseudoheadertype)+rlen);
	log_putbinary(iph,sizeof(ippseudoheadertype)+rlen);
	log_putbinary(((BYTE FAR *)iph)+32,sizeof(ippseudoheadertype)+rlen-32);
	*/
#endif

	if (in_cksum((BYTE far *)iph,sizeof(ippseudoheadertype)+rlen)!=0) {
		/* `FbNTG[ */
#if !defined(NOLOG)
		log_put("TCP : checksum error");
#endif
		tmem_free(rp);
		goto tr_exit;
	}
    }

    transition(NULL,E_RECEIVE,rp,rlen,fromip);

tr_exit:

    INDICATE(2,' ');

    return;
}

/*------------------------------
  đ^CAEg
    ēȂ
------------------------------*/

static void rextimeout(int th)
{
	int i;
	connectiontype *con;

	/* cliԂœ */

	/*--- con->rextimer 𑀍삷 */
	timer_remove(th);

	INDICATE(10,'t');
	con=connection;
	for (i=0; i<CONNECTIONSMAX; i++,con++) {
		if (con->state!=S_FREE && con->rextimer==th) {
			con->rextimer=-1;
			INDICATE(10,'T');
			transition(con,E_REXTIMEOUT,NULL,0,0);
			break;
		}
	}
}


/*------------------------------
  API Tu[`
------------------------------*/

#if 0
gettimeg߁Agp~
/*
V[PXԍ
  ⑫F4}CNbƂɑNbNɊÂČ肷邽߂ɁA
        b*250000(=1/0.000004) V[PXԍƂƁA
        2^32/250000=17179.8=286.3m=4.7h  32bit̒lꏄ
        tɁA2^32/(4h*60m*60s)=298261 Ȃ̂ŁA
        ł́A3.4}CNbƂɑNbNɊÂČ肷B
*/
static DWORD initialseq(void)
{
	struct time time;
	WORD w;

	gettime(&time);
	w=time.ti_sec+time.ti_min*60+(time.ti_hour%4)*60*60;
#if 0
	return 298261L*w;
#else

		/* (h.l)*(0.w)=(l*w+h*w*2^16)
		   298261=0x48d15
		*/
	/* return 0x8d15*(DWORD)w+((DWORD)((WORD)0x4*w)<<16); */

	{
		WORD ax,dx;

		_AX=w;
		_BX=0x8d15;
		__emit__(0xf7,0xe3);	/* MUL BX */
		dx=_DX;
		ax=_AX;

		return (DWORD)ax+((DWORD)dx<<16)+((DWORD)(0x4*w)<<16);
	}
#endif
}

#else
/*
V[PXԍ
  ⑫F4}CNbƂɑNbNɊÂČ肷邱ƂɂȂĂB
  	b*250000(=1/0.000004) V[PXԍƂƁA
        2^32/250000=17179.8=286.3m=4.7h  32bit̒lꏄ

	timer_msecclockœl2^32*1(msec)ňꏄB
  	~b*250(=0.001/0.000004) V[PXԍƂ̂
  	ȒP̂߃~b*256V[PXԍƂB
*/
static DWORD initialseq(void)
{
#if 0
	return timer_msecclock()<<8;
#else
	WORD h,l;
	timer_msecclock(); /* DX.AX=clock */
	_DH=_DL;
	_DL=_AH;
	_AH=_AL;
	_AL=0;
	h=_DX;
	l=_AX;
	return ((DWORD)h<<16)|l;
#endif
}
#endif



/*
nh->connectiontype
  nhsȂƂ́ANULLԂB
*/
static connectiontype *handle2connection(BYTE handle)
{
	connectiontype *con;

	con=&connection[handle];
	return (handle>=CONNECTIONSMAX || con->state==S_FREE || con->state==S_DELETING) ? NULL : con;
}




/*
|[gԍnhɂĎgpH
@́Fint active	ON..tcp_activeopen Ŏgp悤ƂportɂČ
			OFF..tcp_passiveopen Łij
@⑫FactiveoepńAport̂ꂩ̐ڑŎgpĂ΁ugpv
	passiveopeńAportListen̐ڑŎgpĂ΁ugpv
@ӁFsɃnhǉȂƂۏ؂Ŏgp邱
@ē
*/
static int portisused(WORD port, int active)
{
	connectiontype *con;

	port=inet_word(port);
	for (con=connection; con<connection+CONNECTIONSMAX; con++) {
		if ( con->state!=S_FREE && con->thisport==port ) {
			if (active || 
			    con->state==S_LISTEN||
			    con->state==S_WAITACCEPT) return ON;
		}
	}

	return OFF;
}


/*
V|[g̊蓖
@́Fint active	ON..tcp_activeopen Ŏgp悤Ƃport蓖
			OFF..tcp_passiveopen Łij
@ēs
*/
static WORD newport(int active)
{
	static WORD lastport=TCPPORT_USERRESERVED;
	WORD p;

	do {
		if (++lastport>TCPPORT_USERRESERVED) lastport=TCPPORT_RESERVED;
	} while(portisused(lastport,active));

	return lastport;
}


/*------------------------------
  API
------------------------------*/


/*
\Iڑ
ӁFdns_getipaddressĂяo߁Aēs
*/
char tcp_activeopen(TCPPRM far *tcpprm)
{
	connectiontype *con;
	WORD port;
	char handle;

	if ( (port=tcpprm->thisport)==TCPPORT_ANY ) port=newport(ON);
	if (portisused(port,ON) ) {
		/* ̃|[g͎gp */
		return 0x80 | ETCP_BADPORT;
	}

	if ( (handle=searchfreeconnection())<0 ) {
		/* nhs */
#ifdef V020
		return 0x80 | ETCP_NORESOURCE;
#else
		return -1;
#endif
	}
	con=&connection[handle];

	con->rbuf=con->rbufh=con->rbuft=tcpprm->rbuf;
	con->rbuflimit=con->rbuf+ (con->rbufsize=tcpprm->rbufsize);
	con->rcvwnd=con->rbufsize-1;

	con->sbuf=con->sbufh=con->sbuft=tcpprm->sbuf;
	con->sbuflimit=con->sbuf+ (con->sbufsize=tcpprm->sbufsize);
	con->sndwnd=0;
	con->sndnxt=con->snddatanxt=( con->snduna=initialseq() )+1;
	con->rextimer=-1;
	con->rto=RTOINIT;
	con->mrtt=RTTDEFAULT;
	con->srtt=SRTTINIT;
	con->sendtime_valid=OFF;
	con->dupacks=0;


	con->thisport=cnvword(port);
	con->peerport=cnvword(tcpprm->peerport);

	con->notice=tcpprm->notice;

	con->state=S_CLOSED;
	con->substate=0;
	con->flag.sndfinseq_available=OFF;
	con->flag.finreceived=OFF;
#ifdef V020
	if ( dns_getipaddress(tcpprm->host,&(con->peerip)) !=0 ) {
		/* ڑs */
		con->substate=TCP_NOHOST;
		transition(con,E_FAIL,NULL,0,0);
	}
	else {
		transition(con,E_AOPEN,NULL,0,0);
	}
#else
	con->peerip=tcpprm->peerip;
	transition(con,E_AOPEN,NULL,0,0);
#endif

	return handle;
}


/*
󓮓Iڑ
*/
char tcp_passiveopen(WORD thisport, void (huge *notice)())
{
	connectiontype *con;
	char handle;

	if ( thisport==TCPPORT_ANY ) thisport=newport(OFF);
	if ( portisused(thisport,OFF) ) {
		/* ̃|[g͎gp */
		return 0x80 | ETCP_BADPORT;
	}

	if ( (handle=searchfreeconnection())<0 ) {
		/* nhs */
#ifdef V020
		return 0x80 | ETCP_NORESOURCE;
#else
		return -1;
#endif
	}
	con=&connection[handle];

	con->rbuf=con->rbufh=con->rbuft=(BYTE far *)0xffffffffL;
					/* Ǐo̖h~ */


	con->thisport=cnvword(thisport);
	con->notice=notice;

	con->state=S_CLOSED;
	con->substate=0;
	con->flag.sndfinseq_available=OFF;
	con->flag.finreceived=OFF;
	transition(con,E_POPEN,NULL,0,0);

	return handle;
}


/*
ڑv
*/
char tcp_accept(char oldhandle, TCPPRM far *tcpprm)
{
    connectiontype *con,*oldcon;
    char handle;

    if ( (oldcon=handle2connection(oldhandle))==NULL ) {
#ifdef V020
	return 0x80 | ETCP_BADHANDLE;
#else
	return -1;
#endif
    }
    if (oldcon->state != S_WAITACCEPT ) {
	/* sKȏ */
#ifdef V020
	return 0x80 | ETCP_BADSTATE;
#else
	return -1;
#endif
    }

    if ( (handle=searchfreeconnection())>=0 ) {
	/* nh */

	disable();/*cli*/ /* con->state=S_LISTENłԂtransitionĂ͍ */
			/* KvȂ񂶂ȂH */
	con=&connection[handle];
#if 0
	*con=*oldcon;		 	/* ڑv҂Ăconnection
					   ̏Rs[ */
#else
	memcpy(con,oldcon,sizeof(connectiontype));
					/* \̂̑ far proc ̌Ăяo
					   邽߁Amemcpy őp */
#endif
	con->handle=handle;
	con->state=S_WAITACCEPT;
	enable();/*sti*/

	con->rbuf=con->rbufh=con->rbuft=tcpprm->rbuf;
	con->rbuflimit=con->rbuf+ (con->rbufsize=tcpprm->rbufsize);
	con->rcvwnd=con->rbufsize-1;

	con->sndwnd=0;
	con->sndnxt=con->snddatanxt=( con->snduna=initialseq() )+1;

	con->sbuf=con->sbufh=con->sbuft=tcpprm->sbuf;
	con->sbuflimit=con->sbuf+ (con->sbufsize=tcpprm->sbufsize);

	con->rextimer=-1;
	con->rto=RTOINIT;
	con->mrtt=RTTDEFAULT;
	con->srtt=SRTTINIT;
	con->sendtime_valid=OFF;
	con->dupacks=0;

	con->notice=tcpprm->notice;

	transition(con,E_ACCEPT,NULL,0,0);
	transition(oldcon,E_POPEN,NULL,0,0);
	return handle;
    }
    else {
	/* nhs */
#ifdef V020
	return 0x80 | ETCP_NORESOURCE;
#else
	return -1;
#endif
    }
}


/*
ؒfv
*/
char tcp_shutdown(BYTE handle)
{
	connectiontype *con;

	if ( (con=handle2connection(handle))==NULL ) {
#ifdef V020
		return 0x80 | ETCP_BADHANDLE;
#else
		return 0;
#endif
	}
	switch(con->state) {
	case S_FINWAIT1:
	case S_FINWAIT2:
	case S_CLOSING:
	case S_TIMEWAIT:
	case S_LASTACK:
	case S_CLOSED:
#ifdef V020
		return 0x80 | ETCP_CLOSE;
#else
		return 0;
#endif
	default:
		transition(con,E_CLOSE,NULL,0,0);
		return 0;
	}
}


/*
nhJ
  ӁFstate=S_CLOSED ȊO̎́A荞ݓ쒆ɂ͌ĂяoȂ
*/
char tcp_close(BYTE handle)
{
	connectiontype *con;

	if ( (con=handle2connection(handle))==NULL ) {
#ifdef V020
		return 0x80 | ETCP_BADHANDLE;
#else
		return 0;
#endif
	}

	disable();

	removerextimer(con);

	con->sbuf=con->sbufh=con->sbuft=dummybuf;
	con->sbuflimit=con->sbuf+ (con->sbufsize=DUMMYBUFSIZE);
	con->rbuf=con->rbufh=con->rbuft=dummybuf;
	con->rbuflimit=con->rbuf+ (con->rbufsize=DUMMYBUFSIZE);
	con->notice=NULL;

	con->state=S_DELETING;
	enable();
	transition(con,E_DELETE,NULL,0,0);

	return 0;
}


/*
Mv
*/
#ifdef V020
long tcp_send(BYTE handle, BYTE far *buf, uint len, uint flag)
#else
uint tcp_send(BYTE handle, BYTE far *buf, uint len, uint flag)
#endif
{
	connectiontype *con;
	int a;

	if ( (con=handle2connection(handle))==NULL ) {
#ifdef V020
		return 0xffff0000L | ETCP_BADHANDLE;
#else
		return 0;
#endif
	}
	switch(con->state) {
	case S_SYNSENT:
	case S_SYNRCVD:
	case S_ESTAB:
	case S_CLOSEWAIT:
		break;
	case S_LISTEN:
	case S_WAITACCEPT:
		/* ڑ斢w */
#ifdef V020
		return 0xffff0000L | ETCP_BADSTATE;
#else
		return 0;
#endif
	default:
		/* ĂA */
#ifdef V020
		return 0xffff0000L | ETCP_CLOSE;
#else
		return 0;
#endif
	}

	disable();/*cli*/
	a= (con->sbufh > con->sbuft ) 
	   ? con->sbufh - con->sbuft - 1
	   : con->sbuflimit - con->sbuft + con->sbufh - con->sbuf - 1;
					/* Mobt@̋ */
	/*INDICATEINT(32,a);*/

	if (len>a) len=a;
	if (len==0) {
		enable();/*sti*/
		return 0;
	}

	/* Mobt@ɃRs[ */
	a=con->sbuflimit-con->sbuft;
	if (len<a) a=len;
	movedata(FP_SEG(buf),FP_OFF(buf)
		 ,FP_SEG(con->sbuft),FP_OFF(con->sbuft),a);

	con->sbuft+=a;
	if (con->sbuft >= con->sbuflimit) con->sbuft=con->sbuf;

	if (len-a>0) {
		movedata(FP_SEG(buf),FP_OFF(buf)+a
			 ,FP_SEG(con->sbuft),FP_OFF(con->sbuft),len-a);
		con->sbuft+=len-a;
	}
	enable();/*sti*/


	/*if (flag)*/ transition(con,E_PUSH,NULL,0,0);

	return len;
}


/*
Mv(gp)
@́Fuint flag		0..ʏ̓ǂݏo
				1..ǂݏof[^͎Mobt@폜Ȃ
*/
#ifdef V020
static long recv(BYTE handle, BYTE far *buf, uint len, uint flag)
#else
static uint recv(BYTE handle, BYTE far *buf, uint len, uint flag)
#endif
{
	connectiontype *con;
	uint a;
	BYTE far *rbufh;

	if ( (con=handle2connection(handle))==NULL ) {
#ifdef V020
		return 0xffff0000L | ETCP_BADHANDLE;
#else
		return 0;
#endif
	}
	switch(con->state) {
	case S_LISTEN:
	case S_WAITACCEPT:
		/* ڑ斢w */
#ifdef V020
		return 0xffff0000L | ETCP_BADSTATE;
#else
		return 0;
#endif
	case S_SYNSENT:
	case S_SYNRCVD:
		/* MȂ */
		return 0;
	}

	a=con->rbufsize-con->rcvwnd-1;	/* obt@ɂf[^ */
	if (len>a) len=a;
	if (len==0) return 0;

	/* Mobt@Rs[ */
	disable();/*cli*/

	rbufh=con->rbufh;

	a=con->rbuflimit-rbufh;
	if (len<a) a=len;
	movedata(FP_SEG(rbufh),FP_OFF(rbufh), FP_SEG(buf),FP_OFF(buf),a);

	rbufh+=a;
	if (rbufh >= con->rbuflimit) rbufh=con->rbuf;

	if (len-a>0) {
		movedata(FP_SEG(rbufh),FP_OFF(rbufh),
			 FP_SEG(buf),FP_OFF(buf)+a,len-a);
		rbufh+=len-a;
	}

	a=OFF;
	if ( (flag & 1) == 0 ) {
		a= con->rcvwnd < MSS;
		con->rcvwnd+=len;
		con->rbufh=rbufh;
	}
	enable();/*sti*/

	if (a && (con->rcvwnd >= MSS)) {
		/* 󂫃EBhETCYMSSMSSȏɕω
		   EBhETCYʒm̂ACKM */
		transition(con,E_SENDACK,NULL,0,0);
	}

	return len;
}



#if 0
recv()ĝŏ
/*
Mv
*/
#ifdef V020
long tcp_recv(BYTE handle, BYTE far *buf, uint len)
#else
uint tcp_recv(BYTE handle, BYTE far *buf, uint len)
#endif
{
	connectiontype *con;
	uint a;

	if ( (con=handle2connection(handle))==NULL ) {
#ifdef V020
		return 0xffff0000L | ETCP_BADHANDLE;
#else
		return 0;
#endif
	}
	switch(con->state) {
	case S_LISTEN:
	case S_WAITACCEPT:
		/* ڑ斢w */
#ifdef V020
		return 0xffff0000L | ETCP_BADSTATE;
#else
		return 0;
#endif
	case S_SYNSENT:
	case S_SYNRCVD:
		/* MȂ */
		return 0;
	}

	a=con->rbufsize-con->rcvwnd-1;	/* obt@ɂf[^ */
	if (len>a) len=a;
	if (len==0) return 0;

	/* Mobt@Rs[ */
	disable();/*cli*/
	a=con->rbuflimit-con->rbufh;
	if (len<a) a=len;
	movedata(FP_SEG(con->rbufh),FP_OFF(con->rbufh),
		 FP_SEG(buf),FP_OFF(buf),a);

	con->rbufh+=a;
	if (con->rbufh >= con->rbuflimit) con->rbufh=con->rbuf;

	if (len-a>0) {
		movedata(FP_SEG(con->rbufh),FP_OFF(con->rbufh),
			 FP_SEG(buf),FP_OFF(buf)+a,len-a);
		con->rbufh+=len-a;
	}

	a= con->rcvwnd < MSS;
	con->rcvwnd+=len;
	enable();/*sti*/

	if (a && (con->rcvwnd >= MSS)) {
		/* 󂫃EBhETCYMSSMSSȏɕω
		   EBhETCYʒm̂ACKM */
		transition(con,E_SENDACK,NULL,0,0);
	}

	return len;
}
#else

/*
Mv
*/
long tcp_recv(BYTE handle, BYTE far *buf, uint len) 
{
	return recv(handle,buf,len,0);
}

#endif

/*
Mv(jǂݏo)
*/
long tcp_peek(BYTE handle, BYTE far *buf, uint len) 
{
	return recv(handle,buf,len,1);
}

/*
Ԏ擾
*/
char tcp_state(BYTE handle)
{
      if (handle<CONNECTIONSMAX) {
	switch(connection[handle].state) {
	case S_CLOSED: return TCP_CLOSED;
	case S_LISTEN: return TCP_LISTEN;
	case S_WAITACCEPT: return TCP_WAITACCEPT;
	case S_SYNSENT:
	case S_SYNRCVD: return TCP_OPENING;
	case S_ESTAB: return TCP_OPEN;
	case S_CLOSEWAIT: return TCP_HISCLOSING;
	case S_FINWAIT1:
	case S_FINWAIT2: return TCP_MYCLOSING;
	case S_LASTACK:
	case S_CLOSING:
	case S_TIMEWAIT: return TCP_CLOSING;
	}
      }
#ifdef V020
	return 0x80 | ETCP_BADHANDLE;
#else
	return -1;
#endif
}


/*
ؒf擾
*/
char tcp_downstate(BYTE handle)
{
	if (handle<CONNECTIONSMAX) {
		return connection[handle].substate;
	}
	return 0x80 | ETCP_BADHANDLE;
}


/*
TCPnhɊ蓖ĂĂAhX擾
@⑫F
		tcp_state̕Ԃl1(S_LISTEN:肩̐ڑv
		҂)̏ꍇ́Ã|[gԍEIPAhXEIP
		AhX`ł萳lԂȂB
		tcp_state̕Ԃl3(`:ڑIPAhX擾)̏
		́AIPAhXEIPAhX`ł萳
		lԂȂB
*/
char tcp_getaddr(BYTE handle, TCPADDR far *addr /*[2]*/)
{
	connectiontype *con;

	if ( (con=handle2connection(handle))==NULL ) {
		return 0x80 | ETCP_BADHANDLE;
	}

	addr[0].ip=ip_thisaddr();
	addr[0].port=cnvword(con->thisport);
	addr[1].ip=con->peerip;
	addr[1].port=cnvword(con->peerport);
	
	return 0;
}

/*------------------------------
  
------------------------------*/

void tcp_init(void)
{
	int i;

	for (i=0; i<CONNECTIONSMAX; i++) {
		connection[i].handle=i;
		connection[i].rextimer=-1;
		connection[i].state=S_FREE;
	}

/*	thisip=0x01020304;*/
}



/*
đ^C}(rextimer)
  1.f[^1oCgȏ㑗MA^C}N
  2.f[^1oCgȏ㑗M悤Ƃtmem̃sőMłȂ
    ꍇA^C}N
  @(1.2.A^C}łɋNĂꍇA^C}LZ
     ċN)
  3.^CAEg snduna`snddatanxt-1 ܂łđM

  
    E^C}̃^CAEgɂ萶E_REXTIMEOUT  transition ̃L[
      ؂炸Ɏ̂ĂꂽꍇAack𑗐M鑼̗vNȂA
      đ^C}͒~܂܂łB(see, rextimeout() )
    E^CAEgOɎXƐVf[^𑗐MꍇA肪M˂
      ZOgĂAMobt@tɂȂ܂Ń^CAEg͔
      ȂB]āATCPMobt@傫قǃ^CAEǧo͒xB
      (duplicate ACK ̌oɂAđւ̉e͂قډ)

Vf[^̑M̃^C~O
  (1.tcp_send  push w肳ꂽƂ)
  (2.tcp_send  Mobt@ɂoCgȏ̃f[^܂ĂƂ)
  1.tcp_send s
  3.ackԑƂ

  M悤ƂMłȂꍇA̗ŔA
    1.tmems
    2.sndwnd=0  ()(-> window>0ack܂őMs\)
    3.transition L[t


0 window probe ([EEBhET)
	2001/ 2/ 4 

  Eđ̋@\𗘗pĎ

  EVf[^𑗐M悤ƂɁA܂́Ađ^C}^CAEg
    đׂf[^Ȃ(snduna=sndnxt)̎ɁA

    sndwnd=0  Vf[^(sndnxtȍ~̃f[^)A
    Asnduna=sndnxt ł(*1)
    đ^C}ĂȂ΁A1oCgM
    sndnxt 1i߂(*2)B
      
      1oCgMɂčđ^C}N
      (đ^C}ĂȂƂmF1oCgMƁA
       Vf[^𑗐M悤ƂԊu(RTO肸ƒZ)
       1oCg𑗐MĂ܂)

    (*1)ʏ́Asndwnd=0Ȃsndnxt=snduna ̂͂łB
        snduna,sndnxt,snduna+sndwnd ͒PłA
        f[^M(sndnxtXV)ɂāA
        snduna+sndwnd >= sndnxt  sndnxt >= snduna 
        
        snduna+sndwnd >= sndnxt  sndnxt >= snduna
        Asndwnd=0 Ȃ snduna=sndnxt

    (*2)ɂAsndwnd𖳎MsȂ߁A(*1)ȂȂB

  EđKv(snduna<sndnxt) ōđ悤ƂƂɁA
    (ʏ sndwnd<>0ł ((*1)ɂ) )
    sndwnd=0Ȃ΁A 0 window probe őM1oCg̍đłB
    suduna1oCgMB

  E1oCgMAACKM鎖 ^CAEgꍇA
    RTO  2@{ɂ
    snduna 1oCgđ݂
    (̂ƂAsnduna<sndnxt  snduna+sndwnd<sndnxtł)


ackɂack𑗂Ȃ
  =AvP[Vf[^̖acktOt̃pPbgɂack𑗂Ȃ
  2002/ 3/ 2 ύX
    seq=rcvnxtȂack𑗂ȂBłȂȂack𑗂

nhJ
  tcp_close  state=S_DELETING ɂB
  ɑ΂CxgtransitionL[Ɏc
  Ă\A𐳂˂΂ȂȂB

  1.J state=S_FREE/S_DELETING ƂȂĂ->Cxg𖳎
  2.Jꂽʂ̃RlNVɎgpĂ܂́B->
      CxgMɂ̂̏ꍇ
      E|[gԍωĂ΁AM|[gɑΉnh炸
        
      E|[gԍȂACxg͏邪Aseqԍ̈Ⴂ
      @͋NȂEEEHH
      CxgMȊOɂ̂̏ꍇ->???
	(tcp_sendstcp_closesAE_PUSHL[ɎcĂ肷
	 Ɩj

  transitionŏ̃nhɑ΂ tcp_close sꍇ
   1.tcp_closeE_DELETE transitionɗ^Btransition connectiontype
     f[^ݏ̂̂ƈvꍇAdeleting=ONƂāAI
     state=S_FREE ƂB
   2.ݏ̂̂ƈقȂꍇAtransitionłȂꍇȀ
     state=S_FREE ƂB



  
Reset pPbg̈
   S_ESTAB,S_CLOSING,S_FINWAIT2,S_FINWAIT1  LRST M S_CLOSED
   ֈڍsB̂Ƃ notice  substate ̒lǂ邩ׂ͌B



RTT ̑
  seqԍ a`b ̃ZOg𑗐MƂAݎ(=M)L^B
  snduna<=b<ackԍ Ȃ ACK ͂ƂAMRTTvZ

  setrtt Q


RTO ̌
  setrtt Q


Slow start  Congestion avoidance (RFC2001)

  cwnd : congestion window (oCg)
  ssthresh : slow start threshold (oCg)

  hisMSS :  MSS (oCg)
  
  cwnd l = hisMSS
  ssthresh l = 65535

  E^CAEg/duplicate ACKs M
    a = if (sndwnd > cwnd ) cwnd/2 else sndwnd / 2
    ssthresh = if (a > 2*hisMSS) a else 2*hisMSS
    E^CAEg̏ꍇ
      cwnd = hisMSS

    FE(ς)(duplicate ACK ̌o͖)
          E(duplicate ACK ̌oɂقډ)
            (^CAEǧoxBɁÃEBhE傫A
            ɑMf[^RꍇB)

  EVACK̎M (ACKԍ> snduna)
    Ecwnd <= ssthresh ̂Ƃ ( Slow Start)
      cwnd += (ACK ԍ - snduna)
    Ecwnd > ssthresh ̂Ƃ ( Congestion avoidance)
      cwnd += (ACK ԍ - snduna)^2 / cwnd





  Etcp_shutdownɑMobt@Ƀf[^cĂƂ
  EMwindow U 0 ɂȂǍ 1ȏɂȂƂack𑗂Ȃ
    ΂ȂȂij->2001/1/14 

  EMobt@Ɏcf[^̑M
    FACKĂȂMς݃f[^cĂƂ́AK̂ꂩ
          NB
            肩 ACK ͂
            ^CAEg
    Ftcp_send sBAsndwnd܂cwnd AMobt
          @̃f[^̈ꕔ͑MłȂB̂̂ tcp_send ͎s
          ȂƂƁAMobt@̃f[^ivɎc邱Ƃ肤邩H
    񓚁Fꕔ͑M̂ŁA肩ACK͂ƂƁÂƂɑMob
          t@f[^͑MB
          肩ACK͂ȂꍇA^CAEgAđBđ
          ΂đ肩ACK͂B̂ƂɑMobt@f[^͑MB

  ERTO ̋sRFϑRTT=50,mRTT=50,sRTT=0 ŗ RTO  50,
    100 s藈肷

      timer.asm ̐xi݊Ԋujt ɑ΂Atimer_set  l b݂̊
    vAۂɂ l Ŋ݂BɁAl<t ̎̌덷͑
    ȂA^CAEg܂ł܂]T̂Ƀ^CAEgAG
    Ɖ߂邱ƂȂBtimer.asm ̖B

  Etcp_activeopen/passiveopen Ŏgp|[gԍ󂢂Ă邩ۂ
    ĂȂB->2001/ 1/24 C
*/



/*
1997/10/13 
1997/10/17 
1997/10/18 
1997/10/19 
1997/10/20 
1997/10/23 
1997/11/ 8 
1997/11/ 9 
1997/11/12 
1997/12/22 tcp_state
1997/12/23 S_SYNSENT  E_RST M S_CLOSED ɈڂB
1998/ 1/ 3 SYNMɍđ^C}N
1998/ 1/15 炪FIN𑗐MꍇAFINɑ΂SEQ̊ԈACK
           Ă܂̂C
	   S_SYNSENTɎMACKԍ̌sBKvȂRST𑗐MB
	   S_SYNSENTRSTRST&ACKʂĈB
1998/ 1/16 f[^܂܂ȂACK𑗂ƂSEQ邱Ƃ̂C
	   ACK܂FINAFINƔFĂ̂C
1998/ 2/14 tcp_passiveopen,tcp_activeopenł̃|[g̎蓖
1998/ 2/19 API ŃG[Ԃ߂̏
1998/ 2/21 tcp_acriveopen zXgŐڑw肷邽߂̏
1998/ 3/ 7 dns_getipaddress̎dlύXɑΉ
1998/ 3/10 tcp_downstateB
	   SYNSENTłRSTM̏C(ڑۂFłȂ)
1998/ 3/20 RTTvZBOPT_MSS ԈĂ̂CB
1998/ 3/22 ^CX^vgȂRTTvZB
	   ^CX^vIvV̎舵p~B
1998/ 4/ 1 Slow start,Congestion avoidance,Zero window probe ̎
1998/ 4/ 6 indicate_intgp
1998/ 6/21 transitionstcp_closeĂяoĂȂ悤ɁB
	   (͂̃nhĂȂ肵Ȃ悤ɂj
	   FIN̍đBtcp_shutdownsɑMobt@Ƀf[^cĂ
	   ̃f[^MȂ̂Ci肾₵j
1998/10/ 7 get_data_and_send_ack()
	   FINWAIT1  FIN/ACK M FIN ݂̂Ă߁A
	   fȂBi肪 ACK 𑗐MĂĂǂȂ
	   jB
	   E_FINACK ǉBtrangition  S_FINWAIT1 ɂ E_FIN ̏
	   CB
1998/11/ 5 setrtt RTT,RTO ̌vZC
1999/ 4/28 receive_data,receive_fin ŃV[PXԍ̔r cmpseq g
	   Ȃ߁A0܂ԍ̔rsȂ̂C
1999/ 9/ 1 send_ack_nodata,send_finack p~BFIN̑Msend_ack ōsȂB
	   connectiontype  sndfinseq,flag.sndfinseq_availableǉ
	   (Mobt@ɖMf[^Ԃtcp_shutdown
	   FINseqԍsndnxt+1(Mf[^̖菬)ɂȂ
	   ܂AɎ󂯎Ă炦ȂMf[^oĂB
	   CB)
	   transition ɂ FINWAIT1,CLOSING,LASTACKFINɑ΂ACK
	   𔻒肷sndfinseqĝɕύXB
	   transition ɂ CLOSINGԂ̏ E_REXTIMEOUT ǉA
	   f[^FIN̍đsȂ悤ɂBE_ACKɑ΂鏈̈
	   ǉADuplicatedACKɑ΂čđAłȂACKɑ΂ĐV
	   f[^yFIN𑗐MB
1999/ 9/ 2 MEM̃Oo͂ύX
1999/ 9/18 send_ack f[^܂܂Ȃ ack pPbg RTT v̑ΏۂɂĂ
	   ̂C(99/9/1̕ύXɂ萶oO)
1999/10/16 S_ESTAB,S_CLOSING,S_FINWAIT1,S_FINWAIT2 ɂ E_RST 
	   receive_ack dupackešvZ@C
1999/11/ 7 send_rst őMpPbgseq/ackCB
	   M|[gȂpPbgRSTpPbg𑗂B

2000/ 9/ 1 Ethernet Ŏg悤 RHSIZE ύX
2000/ 9/23 ϐifs 폜BꎞI ifman_thisaddrgpB
2001/ 1/14 E_SENDACKǉB
	   tcp_recvɂāA󂫃EBhETCYMSSMSSȏɕω
	   ꍇAEBhETCYʒm̂ACK𑗐M
	   (́AEBhETCYMSS()ȉ̏ꍇAM
	   (RTTxH)ۗ邽߁AEBhEɋ󂫂łʒmȂ
	   ]xBɁAEthernet̏ꍇATEEN̎ł̓Nwł
	   f[^ԊuwʐMxɔׂĒ߂łANw̃f[^
	   sۂɑʂ̃f[^TCPɎMAEBhETCY
	   0߂ɂȂ₷B)
2001/ 1/23 initialseq()  gettimeg킸 timer_msecclockgB
2001/ 1/23 jǂݏo\recvBtcp_peekB
	   tcp_recv  recvĝɏB
2001/ 1/24 tcp_activeopen/passiveopenŃ|[gԍIɊ蓖ĂꍇA
	   ̔ԍ񂷂悤ɂ(newport())
	   tcp_activeopen/passiveopenŎ̃|[gԍAɎgpȂ
	   G[R[h ETCP_BADPORT(12)ԂB
2001/ 2/ 4 receive_ack: sndunaƓack󂯎ꍇɂsndwndXVB
	   (ackԍOƓ̏ꍇAwindowsTCY̕ύXA
	    M~Ă܂Ă̂CB)
	   check_zerowindowprobe()
	   ESTAB,FINWAIT1,LASTACK,CLOSEWAITԂōđ^C}^CAEgA
	   đׂf[^Ȃꍇ́AVKf[^̑M݂
	   (0 window probê)B
	   (ŌɑMpPbg̍đ^C}^CAEgOsndwnd=0
	   ƂȂAtcp_sendŃf[^𑗐MꍇA0 window probe s
	   B)

2001/ 2/27 send_synack  send_syn ɓB
2001/ 3/ 1 S_SYNSENTSYN̂ȂACK͖B
	   S_SYNSENTE_SYN̎Ađ^C}~ĂA~Ȃ悤
	   B
2001/ 3/ 3 S_SYNSENTłACK̑Msend_ackgpB
	   send_ack: f[^𔺂ȂACK̑M̏ꍇłđ^C}ċN
	   Ă̂CB(ϐuserextimergp)
	   S_SYNRCVDōđ^CAEg(SYN̍đ)ASYN,SYN&ACK̎M
2001/ 7/ 8 S_LASTACKRST̏ǉ
2001/10/11 S_CLOSING  TIMEOUTɑMFINACKackԍ1̂C
           (Mς݂FIÑV[PXԍƓԍack𑗂ĂB)
           (ESEMAILniftyɐڑpX[hԈĂꍇ
            ؒfEEÊ܂ܐɐi܂Ȃۂ͉PB
            肪FINɑ΂ACK𑗂ĂȂ߂ȂB)
2001/12/22 tcp_receiveŎMpPbgOɏo͂̂Ƃ߁B
2002/ 3/ 2 receive_data: L[vACupPbgɑ΂ACK𑗂悤ɕύX
*/

/*
	xsyn󂯎󓮃nh́Asyn̑MȊO
	v󂯕tȂȂoOH
	SYNSENTRSTׂ
*/
