#include <dos.h>	/* FP_SEG etc */
#include <alloc.h>	/* farmalloc etc */
#include <conio.h>	/* kbhit,getch */

#include <timer.h>
#include <log.h>
#include <tmem.h>
#include <ip.h>
#include "tcp.h"

#define TMEMBUFSIZE 0x0800

#define QSIZE 10
#define THISIP 0x01020304

/*------------*/
static IF if_ppp;
IF *ifs[IFS_SIZE]={&if_ppp};
/*------------*/


static void far *packet[QSIZE];
static uint packetlen[QSIZE];
static int packets=0;

BYTE phandle,ahandle,lhandle;


void tcp_receive(void far *rp, uint rlen, IDWORD fromip);
void far notice(BYTE handle, int kind, void far *vp);




void transmit(void)
{
	int i;
	int packets0;
	void far *packet0[QSIZE];
	uint packetlen0[QSIZE];

	log_put("[]Jn]");

	disable();
	for (i=0; i<packets; i++) {
		packet0[i]=packet[i];
		packetlen0[i]=packetlen[i];
	}
	packets0=packets;
	packets=0;
	enable();

	for (i=0; i<packets0; i++) {
		tcp_receive(packet0[i],packetlen0[i],THISIP);
	}

	log_put("[]I]");
}

static void transmitall(void)
{
	while (packets!=0 && !kbhit()) {
		transmit();
	}
}


void main(void)
{
	void far *tmembuf;
	int a;

	machine_ditect();

	if_ppp.if_addr=THISIP;

	tmembuf=farmalloc((long)TMEMBUFSIZE*16+16);
	if (tmembuf==NULL) return ;
	tmem_init(FP_SEG(tmembuf),TMEMBUFSIZE);

	log_init();
	tmem_disp();
	timer_init();

	tcp_init();

	{
		lhandle=tcp_passiveopen(20,notice);
		log_printf("[󓮐ڑ]nh:%d",lhandle);
		transmit();
	}


	{
		TCPPRM tcpprm;

		tcpprm.thisport=10;
		tcpprm.peerport=20;
		tcpprm.peerip=THISIP; /*0x01020304;*/
		tcpprm.notice=notice;
		tcpprm.rbuf=tmem_alloc(16);
		tcpprm.rbufsize=256;
		tcpprm.sbuf=tmem_alloc(16);
		tcpprm.sbufsize=256;
		ahandle=tcp_activeopen(&tcpprm);
		log_printf("[\ڑ]nh:%d",ahandle);
		transmit();
	}

	{
		static char data[]={0x01,0x02,0x03,0x04,0x05};
		uint a;

		transmitall();
		a=tcp_send(ahandle,data,sizeof data,1);
		log_printf("[M]%dbytes",a);
		/*transmitall();*/
	}

	for(;;) {
		transmitall();
		if (kbhit()) {getch(); break;}
	}

	{
		static char data[10];
		uint a;

		a=tcp_recv(phandle,data,10);
		log_printf("[M]%dbytes",a);
		log_putbinary(data,a);
	}

	{
		static char data[]={0x06,0x07,0x08,0x09};
		uint a;

		transmitall();
		a=tcp_send(phandle,data,sizeof data,1);
		log_printf("[M]%dbytes",a);
		/*transmitall();*/
	}

	for(;;) {
		transmitall();
		if (kbhit()) {getch(); break;}
	}

	{
		static char data[10];
		uint a;

		a=tcp_recv(ahandle,data,10);
		log_printf("[M]%dbytes",a);
		log_putbinary(data,a);
	}





	tcp_shutdown(ahandle);
	transmitall();
	tcp_shutdown(phandle);
	transmitall();
	tcp_shutdown(lhandle);
	transmitall();

	tcp_close(ahandle);
	tcp_close(phandle);
	tcp_close(lhandle);

	timer_stop();

	tmem_disp();

}


void far notice(BYTE handle, int kind, void far *vp)
{
	log_printf("[ʒm]handle=%d kind=%d",handle,kind);

	if (handle==lhandle && kind==TCP_WAITACCEPT) {
		TCPPRM tcpprm;

		tcpprm.notice=notice;
		tcpprm.rbuf=tmem_alloc(16);
		tcpprm.rbufsize=256;
		tcpprm.sbuf=tmem_alloc(16);
		tcpprm.sbufsize=256;
		phandle=tcp_accept(handle,&tcpprm);
		log_printf("[ڑ]nh:%d",phandle);
	}
}

#if 0
int ip_send(BYTE far *buf, uint len, IDWORD toip)
{
	log_printf("IP  : M %ubytes",len);
	log_putbinary(buf,len);
	packet[packets]=buf;
	packetlen[packets++]=len;
}
#else
void ip_output(BYTE far *buf, uint len)
{
	log_printf("IP  : M %ubytes",len);
	((IP far *)buf)->ip_src=THISIP;
	/*log_putbinary(buf,IPHLEN);*/
	buf+=IPHLEN;
	log_putbinary(buf,len);
	packet[packets]=buf;
	packetlen[packets++]=len;
}
#endif

/*
uint cksum(BYTE far *buf, uint len)
{
	return 0xffff;
}
*/
