;
;	^C}[(MC 146818)
;	for PC/AT
;
;	$Header: RTC.ASv  1.0  2008/04/19 11:11:32  Exp $
;

		INCLUDE	STDDEFS.INC
		INCLUDE TIMERDEV.INC

		INCLUDE	RTC.INC

		.186
		.MODEL	SMALL


;DISPREENTRY	EQU	1	;ē󋵂\



;I/O ܂
;
IOWait		MACRO
		PUSH	AX
		in      al,61h
		POP	AX
		ENDM



		.CODE

		;PUBLIC	RTC_DefaultConfig
		;PUBLIC	RTC_Init,RTC_Release,RTC_ReadyToRelease
		EXTRN	TIMER_Up:NEAR


;Config̃[hf[^̏lݒ
;@jFCX,SI,DI,ES
;@ӁF@픻ʂIĂ邱
;	 ̃[`͂P񂾂sł

RTC_DefaultConfig	PROC

		TEST	MachType,08h
		@IF Z, <RET>			; PC/AT

		RET

RTC_DefaultConfig	ENDP


;i荞݃xN^̃tbNji풓ɂP񂾂Ăяoj
;@́FDS
;@jFAX,BX,CX,DX,ES

_rtc_init	LABEL	PROC
RTC_Init	PROC

		;IR
		MOV	AL,RtcIR
		CMP	AL,15
		_IF AE
			MOV	AL,IR_DEFAULT
			MOV	RtcIR,AL
		_ENDIF

		;RTC荞݋֎~(荞݃Rg[)
		CALL	RTC_CLI

		;ϐȂǏ
		MOV	CS:DataSeg,DS

		;荞݃xN^
		MOV	AL,RtcINT
		MOV	AH,35h
		INT	21h
		MOV	WORD PTR OldVect[0],BX
		MOV	WORD PTR OldVect[2],ES

		PUSH	DS
		MOVSEG	DS,CS
		MOV	DX,OFFSET RTC_Int
		MOV	AH,25h
		INT	21h
		POP	DS

		;^C}[ݒ
		CALL	RTC_Reset

		RET

RTC_Init	ENDP




;荞݃xN^ɖ߂
;@́FDS
;@óF
;@jFAX,DX
_rtc_release	LABEL	PROC
RTC_Release	PROC

		CALL	RTC_CLI

		PUSH	DS
		MOV	AL,RtcINT
		LDS	DX,OldVect
		MOV	AH,25h
		INT	21h
		POP	DS

		RET

RTC_Release	ENDP

;݃xN^\
;@́FDS
;@óFAX=1..\ 0..s\
;@jFBX,DX,ES
RTC_ReadyToRelease	PROC

		MOV	AL,RtcINT
		MOV	AH,35h
		INT	21h

		CLR	AX
		CMP	BX,OFFSET RTC_Int
		_IF E
			MOV	BX,ES
			MOV	DX,CS
			CMP	BX,DX
			_IF E
				;\
				INC	AX
			_ENDIF
		_ENDIF

		RET

RTC_ReadyToRelease	ENDP



;荞ݎ̐ݒ
;@́FDS
;@jFAX,BX,CX,DX,ES

RTC_Reset	PROC

				;ݒl=Interval(sec)/(1/TimerFreq(Hz))(sec)
				;      =Interval(sec)*TimerFreq(Hz)
				;      =Interval(1/100sec)*TimerFreq(100Hz)

				; periodic interrupt rate
				; TimerRate	= 0110b  :  0.9765625 ms
				;		= 0111b  :  1.953125 ms
				;		= 1000b  :  3.90625 ms
				;		= 1001b  :  7.8125 ms

;		CMP	RtcUnitLevel,1

;		PUSHF
		CLI

		MOV	DX,TimerRSlct
		MOV	AL,8Ah
		OUT	DX,AL			; RTC Register A request
		IOWait
		MOV	DX,TimerDPort
		IN	AL,DX			; RTC Register A status
		AND	AL,0F0h
		OR	AX,TimerRate		; 0.9765625 ms
		OUT	DX,AL			; Periodic Interrupt disable
		IOWait

		MOV	DX,TimerRSlct
		MOV	AL,8Bh
		OUT	DX,AL			; RTC Register B request
		IOWait
		MOV	DX,TimerDPort
		IN	AL,DX			; RTC Register B status
;		AND	AL,0Fh
		AND	AL,07h
		OR	AL,40h
		OUT	DX,AL			; Periodic Interrupt disable
		IOWait

		MOV	DX,TimerRSlct		; RTC Register C request
		MOV	AL,8Ch
		OUT	DX,AL
		IOWait
		MOV	DX,TimerDPort		; RTC Register C clear
		IN	AL,DX

		MOV	CS:Busy,OFF

;		POPF


		;RS荞݋(荞݃Rg[)

;		MOV	DX,MasICU1
		MOV	CL,RtcIR
;		CMP	CL,8
;		JB	#Slv_Skip
		SUB	CL,8
		MOV	DX,SlvICU1
;#Slv_Skip:
		MOV	AH,1
		SHL	AH,CL
		NOT	AH
		IN	AL,DX
		AND	AL,AH
		IOWait
		OUT	DX,AL

		STI

		RET

RTC_Reset	ENDP


;݊ԊuԂ
;  óFAX=݊Ԋu(msec)

RTC_Interval	PROC

;		CMP	RtcUnitLevel,1
		MOV	AX,1
		RET

RTC_Interval	ENDP


;RTC荞݋֎~
;@́FDS
;@jFAX,CL,DX
;@ӁFRtcIR^Ă邱

RTC_CLI		PROC

		MOV	DX,TimerRSlct
		MOV	AL,8Bh
		OUT	DX,AL			; RTC Register B request
		IOWait
		MOV	DX,TimerDPort
		IN	AL,DX			; RTC Register B status
		AND	AL,0Fh
		OUT	DX,AL			; Periodic Interrupt disable

;		MOV	DX,MasICU1
		MOV	CL,RtcIR
;		CMP	CL,8
;		JB	#Slv_Skip
		SUB	CL,8
		MOV	DX,SlvICU1
;#Slv_Skip:
		MOV	AH,1
		SHL	AH,CL
		IN	AL,DX
		OR	AL,AH
		OUT	DX,AL

		RET

RTC_CLI		ENDP



;荞݃[`
;@⑫Fē΍􂸂

RTC_Int		PROC

		PUSH	DS

		MOV	DS,CS:DataSeg

		PUSH	AX
		PUSH	DX

		MOV	DX,TimerRSlct		; RTC Register C request
		MOV	AL,8Ch
		OUT	DX,AL
		IOWait
		MOV	DX,TimerDPort		; RTC Register C clear
		IN	AL,DX

		MOV	DX,SlvICU0
		MOV	AL,20h
		OUT	DX,AL			; EOI for Slave ICU
		IOWait
		MOV	AL,0Bh
		OUT	DX,AL			; ICU2 InService status req
		IOWait
		IN	AL,DX			; ICU2 InService Status
		CMP	AL,0
		JNE	@f
;		JNE	#SKIP_MasEOI

		MOV	DX,MasICU0
		MOV	AL,20h
		OUT	DX,AL			; EOI for Master ICU
@@:
;#SKIP_MasEOI:

		CMP	CS:Busy,OFF
		_IF E
			MOV	CS:Busy,ON
			CALL	TIMER_Up	;AX,DX͔j\
			MOV	CS:Busy,OFF
IFDEF DISPREENTRY
		_ELSE
			EXTN	INDICATE

			INC	CS:TestInd
			MOV	DL,CS:TestInd
			MOV	DH,38
			CALL	INDICATE
ENDIF
		_ENDIF

		POP	DX
		POP	AX

		POP	DS

		IRET

RTC_Int		ENDP




DataSeg		DW ?
Busy		DB ?

IFDEF DISPREENTRY
TestInd		DB '0'
ENDIF


		.DATA

		PUBLIC	TimerDev_FunctionTable
		EXTRN	MachType:BYTE

		EXTRN	RTC_WReg:Word,MasICU0:Word,MasICU1:Word,SlvICU0:Word,SlvICU1:Word
		EXTRN	TimerRSlct:Word,TimerDPort:Word,TimerRate:Word,IOWaitTime:Word
		EXTRN	RtcIR:Byte,RtcINT:Byte,RtcUnitLevel:Byte


;^C}[foCXhCo@֐ꗗ
;
TimerDev_FunctionTable TimerDev_FunctionTableType <RTC_DefaultConfig,RTC_Init,RTC_Release,RTC_ReadyToRelease,RTC_Interval>



		.DATA?

OldVect		DD ?		;RTC 荞݃xN^̌̒l



;2007/10/ 5 J
;2008/ 4/19 ̏C

		end
